#ifndef INCLUDED_GAMELIB_PSEUDOXML_ATTRIBUTE_H
#define INCLUDED_GAMELIB_PSEUDOXML_ATTRIBUTE_H

namespace GameLib{
namespace PseudoXml{

class Attribute{
public:
	///NULLI[łȂȂǂăTCY𖾎Iɗ^B-1Ώɑ̂ŁAЕ^邱Ƃł
	void set( const char* name, int nameSize, const char* value, int valueSize );
	void set( const char* name, const char* value );
	void set( const char* name, int value ); //intl
	void set( const char* name, float value ); //floatl
	void set( const char* name, double value ); //doublel
	void set( const char* name, const int* values, int number ); //intz
	void set( const char* name, const float* values, int number ); //floatz
	void set( const char* name, const double* values, int number ); //doublez
	const char* value() const;
	const char* name() const;
	///s0ԂAƂ0Ă̂Ƃ͋ʂȂB
	int getIntValue() const;
	///s0.fԂAƂ0.fĂ̂Ƃ͋ʂȂB
	float getFloatValue() const;
	///s0.0ԂAƂ0.0Ă̂Ƃ͋ʂȂB
	double getDoubleValue() const;
	///߂l͎ۂɓǂ߂vf
	int getIntValues( int* out, int number ) const;
	///߂l͎ۂɓǂ߂vf
	int getFloatValues( float* out, int number ) const;
	///߂l͎ۂɓǂ߂vf
	int getDoubleValues( double* out, int number ) const;

	//ȉ[U͈ӎȂĂ
	Attribute();
	~Attribute();
	Attribute( const Attribute& );
	operator void*() const;
	Attribute& operator=( const Attribute& );
	void release();
	bool operator==( const Attribute& ) const;
	bool operator!=( const Attribute& ) const;

	class Impl;
private:
	friend class Element;
	friend class Tag;

	explicit Attribute( Impl* );
	Impl* mImpl;
};

//const
class ConstAttribute{
public:
	const char* value() const;
	const char* name() const;
	///s0ԂAƂ0Ă̂Ƃ͋ʂȂB
	int getIntValue() const;
	///s0.fԂAƂ0.fĂ̂Ƃ͋ʂȂB
	float getFloatValue() const;
	///s0.0ԂAƂ0.0Ă̂Ƃ͋ʂȂB
	double getDoubleValue() const;
	///߂l͎ۂɓǂ߂vf
	int getIntValues( int* out, int number ) const;
	///߂l͎ۂɓǂ߂vf
	int getFloatValues( float* out, int number ) const;
	///߂l͎ۂɓǂ߂vf
	int getDoubleValues( double* out, int number ) const;

	//ȉ[U͈ӎȂĂ
	ConstAttribute();
	ConstAttribute( const Attribute& );
	~ConstAttribute();
	operator void*() const;
	ConstAttribute& operator=( const Attribute& );
	void release();
	bool operator==( const Attribute& ) const;
	bool operator!=( const Attribute& ) const;
private:
	Attribute mBase;
};


} //namespace PseudoXml
} //namespace GameLib

#endif
