#ifndef INCLUDED_GAMELIB_HASTSETIMPL_H
#define INCLUDED_GAMELIB_HASHSETIMPL_H

#include "GameLib/GameLib.h"
#include "GameLib/Base/HashSet.h"
#include "GameLib/Base/PrimeNumber.h"

/*
<>
YmCapacity + i (0<=i<mTableSize)gĂA̓_~[m[hłB
mNodes[ mCapacity + i ].mNextmNodes[ mCapacity + i + 1 ]ĂB
*/

namespace GameLib{

//擪ƖʈȂ悤ɂƍHvĂB
template< class T, class H > inline HashSet< T, H >::HashSet() : 
mNexts( 0 ),
mValues( 0 ),
mCapacity( 0 ),
mSize( 0 ),
mTableSize( 0 ){
	ASSERT( sizeof( T ) != 0 ); //肦ȂˁH
}

//擪ƖʈȂ悤ɂƍHvĂB
template< class T, class H > inline HashSet< T ,H >::HashSet( int capacity, int tableSize ) : 
mNexts( 0 ),
mValues( 0 ),
mCapacity( 0 ),
mSize( 0 ),
mTableSize( 0 ){
	ASSERT( sizeof( T ) != 0 ); //肦ȂˁH
	setCapacity( capacity, tableSize );
}

template< class T, class H > inline HashSet< T, H >::~HashSet(){
	if ( mNexts ){
		int pos = mNexts[ mCapacity ];
		while ( pos < mCapacity + mTableSize ){ //m[h
			if ( pos < mCapacity ){
				mValues[ pos ].~T();
			}
			pos = mNexts[ pos ];
		}
		OPERATOR_DELETE( mValues ); //delete
		SAFE_DELETE_ARRAY( mNexts );
	}
}

template< class T, class H > inline void HashSet< T, H >::setCapacity( int capacity, int tableSize ){
	ASSERT( mSize == 0 && "NOT EMPTY! call clear()." );
	//܂NA
	if ( mCapacity > 0 ){
		mEmptyStack.clear();
		clear();
		OPERATOR_DELETE( mValues ); //delete
		SAFE_DELETE_ARRAY( mNexts );
	}
	//Ċm
	mCapacity = capacity;
	if ( capacity <= 0 ){ //0TCY
		return;
	}	
	if ( tableSize == 0 ){ //capacityȏ̑fݒ
		tableSize = capacity;
	}
	tableSize = PrimeNumber::next( tableSize );
	if ( tableSize < 3 ){
		tableSize = 3; //Œ3
	}else if ( tableSize > 0x10000 ){ //65536ȏ͋Ȃ
		tableSize = 65521; //65536ȉő̑f
	}
	mTableSize = tableSize;
	//z e[uTCY_~[𑫂Ƃɒ
	mNexts = NEW int[ mCapacity + mTableSize ];
	//lzmہBRXgN^svȂ̂Őnew
	mValues = static_cast< T* >( OPERATOR_NEW( sizeof( T ) * mCapacity ) );
	//󂫔ԍX^bN
	mEmptyStack.setCapacity( mCapacity );
	for ( int i = 0; i < mCapacity; ++i ){
		mEmptyStack.push( i ); //󂫔ԍXgɋl߂Ă
	}
	//mCapacity+0mCapacity+mTableSize-1Ԃ̓_~[vfBe̐擪̑OɈʒuB
	for ( int i = 0; i < mTableSize; ++i ){
		mNexts[ mCapacity + i ] = mCapacity + i + 1;
	}
}

template< class T, class H > inline int HashSet< T, H >::capacity() const {
	return mCapacity;
}

template< class T, class H > inline int HashSet< T, H >::add( const T& v ){
	ASSERT( mSize < mCapacity );
	//nbV֐Zo
	int h = H().value( v, mTableSize );
	//
	int p = mNexts[ mCapacity + h ];
	while ( p < mCapacity ){
		if ( H().isEqual( mValues[ p ], v ) ){
			break;
		}
		p = mNexts[ p ];
	}
	if ( p >= mCapacity ){ //Ȃ瑫
		//󂫏ꏊ擾
		int newPos;
		mEmptyStack.pop( &newPos );
		//e[u擪ɑ}
		int head = mCapacity + h;
		mNexts[ newPos ] = mNexts[ head ]; //_~[̎Zbg
		new ( &mValues[ newPos ] ) T( v ); //Rs[RXgN^Ăяo
		mNexts[ head ] = newPos; //ÕNVm[hɂȂ
		++mSize;
		return newPos;
	}else{
		return mCapacity + mTableSize;
	}
}

template< class T, class H > inline int HashSet< T, H >::find( const T& v ){
	int h = H().value( v, mTableSize );

	int p = mNexts[ mCapacity + h ];
	while ( p < mCapacity ){
		if ( H().isEqual( mValues[ p ], v ) ){
			return p;
		}
		p = mNexts[ p ];
	}
	return mCapacity + mTableSize;
}

template< class T, class H > inline bool HashSet< T, H >::isIn( const T& v ) const {
	int h = H().value( v, mTableSize );

	int p = mNexts[ mCapacity + h ];
	while ( p < mCapacity ){
		if ( H().isEqual( mValues[ p ], v ) ){
			return true;
		}
		p = mNexts[ p ];
	}
	return false;
}

template< class T, class H > inline bool HashSet< T, H >::remove( int position ){
	//p̏ꏊɂvf̃nbVlnbVlvZȂŒm肽B
	//ŁAUwbhe[uɏo܂ŃCe[^i߂ČB
	int h = position;
	while ( h < mCapacity ){
		h = mNexts[ h ];
	}
	//U͈͊OɏoBmCapacityƎ̃nbVl킩B
	h -= mCapacity;
	//-1΂̃nbVl
	h -= 1;
	//nbVl킩̂ŁAe[u̐擪HĂpB
	int prev = mCapacity + h; //wbh
	int p = mNexts[ prev ];
	while ( p < mCapacity ){
		if ( p == position ){ //BB
			mNexts[ prev ] = mNexts[ p ]; //Ȃς
			mValues[ p ].~T(); //fXgNg
			mEmptyStack.push( p ); //󂫃X^bNɃvbV
			--mSize;
			return true;
		}
		prev = p;
		p = mNexts[ p ];
	}
	return false;
}

template< class T, class H > inline const T* HashSet< T, H >::value( int p ) const {
	return &mValues[ p ];
}

template< class T, class H > inline void HashSet< T, H >::clear(){
	//fXgNgĉ
	int prev = mCapacity; //wbh
	int p = mNexts[ mCapacity ]; //_~[wbh
	while ( p < mCapacity + mTableSize ){  //mCapacity + mTableSize݂͑ȂB܂ł̓_~[Ƃđ݂B
		if ( p < mCapacity ){
			mNexts[ prev ] = mNexts[ p ]; //Ȃς
			mValues[ p ].~T();
			mEmptyStack.push( p ); //󂫃X^bNɃvbV
		}
		prev = p;
		p = mNexts[ p ];
	}
	mSize = 0;
}

template< class T, class H > inline int HashSet< T, H >::next( int p ) const {
	ASSERT( p >= 0 );
	while ( p < mCapacity + mTableSize ){
		p = mNexts[ p ];
		if ( p < mCapacity ){ //_~[m[hȊOԂ
			return p;
		}
	}
	return p;
}

template< class T, class H > inline int HashSet< T, H >::first() const {
	int p = mCapacity; //ŏ̃_~[
	while ( p < mCapacity + mTableSize ){
		p = mNexts[ p ];
		if ( p < mCapacity ){ //_~[m[hȊOԂ
			return p;
		}
	}
	return mCapacity + mTableSize;
}

template< class T, class H > inline bool HashSet< T, H >::isEnd( int position ) const {
	return ( position == mCapacity + mTableSize );
}

template< class T, class H > inline void HashSet< T, H >::copyTo( T* a ) const {
	int p = mNexts[ mCapacity ];
	int idx = 0;
	while ( p != mCapacity + mTableSize ){
		if ( p < mCapacity ){
			a[ idx ] = mValues[ p ];
			++idx;
		}
		p = mNexts[ p ];
	}
}

template< class T, class H > inline void HashSet< T, H >::copyTo( Array< T >* a ) const {
	a->setSize( mSize );
	if ( mSize > 0 ){
		copyTo( &( ( *a )[ 0 ] ) );
	}
}


template< class T, class H > inline int HashSet< T, H >::size() const {
	return mSize;
}

} //namespace GameLib

#endif
