#ifndef INCLUDED_GAMELIB_LISTIMPL_H
#define INCLUDED_GAMELIB_LISTIMPL_H

#include "GameLib/GameLib.h"
#include "GameLib/Base/List.h"

/*
<>
YmCapacitygĂA̓_~[m[hłB
mNodes[ mCapacity ].mNext͐擪A
mNodes[ mCapacity ].mPrev͖ɂȂĂB
*/

namespace GameLib{

//擪ƖʈȂ悤ɂƍHvĂB
template< class T > inline List< T >::List() : 
mValues( 0 ),
mNodes( 0 ),
mCapacity( 0 ),
mSize( 0 ){
}

//擪ƖʈȂ悤ɂƍHvĂB
template< class T > inline List< T >::List( int capacity ) : 
mValues( 0 ),
mNodes( 0 ),
mCapacity( 0 ),
mSize( 0 ){
	setCapacity( capacity );
}

template< class T > inline List< T >::~List(){
	if ( mNodes ){
		//P̃fXgNg
		int pos = mNodes[ mCapacity ].mNext;
		while ( pos < mCapacity ){ //_~[łȂ
			mValues[ pos ].~T(); //fXgNg
			pos = mNodes[ pos ].mNext;
		}
		OPERATOR_DELETE( mValues ); //delete
		SAFE_DELETE_ARRAY( mNodes );
	}
}

template< class T > inline void List< T >::setCapacity( int capacity ){
	ASSERT( mSize == 0 && "NOT EMPTY! call clear()." );
	//܂NA
	if ( mCapacity > 0 ){
		mEmptyStack.clear();
		clear();
		OPERATOR_DELETE( mValues ); //delete
		SAFE_DELETE_ARRAY( mNodes );
	}
	//Ċm
	mCapacity = capacity;
	if ( capacity <= 0 ){ //0TCY
		return;
	}
	mNodes = NEW Node[ mCapacity + 1 ];
	//m[hzmہBRXgN^svȂ̂malloc
	mValues = static_cast< T* >( OPERATOR_NEW( sizeof( T ) * mCapacity ) );
	//󂫔ԍX^bN
	mEmptyStack.setCapacity( mCapacity );
	for ( int i = 0; i < mCapacity; ++i ){
		mEmptyStack.push( i ); //󂫔ԍXgɋl߂Ă
	}
	//mCapacityԂ͓ʁBŏ̗vf̑OŌ̗vf̌ɂ_~[vf
	mNodes[ mCapacity ].mNext = mNodes[ mCapacity ].mPrev = mCapacity;
}

template< class T > inline int List< T >::capacity() const {
	return mCapacity;
}

template< class T > inline int List< T >::addAfter( int position, const T& v ){
	ASSERT( position >= 0 && position <= mCapacity ); //CR[͂肤
	//󂫏ꏊ擾
	int newPos;
	mEmptyStack.pop( &newPos );
	//ꏊaddPosition
	Node* e = &mNodes[ newPos ];
	//w̓zo
	Node* cur = &mNodes[ position ];
	//̓zo
	Node* next = &mNodes[ cur->mNext ];
	//li[(Rs[RXgN^Ăяo)
	new ( &mValues[ newPos ] ) T( v );
	e->mPrev = position; //wꏊO
	e->mNext = cur->mNext; //w̎̂
	//w̓z͑OɂȂ̂ŁA͑zɂȂ
	cur->mNext = newPos;
	//w̎̓z͌ɂȂ̂ŁAO͑zɂȂ
	next->mPrev = newPos;
	++mSize;

	return newPos;
}

template< class T > inline int List< T >::addBefore( int position, const T& v ){
	ASSERT( position >= 0 && position <= mCapacity ); //CR[͂肤
	//󂫏ꏊ擾
	int newPos;
	mEmptyStack.pop( &newPos );
	//ꏊaddPosition
	Node* e = &mNodes[ newPos ];
	//w̓zo
	Node* cur = &mNodes[ position ];
	//O̓zo
	Node* prev = &mNodes[ cur->mPrev ];
	//li[(RXgN^Ăяo)
	new ( &mValues[ newPos ] ) T( v );
	e->mPrev = cur->mPrev; //w̑O̓zO
	e->mNext = position; //w̓z
	//w̓z͌ɂȂ̂ŁAO͑zɂȂ
	cur->mPrev = newPos;
	//w̑O̓z͑OɂȂ̂ŁA͑zɂȂ
	prev->mNext = newPos;
	++mSize;

	return newPos;
}

template< class T > inline int List< T >::addHead( const T& v ){
	return addAfter( mCapacity, v ); //_~[vf̂łB
}

template< class T > inline int List< T >::addTail( const T& v ){
	return addBefore( mCapacity, v ); //_~[vf̂ł
}

template< class T > inline void List< T >::remove( int position ){
	ASSERT( mSize > 0 );
	//w̓z
	Node* cur = &mNodes[ position ];
	//
	Node* next = &mNodes[ cur->mNext ];
	//O
	Node* prev = &mNodes[ cur->mPrev ];
	//O̓z̎AɂB
	prev->mNext = cur->mNext;
	//̓z̑OAOɂB
	next->mPrev = cur->mPrev;
	//fXgN^𖾎IɌĂ
	mValues[ position ].~T();
	//TCY
	--mSize;
	//󂫃X^bNɃvbV
	mEmptyStack.push( position );
}

template< class T > inline void List< T >::removeHead(){ //͂قƂǕʖB
	int pos = mNodes[ mCapacity ].mNext;
	if ( pos < mCapacity ){ //_~[͏Ȃ
		remove( pos  );
	}
}

template< class T > inline void List< T >::removeTail(){ //͂قƂǕʖB
	int pos = mNodes[ mCapacity ].mPrev;
	if ( pos < mCapacity ){ //_~[͏Ȃ
		remove( pos  );
	}
}

template< class T> inline void List< T >::clear(){
	int pos = mNodes[ mCapacity ].mNext;
	while ( pos < mCapacity ){ //_~[łȂ
		mValues[ pos ].~T(); //fXgNg
		pos = mNodes[ pos ].mNext;
	}
	mNodes[ mCapacity ].mNext = mCapacity;
	mNodes[ mCapacity ].mPrev = mCapacity;
	mSize = 0;
	//X^bNl߂Ȃ
	mEmptyStack.clear();
	for ( int i = 0; i < mCapacity; ++i ){
		mEmptyStack.push( i ); //󂫔ԍXgɋl߂Ă
	}
}

template< class T > inline const T* List< T >::value( int position ) const {
	ASSERT( position >= 0 && position < mCapacity );
	return &mValues[ position ];
}

template< class T > inline T* List< T >::value( int position ){
	ASSERT( position >= 0 && position < mCapacity );
	return &mValues[ position ];
}

template< class T > inline int List< T >::next( int position ) const {
	ASSERT( position >= 0 && position <= mCapacity ); //_~[̂<=
	return mNodes[ position ].mNext;
}

template< class T > inline int List< T >::previous( int position ) const {
	ASSERT( position >= 0 && position <= mCapacity );//_~[̂<=
	return mNodes[ position ].mPrev;
}

template< class T > inline int List< T >::first() const {
	return next( mCapacity );
}

template< class T > inline int List< T >::last() const {
	return getPrev( mCapacity );
}

template< class T > inline bool List< T >::isEnd( int position ) const {
	return ( position == mCapacity );
}

template< class T > inline void List< T >::copyTo( T* a ) const {
	int p = mNodes[ mCapacity ].mNext;
	int idx = 0;
	while ( p != mCapacity ){
		a[ idx ] = mValues[ p ];;
		++idx;
		p = mNodes[ p ].mNext;
	}
}

template< class T > inline void List< T >::copyTo( Array< T >* a ) const {
	a->setSize( mSize );
	if ( mSize > 0 ){
		copyTo( &( ( *a )[ 0 ] ) );
	}
}
		




} //namespace GameLib

#endif
