#ifndef INCLUDED_GAMELIB_GRAPHICS_TEXTURE_H
#define INCLUDED_GAMELIB_GRAPHICS_TEXTURE_H

namespace GameLib{
namespace PseudoXml{
	class ConstElement;
}
namespace Graphics{

class Texture{
public:
	///Gg琶Bpath΃t@C̑OɒǉB
	static Texture create( PseudoXml::ConstElement, const char* path = 0 );
	//̃eNX`
	static Texture create( int width, int height, bool createMipChain );
	///TGADDSBgqŔʂB
	static Texture create( const char* filename );
	///TGADDS̒gnBŏDDSƏĂDDSƂ݂ȂAȊOTGAƂ݂ȂB
	static Texture create( const char* fileData, int fileSize );
	///OQbg(jZxml烍[h΂̖OB͋B)
	const char* name() const;

	///[hIH(constȂ͓̂ŏ邩)
	bool isReady(); 
	///ǂݍ݃G[NĂȂH
	bool isError() const;

	///݊֐
	void lock( unsigned** address, int* pitch, int mipLevel = 0 );
	///݊֐
	void lock( 
		unsigned** address, 
		int* pitch, 
		int x,
		int y,
		int width,
		int height,
		int mipLevel = 0 );
	void unlock( unsigned** address, int mipLevel = 0 );
	//擾
	int width() const;
	int height() const;
	///2pɒǑ̕
	int originalWidth() const;
	///2pɒǑ̍
	int originalHeight() const;
	int mipmapNumber() const;
	///t@CɏoBs̓`FbNȂBfoOpB
	void write( const char* filename );

	//ȉ[U͈ӎȂ֐Q
	Texture();
	Texture( const Texture& );
	~Texture();
	operator void*() const;
	Texture& operator=( const Texture& );
	void release();
	bool operator==( const Texture& ) const;
	bool operator!=( const Texture& ) const;
	bool operator<( const Texture& ) const;

	class Impl;
	Texture( const Impl* );
private:
	friend class Manager;
	Impl* mImpl;
};

} //namespace Graphics
} //namespace GameLib

#endif
