#ifndef INCLUDED_GAMELIB_PSEUDOXML_DOCUMENT_H
#define INCLUDED_GAMELIB_PSEUDOXML_DOCUMENT_H

#include <string>

namespace GameLib{
template< class T > class Array;
namespace PseudoXml{
using namespace std;

class Element;
class ConstElement;

///t@CANZX@\jZxmlNX
class Document{
public:
	///ݗpɋŐ
	static Document create();
	///t@CRXgNg(vFileIO)
	static Document create( const char* filename );
	///[hςݕ񂩂RXgNg
	static Document create( const char* data, int size );
	///ElementQbg
	Element root();
	///ElementQbg
	ConstElement root() const; 
	///[hς݂ۂ
	bool isReady();
	///ǂݍݒG[
	bool isError() const;
	///jZxmleLXg𐶐
	void convertToString( string* out ) const;
	///jZxmloCi𐶐
	void convertToBinary( Array< char >* out ) const;
	///jZxmlt@C𐶐(vFileIO)
	void write( const char* filename, bool isBinary = false ) const;
	///q̐Qbg
	int childNumber() const;
	///qQbg
	Element child( int i );
	///qQbg
	ConstElement child( int i ) const;

	//ȉӎȂĂ
	Document();
	Document( const Document& );
	~Document();
	operator void*() const;
	Document& operator=( const Document& );
	void release();
	bool operator==( const Document& ) const;
	bool operator!=( const Document& ) const;

	class Impl;
private:
	Impl* mImpl;
};

//const
class ConstDocument{
public:
	///ElementQbg
	ConstElement root() const; 
	///ǂݍݒG[
	bool isError() const;
	///jZxmleLXg𐶐
	void convertToString( string* out ) const;
	///jZxmloCi𐶐
	void convertToBinary( Array< char >* out ) const;
	///jZxmlt@C𐶐(vFileIO)
	void write( const char* filename, bool isBinary = false ) const;
	///q̐Qbg
	int childNumber() const;
	///qQbg
	ConstElement child( int i ) const;

	//ȉmȂĂ
	ConstDocument();
	ConstDocument( const Document& );
	~ConstDocument();
	ConstDocument& operator=( const Document& );
	void release();
	operator void*() const;
	bool operator==( const Document& ) const;
	bool operator!=( const Document& ) const;
private:
	Document mBase;
};

} //namespace PseudoXml
} //namespace GameLib

#endif
