#include "GameLib/Framework.h"
using namespace GameLib;

#include <fstream>
using namespace std;

//֐vg^Cv
void readFile( char** buffer, int* size, const char* filename );
void mainLoop();


//񎟌zNX
//ev[gɂȂ݂͂邾낤HȂΊbł׋ĂB
//̃NX錾̒łTƂNX邩̂悤ɈA
//gɂT̂ƂintƂboolƂĎgB
template< class T > class Array2D{
public:
	Array2D() : mArray( 0 ){}
	~Array2D(){
		delete[] mArray;
		mArray = 0;  //|C^0̂̓NZɂ悤B
	}
	void setSize( int size0, int size1 ){
		mSize0 = size0;
		mSize1 = size1;
		mArray = new T[ size0 * size1 ];
	}
	T& operator()( int index0, int index1 ){
		return mArray[ index1 * mSize0 + index0 ];
	}
	const T& operator()( int index0, int index1 ) const {
		return mArray[ index1 * mSize0 + index0 ];
	}
private:
	T* mArray;
	int mSize0;
	int mSize1;
};

//ԃNX
class State{
public:
	State( const char* stageData, int size );
	void update( char input );
	void draw() const;
	bool hasCleared() const;
private:
	enum Object{
		OBJ_SPACE,
		OBJ_WALL,
		OBJ_BLOCK,
		OBJ_MAN,

		OBJ_UNKNOWN,
	};
	void setSize( const char* stageData, int size );
	//}X`֐
	static void drawCell( int x, int y, unsigned color );

	int mWidth;
	int mHeight;
	Array2D< Object > mObjects;
	Array2D< bool > mGoalFlags;
};

//O[oϐ
State* gState = 0;

//[U֐BgmainLoop()Ɋۓ
namespace GameLib{
	void Framework::update(){
		mainLoop();
	}
}

void mainLoop(){
	//ŏ̃t[͏Bŏ̏Ԃ`悵ďIB
	if ( !gState ){ 
		const char* filename = "stageData.txt";
		char* stageData;
		int fileSize;
		readFile( &stageData, &fileSize, filename );
		if ( !stageData ){
			cout << "stage file could not be read." << endl;
			return;
		}
		gState = new State( stageData, fileSize );
		//n
		delete[] stageData;
		stageData = 0;
		//`
		gState->draw();
		return; //̂܂܏I
	}
	bool cleared = false;
	//C[v
	//NA`FbN
	if ( gState->hasCleared() ){
		cleared = true;
	}
	//͎擾
	cout << "a:left s:right w:up z:down. command?" << endl; //
	char input;
	cin >> input;
	//XV
	gState->update( input );
	//`
	gState->draw();

	if ( cleared ){
		//j̃bZ[W
		cout << "Congratulation! you win." << endl;
		delete gState;
		gState = 0;
	}
	//I
	if ( input == 'q' ){
		Framework::instance().requestEnd();
	}
	//~{^ĂH
	if ( Framework::instance().isEndRequested() ){
		if ( gState ){
			delete gState;
			gState = 0;
		}
		return;
	}
}

//---------------------ȉ֐`------------------------------------------

void readFile( char** buffer, int* size, const char* filename ){
	ifstream in( filename, ifstream::binary );
	if ( !in ){
		*buffer = 0;
		*size = 0;
	}else{
		in.seekg( 0, ifstream::end );
		*size = static_cast< int >( in.tellg() );
		in.seekg( 0, ifstream::beg );
		*buffer = new char[ *size ];
		in.read( *buffer, *size );
	}
}

State::State( const char* stageData, int size ){	
	//TCY
	setSize( stageData, size );
	//zm
	mObjects.setSize( mWidth, mHeight );
	mGoalFlags.setSize( mWidth, mHeight );
	//lŖ߂Ƃ
	for ( int y = 0; y < mHeight; ++y ){
		for ( int x = 0; x < mWidth; ++x ){
			mObjects( x, y ) = OBJ_WALL; //܂͕
			mGoalFlags( x, y ) = false; //S[Ȃ
		}
	}
	int x = 0;
	int y = 0;
	for ( int i = 0; i < size; ++i ){
		Object t;
		bool goalFlag = false;
		switch ( stageData[ i ] ){
			case '#': t = OBJ_WALL; break;
			case ' ': t = OBJ_SPACE; break;
			case 'o': t = OBJ_BLOCK; break;
			case 'O': t = OBJ_BLOCK; goalFlag = true; break;
			case '.': t = OBJ_SPACE; goalFlag = true; break;
			case 'p': t = OBJ_MAN; break;
			case 'P': t = OBJ_MAN; goalFlag = true; break;
			case '\n': x = 0; ++y; t = OBJ_UNKNOWN; break; //s
			default: t = OBJ_UNKNOWN; break;
		}
		if ( t != OBJ_UNKNOWN ){ //mȂȂ疳̂łif
			mObjects( x, y ) = t; //
			mGoalFlags( x, y ) = goalFlag; //S[
			++x;
		}
	}
}

void State::setSize( const char* stageData, int size ){
	mWidth = mHeight = 0; //
	//݈ʒu
	int x = 0;
	int y = 0;
	for ( int i = 0; i < size; ++i ){
		switch ( stageData[ i ] ){
			case '#': case ' ': case 'o': case 'O':
			case '.': case 'p': case 'P':
				++x;
				break;
			case '\n': 
				++y;
				//őlXV
				mWidth = max( mWidth, x );
				mHeight = max( mHeight, y );
				x = 0; 
				break;
		}
	}
}

void State::draw() const {
	for ( int y = 0; y < mHeight; ++y ){
		for ( int x = 0; x < mWidth; ++x ){
			Object o = mObjects( x, y );
			bool goalFlag = mGoalFlags( x, y );
			unsigned color = 0;
			if ( goalFlag ){
				switch ( o ){
					case OBJ_SPACE: cout << '.'; color = 0x0000ff; break;
					case OBJ_WALL: cout << '#'; color = 0xffffff; break;
					case OBJ_BLOCK: cout << 'O'; color = 0xff00ff; break;
					case OBJ_MAN: cout << 'P'; color = 0x00ffff; break;
				}
			}else{
				switch ( o ){
					case OBJ_SPACE: cout << ' '; color = 0x000000; break;
					case OBJ_WALL: cout << '#'; color = 0xffffff; break;
					case OBJ_BLOCK: cout << 'o'; color = 0xff0000; break;
					case OBJ_MAN: cout << 'p'; color = 0x00ff00; break;
				}
			}
			drawCell( x, y, color );
		}
		cout << endl;
	}
}

void State::drawCell( int x, int y, unsigned color ){
	unsigned* vram = Framework::instance().videoMemory();
	unsigned windowWidth = Framework::instance().width();
	for ( int i = 0; i < 16; ++i ){
		for ( int j = 0; j < 16; ++j ){
			vram[ (y*16+i) * windowWidth + (x*16+j) ] = color;
		}
	}
}

void State::update( char input ){
	//ړɕϊ
	int dx = 0;
	int dy = 0;
	switch ( input ){
		case 'a': dx = -1; break; //
		case 's': dx = 1; break; //E
		case 'w': dy = -1; break; //BY͉vX
		case 'z': dy = 1; break; //B
	}
	//ZϐB
	int w = mWidth;
	int h = mHeight;
	Array2D< Object >& o = mObjects;
	//lW
	int x, y;
	x = y = -1;
	bool found = false;
	for ( y = 0; y < mHeight; ++y ){
		for ( x = 0; x < mWidth; ++x ){
			if ( o( x, y ) == OBJ_MAN ){
				found = true;
				break;
			}
		}
		if ( found ){
			break;
		}
	}
	//ړ
	//ړW
	int tx = x + dx;
	int ty = y + dy;
	//W̍őŏ`FbNBOĂΕs
	if ( tx < 0 || ty < 0 || tx >= w || ty >= h ){
		return;
	}
	//A.̕󔒂܂̓S[BlړB
	if ( o( tx, ty ) == OBJ_SPACE ){
		o( tx, ty ) = OBJ_MAN;
		o( x, y ) = OBJ_SPACE;
	//B.̕B̎̃̕}X󔒂܂̓S[łΈړB
	}else if ( o( tx, ty ) == OBJ_BLOCK ){
		//2}X悪͈͓`FbN
		int tx2 = tx + dx;
		int ty2 = ty + dy; 
		if ( tx2 < 0 || ty2 < 0 || tx2 >= w || ty2 >= h ){ //Ȃ
			return;
		}
		if ( o( tx2, ty2 ) == OBJ_SPACE ){
			//ւ
			o( tx2, ty2 ) = OBJ_BLOCK;
			o( tx, ty ) = OBJ_MAN;
			o( x, y ) = OBJ_SPACE;
		}
	}
}

//ubN̂ƂgoalFlagłfalseȂ
//܂NAĂȂ
bool State::hasCleared() const {
	for ( int y = 0; y < mHeight; ++y ){
		for ( int x = 0; x < mWidth; ++x ){
			if ( mObjects( x, y ) == OBJ_BLOCK ){
				if ( mGoalFlags( x, y ) == false ){
					return false;
				}
			}
		}
	}
	return true;
}

