#include "GameLib/Framework.h"

class Square{
public:
	void set( int x, int y, int halfSize ){
		mX = x;
		mY = y;
		mHalfSize = halfSize;
	}
	bool solvePenetration( const Square& b ){
		int al = mX - mHalfSize; //left A
		int ar = mX + mHalfSize; //right A
		int bl = b.mX - b.mHalfSize; //left B
		int br = b.mX + b.mHalfSize; //right B
		int at = mY - mHalfSize; //top A
		int ab = mY + mHalfSize; //bottom A
		int bt = b.mY - b.mHalfSize; //top B
		int bb = b.mY + b.mHalfSize; //bottom B

		bool hitX = ( al < br ) && ( ar > bl ); //Eœ
		bool hitY = ( at < bb ) && ( ab > bt ); //㉺œ

		if ( hitX && hitY ){ //œȂƏ͂Ȃ
			int pl = ar - bl; //̂߂肱
			int pr = br - al; //Ê߂肱
			if ( pl < pr ){
				mX -= pl;
			}else{
				mX += pr;
			}
			int pt = ab - bt; //ォ̂߂肱
			int pb = bb - at; //̂߂肱
			if ( pt < pb ){
				mY -= pt;
			}else{
				mY += pb;
			}
			return true;
		}else{
			return false;
		}
	}
	int mX;
	int mY;
	int mHalfSize;
};
bool gFirstFrame = true;
Square gPlayer; //L̂
Square gWall; //

namespace GameLib{
	void Framework::update(){
		if ( gFirstFrame ){
			setFrameRate( 60 );
			gFirstFrame = false;
			gPlayer.set( 16, 16, 16 );
			gWall.set( 160, 120, 16 );
		}
		//ړʃQbg
		int dx = 0;
		int dy = 0;
		if ( isKeyOn( 'a' ) ){
			dx = -1;
		}else if ( isKeyOn( 's' ) ){
			dx = 1;
		}
		if ( isKeyOn( 'w' ) ){
			dy = -1;
		}else if ( isKeyOn( 'z' ) ){
			dy = 1;
		}
		unsigned* vram = videoMemory();
		//ړ
		gPlayer.mX += dx;
		gPlayer.mY += dy;
		//Փˏ
		unsigned color = 0xffff0000;
		if ( gPlayer.solvePenetration( gWall ) ){
			color = 0xffffffff;
		}
		//`
		//UNA
		for ( int i = 0; i < width() * height(); ++i ){
			vram[ i ] = 0;
		}
		//Ȃق`
		for ( int y = 0; y < 32; ++y ){
			for ( int x = 0; x < 32; ++x ){
				int tx = x + gWall.mX - 16;
				int ty = y + gWall.mY - 16;
				vram[ ty * width() + tx ] = 0xff0000ff; 
			}
		}
		//ق`
		for ( int y = 0; y < 32; ++y ){
			for ( int x = 0; x < 32; ++x ){
				int tx = x + gPlayer.mX - 16;
				int ty = y + gPlayer.mY - 16;
				vram[ ty * width() + tx ] = color; 
			}
		}
	}
}