#ifndef INCLUDED_GAME_DYNAMIC_OBJECT_H
#define INCLUDED_GAME_DYNAMIC_OBJECT_H

class Image;
class StaticObject;

class DynamicObject{
public:
	enum Type{
		TYPE_PLAYER,
		TYPE_ENEMY,

		TYPE_NONE, //ł܂
	};
	DynamicObject();
	void set( int x, int y, Type );
	void draw( const Image* ) const;
	//ړ
	void move( const int* wallsX, int* wallsY, int wallNumber );
	//ǂ̃}XɒŜ˂B
	void getCell( int* x, int* y ) const;
	//dx,dyړۂɏdȂĂ}XWzɓĕԂB
	//int[4]B߂l͓ꂽB1,2,4̂ǂꂩB
	int getIntersectionCell( int* xArray, int* yArray, int dx, int dy ) const;
	//GĂő4}X󂯎ĉsB
	void doCollisionReactionToStatic( StaticObject** o, int cellNumber );
	void doCollisionReactionToDynamic( DynamicObject* );

	//DynamicObjectƂ̌
	bool isIntersect( const DynamicObject& ) const;
	//Ǘp
	bool isIntersectWall( int wallCellX, int wallCellY );

	//֗֐Q
	bool hasBombButtonPressed() const;	//e{^ꂽׂ
	bool isPlayer() const;
	bool isEnemy() const;
	void die(); //ɂ܂(mTypeNONEɂ邱Ƃŕ\)
	bool isDead() const; //ł܂H

	//ڂ肽Ȃ̂privateɂ͂ȂBpɂStateĝ炾B
	Type mType;
	//vC[p
	int mBombPower; //
	int mBombNumber; //e
	int mPlayerID; //vC[ԍ
	//eulp
	int mLastBombX[ 2 ];
	int mLastBombY[ 2 ];
private:
	//Ǘp
	static bool isIntersectWall( int x, int y, int wallCellX, int wallCellY );
	//t[̈ړʂ擾
	void getVelocity( int* dx, int* dy ) const;
	//ړ擾
	void getDirection( int* dx, int* dy ) const;
	//W(P)
	int mX;
	int mY;
	//Gp
	int mDirectionX;
	int mDirectionY;
};

#endif
