#include "GameLib/Framework.h"
#include "GameLib/Sound/Wave.h"
#include "GameLib/Sound/Player.h"
using namespace GameLib::Sound;

Wave gWaveSE;
Wave gWaveBGM;
Player gPlayerSE0;
Player gPlayerSE1;
Player gPlayerBGM;

#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"
#include <sstream>
using namespace std;

namespace GameLib{
	void Framework::update(){
		sleep( 16 );
		//SE[h
		if ( !gWaveSE ){
			gWaveSE = Sound::Wave::create( "dokaan.wav" );
		}
		//BGM[h
		if ( !gWaveBGM ){
			gWaveBGM = Sound::Wave::create( "charara.wav" );
		}
		//SEvC[쐬
		if ( !gPlayerSE0 && !gPlayerSE1 && gWaveSE.isReady() ){ //vC[Ń[hIĂȂ
			if ( !gWaveSE.isError() ){ //G[`FbN悤ˁBt@Cǂݑ˂Ă~܂Ȃ̂ŁB
				//1Wave2vC[쐬
				gPlayerSE0 = Sound::Player::create( gWaveSE );
				gPlayerSE1 = Sound::Player::create( gWaveSE );
			}
		}
		//BGMvC[쐬
		if ( !gPlayerBGM && gWaveBGM.isReady() ){ //vC[Ń[hIĂȂ
			if ( !gWaveBGM.isError() ){ //G[`FbN悤ˁBt@Cǂݑ˂Ă~܂Ȃ̂ŁB
				gPlayerBGM = Sound::Player::create( gWaveBGM );
				gPlayerBGM.play( true ); //[vĐBɖB
			}
		}
		//SE80*16~bƂɌ݂ɖ炷BЕ͏B
		if ( gPlayerSE0 && gPlayerSE1 ){
			static int a;
			if ( a % 80 == 0 ){
				gPlayerSE0.setVolume( -10 );
				gPlayerSE0.play(); 
			}
			if ( a % 80 == 40 ){
				gPlayerSE1.setVolume( -20 );
				gPlayerSE1.play(); 
			}
			++a;
		}

		static int v = 0;
		if ( Input::Manager::instance().keyboard().isTriggered( Input::Keyboard::KEY_DOWN ) ){
			--v;
			if ( v < -100 ){
				v = -100;
			}
		}
		if ( Input::Manager::instance().keyboard().isTriggered( Input::Keyboard::KEY_UP ) ){
			++v;
			if ( v > 0 ){
				v = 0;
			}
		}
		ostringstream oss;
		oss << "VOLUME: " << v;
		drawDebugString( 0, 0, oss.str().c_str() );
		if ( gPlayerBGM ){
			gPlayerBGM.setVolume( v );
		}
		if ( isEndRequested() ){
			gWaveSE.release();
			gWaveBGM.release();
			gPlayerSE0.release();
			gPlayerSE1.release();
			gPlayerBGM.release();
		}
	}
}
