#include "GameLib/GameLib.h"
#include "Track.h"
#include "Note.h"
#include <cmath>
using namespace std;

Track::Track() : mNotes( 0 ), mNoteNumber( 0 ){}

Track::~Track(){
	if ( mNotes ){
		SAFE_DELETE_ARRAY( mNotes );
	}
	mNoteNumber = 0;
}

void Track::setData( const Note* notes, int noteNumber ){
	mNotes = new Note[ noteNumber ];
	for ( int i = 0; i < noteNumber; ++i ){
		mNotes[ i ] = notes[ i ];
	}
	mNoteNumber = noteNumber;
}

void Track::addWave( short* buffer, int bufferSize, int frequency ) const {
	int time = 0; //1/100Pʎ
	int pos = 0; //TvPʎ
	for ( int i = 0; i < mNoteNumber; ++i ){
		const Note& n = mNotes[ i ];
		int endTime = time + n.mLength;
		int length = ( endTime * frequency / 100 ) - pos;
		if ( pos + length >= bufferSize ){
			length = bufferSize - pos; //ӂĂ܂
		}
		if ( n.mVolume > 0 ){ //Ȃ珈΂
			addNote( 
				buffer + pos,
				n.mVolume * 32767 / 100,
				n.mName,
				length,
				frequency );
		}
		time = endTime;
		pos += length;
	}
}

void Track::addNote( 
short* buffer,
int waveWidth, 
int name, 
int sampleNumber,
int frequency ) const {
	//57440HzɂȂ悤name߂B
	double f = 440.0 * pow( 2.0, ( name - 57 ) * ( 1.0 / 12.0 ) );

	//ƎgPI
	const double pi = 3.1415926535897932384626433832795;
	//ȉg
	/*
	y = c*sin( ax )
	g̎Bsine2PI1A܂a=2PIɂx11B
	ۂ̎f/44100炱悶
	a = 2PI * f / 44100;
	bwaveWidth̔B-bb܂œB
	̃Tvł͂񂾂񉹂Ȃ悤ɂĂ݂B
	*/
	double a = f * ( 2.0 * pi ) / frequency;
	double b = waveWidth / 2.0;
	double rcpSampleNumber = 1.0 / sampleNumber;

	//yF(gybg̃t[G͌(7{܂))
	//ƂȉFł܂B
	//e{̊ܗL
	const double factor[] = { 
		0.5, //g
		0.85, //2{
		1.05, //3{
		0.85,
		0.4,
		0.3,
		0.1,
		0.0
	};
	//e{̈ʑ(Pʂ͓x)
	const double phase[] = { 
		339.0, //g
		9.0, //2{
		18.0, //3{
		3.0,
		351.0,
		353.0,
		358.0,
		0,
	};
	//ru[gpsin(ax)a(b8)
	const double va = 8.f * ( 2.0 * pi ) / frequency;

	for ( int i = 0; i < sampleNumber; ++i ){
		double posInNote = i * rcpSampleNumber; //̒̈ʒu
		double tb = b * ( 1.0 - posInNote ); //ʂ񂾂񏬂
		tb *= ( 1.0 + posInNote * 0.2 * sin( va * i ) ); //Bu[g(̌قǋ)
		//8̐g
		double w = 0.0;
		for ( int j = 0; j < 8; ++j ){
			w += tb * sin( a * j * i + ( phase[ j ] / pi ) ) * factor[ j ];
		}
		w += buffer[ i ];
 		buffer[ i ] = static_cast< short >( w );
	}
}
