#include "GameLib/GameLib.h"
#include "GameLib/Framework.h"
using namespace GameLib;

#include "Sequence/Title.h"
#include "Sequence/Parent.h"
#include "Image.h"
#include "Pad.h"
#include "SoundManager.h"

namespace Sequence{

Title::Title() : mImage( 0 ), mCursorPosition( 0 ){
	mImage = new Image( "data/image/dummy.dds" );
}

Title::~Title(){
	SAFE_DELETE( mImage );
}

void Title::update( Parent* parent ){
	//͎擾
	if ( Pad::isTriggered( Pad::U ) ){
		--mCursorPosition;
		if ( mCursorPosition < 0 ){ //}CiX͍őlɃ[v
 			mCursorPosition = 1;
		}
		//J[\
		SoundManager::instance()->playSe( SoundManager::SE_CURSOR_MOVE );
	}else if ( Pad::isTriggered( Pad::D ) ){
		++mCursorPosition;
		if ( mCursorPosition > 1 ){ //1z0Ƀ[v
			mCursorPosition = 0;
		}
		//J[\
		SoundManager::instance()->playSe( SoundManager::SE_CURSOR_MOVE );
	}else if ( Pad::isTriggered( Pad::A ) ){
		parent->moveTo( Parent::NEXT_GAME );
		if ( mCursorPosition == 0 ){
			parent->setMode( Parent::MODE_1P );
		}else if ( mCursorPosition == 1 ){
			parent->setMode( Parent::MODE_2P );
		}else{
			HALT( "arienai" );
		}
		//艹
		SoundManager::instance()->playSe( SoundManager::SE_SELECTION );
	}
	//`
	mImage->draw();
	//o
	Framework f = Framework::instance();
	f.drawDebugString( 0, 0, "[] : ޸" );
	f.drawDebugString( 1, 2, "  " );
	f.drawDebugString( 1, 3, "  ۼ" );
	//J[\
	f.drawDebugString( 0, mCursorPosition + 2, ">" );
}

} //namespace Sequence