#include "GameLib/Framework.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"

#include <sstream>
using namespace std;

double gZMove = 2000.0;
bool gFirstFrame = true;
GameLib::Texture* gTexture;

namespace GameLib{
	void Framework::update(){
		setFrameRate( 60 );
		if ( gFirstFrame ){
			gFirstFrame = false;
			createTexture( &gTexture, "grid.tga" ); 
		}

		double p[ 4 ][ 4 ] = { //4 
			{ -500.0, -300.0, -1000.0, 1.0 }, //Y͏オvXȂ̂ŉɂ炷ɂ̓}CiX
			{ -500.0, -300.0, 1000.0, 1.0 },
			{ 500.0, -300.0, -1000.0, 1.0 },
			{ 500.0, -300.0, 1000.0, 1.0 },
		};
		double uv[ 4 ][ 2 ] = { 
			{ 0.0, 0.0 },
			{ 1.0, 0.0 },
			{ 0.0, 1.0 },
			{ 1.0, 1.0 },
		};

		//n[hEFAɓn
		for ( int i = 0; i < 4; ++i ){
			//y640/480ďc𒲐
			p[ i ][ 1 ] *= 640.0 / 480.0;
			//ړʔf
			p[ i ][ 2 ] += gZMove;
			//wɔ͈͕ϊOzi[
			p[ i ][ 3 ] = p[ i ][ 2 ];
			//z͈͕ϊ
			p[ i ][ 2 ] = ( 1.0/9999.0 ) * p[ i ][ 2 ] - ( 1.0/9999.0 );
			//zɔ͈͕ϊOz]ɏZ
			p[ i ][ 2 ] *= p[ i ][ 3 ];
		}
		//lp``B
		setTexture( gTexture );
		drawTriangle3DH( p[ 0 ], p[ 1 ], p[ 2 ], uv[ 0 ], uv[ 1 ], uv[ 2 ], 0xffff0000, 0xffff0000, 0xffff0000 );
		drawTriangle3DH( p[ 3 ], p[ 1 ], p[ 2 ], uv[ 3 ], uv[ 1 ], uv[ 2 ], 0xff00ff00, 0xff00ff00, 0xff00ff00 );

		if ( Input::Manager::instance().keyboard().isOn( 'z' ) ){
			gZMove -= 10.f;
		}else if ( Input::Manager::instance().keyboard().isOn( 'w' ) ){
			gZMove += 10.f; 
		}
		//\
		ostringstream oss;
		oss << "[w-z] Z MOVEMENT: " << gZMove;
		drawDebugString( 10, 0, oss.str().c_str() );
		oss.str( "" );

		if ( isEndRequested() ){
			destroyTexture( &gTexture );
		}
	}
}
