#ifndef INCLUDED_PSEUDO_XML_ELEMENT_H
#define INCLUDED_PSEUDO_XML_ELEMENT_H

#include <string>
#include <vector>
using namespace std;

namespace PseudoXml{

class Tag;
class Attribute;

class Element{
public:
	Element();
	Element( const char* name ); //ORXgNg
	Element( Tag*, const char** readPointer, const char* end );
	~Element();
	//Agr[gQbgn
	int attributeNumber() const;
	const Attribute* attribute( int i ) const;
	Attribute* attribute( int i );
	//Agr[gZbgn
	void setAttributeNumber( int );
	//qQbgn
	int childNumber() const;
	const Element* child( int i ) const;
	Element* child( int i );
	//qZbgn
	void setChildNumber( int );
	//OQbg
	const string* name() const;
	//OύX
	void setName( const char* );
	//
	void convertToString( string* out, int indent ) const;
private:
	vector< Attribute* > mAttributes;
	vector< Element* > mChildren;
	string mName;
};

} //namespace PseudoXml

#endif
