#include "GameLib/GameLib.h"
#include "PseudoXml/Document.h"
#include "PseudoXml/Element.h"
#include "PseudoXml/Attribute.h"
#include "PseudoXml/Parser.h"

namespace PseudoXml{

class ElementData{
public:
	~ElementData(){
		//̂͂ł
		assert( mAttributes.size() == 0 && mChildren.size() == 0 );
	}
	string mName; //Gg
	list< Attribute* > mAttributes; //Agr[g
	list< ElementData* > mChildren; //qf[^
};

Parser::Parser( const char* data, int size ) :
mData( data ),
mDataSize( size ),
mMode( 0 ),
mInEndTag( false ){
}

Parser::~Parser(){
	//ɗƂɂ͋ɂȂĂ͂
	assert( mElements.size() == 0 );
}

namespace {
//a-z,A-Z,0-9,_̂ǂꂩ𒲂ׂ֐
//킩₷xB̕@Ă݂悤B
bool static isNormalChar( char c ){
	if ( c >= '0' && c <= '9' ){
		return true;
	}
	if ( c >= 'a' && c <= 'z' ){
		return true;
	}
	if ( c >= 'A' && c <= 'Z' ){
		return true;
	}
	if ( c == '_' ){
		return true;
	}
	return false;
}

} //namespace {}

//ԑJڕ\BŒȂ̂ŁAG[ɂُ͈ȂقǊeȍɂȂĂB
/*
<ԔԍXg>
0:
1:<̏
2:Gg
3:Gǧ̋󔒁BAgr[g̊Ԃ̋󔒁B
4:Agr[g
5:=̏
6:Agr[gl(""̒g)
7:>̏

<ԑJڃXg>
L:
c = [a-zA-Z0-9_] ܂蕁ʂ̕
s = ̏ɈȂc̕

0,<,1 Jn
1,/,1 I^OtOĂ
1,s,2 Ggŏ̈ꕶ
2,c,2 Ggɒǉ
2,>,7
2,s,3 Ggm
3,>,7
3,c,4 Agr[gŏ̈ꕶ
3,s,3 ǂݔ΂
4,=,5 =BAgr[gm
4,s,4 Agr[gɒǉ
5,",6 _uNHeCVBAgr[glɈڍs
5,s,5 ǂݔ΂
6,",3 Agr[glmBAgr[gXgɒǉB
6,s,6 Agr[glɒǉ
7,c,0 Ă0B^Ôłł낢낷B
*/
Element* Parser::build(){
	//Agr[g̖Oƒl̈ꎞIȊi[ꏊ
	string name;
	string value;
	
	//_~[e
	ElementData* parent = new ElementData;
	parent->mName = "<ROOT>"; //ʈ̍Gg
	elements.push_back( parent ); //Zbg

	//ꂩGg
	ElementData* child = new ElementData;

	//I^OłH
	bool isEndTag = false;

	for ( int i = 0; i < mDataSize; ++i ){
		char c = mData[ i ];
		//[hŕ
		switch ( mMode ){
			case 0: //
				switch ( c ){
					case '<': mMode = 1; break;
					default: break; //Ȃ
				}
				break;
			case 1: //<̏
				switch ( c ){
					case '/': mInEndTag = true; break; //I^Oł
					default: child->mName += c; mMode = 2; break; //Gg˓
				}
				break;
			case 2: //Gg
				if ( c == '>' ){
					mMode = 7;
				}else if ( isNormalChar( c ) ){
					child->mName += c;
				}else{
					mMode = 3; //Gg𔲂
				}
				break;
			case 3: //Gǧ̋
				if ( c == '>' ){
					mMode = 7;
				}else if ( isNormalChar( c ) ){
					name += c; //Agr[gǉ
					mMode = 4;
				}else{
					; //Ȃ
				}
				break;
			case 4: //Agr[g
				switch ( c ){
					case '=': mMode = 5; break;
					default: name += c; break;
				}
				break;
			case 5: //=̏
				switch ( c ){
					case '"': mMode = 6; break;
					default: break; //Ȃ
				}
				break;
			case 6: //Agr[gl
				switch ( c ){
					case '"': 
						mMode = 3; //Gǧ̋
						//Agr[gǉ
						child->mAttributes.push_back( new Attribute( name.c_str(), value.c_str() ) );
						//Oƒl
						name.clear();
						value.clear();
						break;
					default: value += c; break;
				}
				break;
			case 7: //>̏B^O
				if ( mInEndTag ){ //I^OȂ̂ŁAElementXgi߂
					elements.pop_back();
					parent = elements.back(); //Ō̂̐ełB
					mInEndTag = false;
				}else{ //Jn^OȂ̂ŃGg̎qɒǉ
					parent->mChildren.push_back( child );
					parent = child; //Ve͂̐lłB
					child = new ElementData; //V̂ď
				}
				mMode = 0; //ⓚp0
				break;
		}
	}
	//߂łޗ̂ŁAElementĂ܂B
	Element* root = new Element;
	ElementData* rootData = elements.front();
	root->setName( rootData->mName );
	root->setAttributeNumber( rootData->mAttributes.size() );
	int j = 0;
	for ( list< Attributes* >::iterator i = rootData->mAttributes.begin(); i != rootData->mAttributes.end(); ++i ){
		root->setAttribute( j, *i );
		++j;
		*i = 0; //Ǘڂ
	}
	root->setChildNumber( rootData->mChildren.size() );

}

} //namespace PseudoXml
