#include "GameLib/GameLib.h"
#include "PseudoXml/Tag.h"
#include "PseudoXml/Attribute.h"
#include <list>
using namespace std;

namespace PseudoXml{

//a-z,A-Z,0-9,_̂ǂꂩ𒲂ׂ֐
//킩₷xB̕@Ă݂悤B
bool static isNormalChar( char c ){
	if ( c >= '0' && c <= '9' ){
		return true;
	}
	if ( c >= 'a' && c <= 'z' ){
		return true;
	}
	if ( c >= 'A' && c <= 'Z' ){
		return true;
	}
	if ( c == '_' ){
		return true;
	}
	return false;
}

Tag::Tag( const char* name ) : 
mName( name ),
mType( TYPE_BEGIN ){
}

//ԑJڕ\BŒȂ̂ŁAG[ɂُ͈ȂقǊeȍɂȂĂB
/*
<ԔԍXg>
0:<̏B
1:Gg
2:Gǧ̋󔒁BAgr[g̊Ԃ̋󔒁B
3:Agr[g
4:=̏
5:Agr[gl(""̒g)
E:I

<ԑJڃXg>
L:
c = [a-zA-Z0-9_] ܂蕁ʂ̕
s = ̏ɈȂc̕

0,/,0 I^OtOĂ
0,s,1 Ggŏ̈ꕶ
1,c,1 Ggɒǉ
1,>,E
1,s,2 Ggm
2,>,E
2,c,3 Agr[gŏ̈ꕶ
2,s,2 ǂݔ΂
3,=,4 =BAgr[gm
3,s,3 Agr[gɒǉ
4,",5 _uNHeCVBAgr[glɈڍs
4,s,4 ǂݔ΂
5,",2 Agr[glmBAgr[gXgɒǉB
5,s,5 Agr[glɒǉ
*/
Tag::Tag( const char** p, const char* e ) : 
mType( TYPE_BEGIN ){
	//Agr[g̖Oƒl̈ꎞIȊi[ꏊ
	string name;
	string value;

	int m = 0; //[hBmodeƂɂق񂾂낤Agp񐔂q킶Ȃ̂1ɂ
	bool end = false; //[v𔲂tO
	while ( *p < e ){
		char c = **p;
		++( *p ); //|C^i߂
		switch ( m ){
			case 0: //
				switch ( c ){
					case '/': mType = TYPE_END; break; //I^Oł
					default: mName += c; m = 1; break; //Gg˓
				}
				break;
			case 1: //Gg
				if ( c == '>' ){
					end = true;
				}else if ( isNormalChar( c ) ){
					mName += c;
				}else{
					m = 2; //Gg𔲂
				}
				break;
			case 2: //Gǧ̋
				if ( c == '>' ){
					end = true;
				}else if ( isNormalChar( c ) ){
					name += c; //Agr[gǉ
					m = 3;
				}else{
					; //Ȃ
				}
				break;
			case 3: //Agr[g
				switch ( c ){
					case '=': m = 4; break;
					default: name += c; break;
				}
				break;
			case 4: //=̏
				switch ( c ){
					case '"': m = 5; break;
					default: break; //Ȃ
				}
				break;
			case 5: //Agr[gl
				switch ( c ){
					case '"': 
						m = 2; //Gǧ̋
						//Agr[gǉ
						mAttributes.push_back( new Attribute( name.c_str(), value.c_str() ) );
						//Oƒl
						name.clear();
						value.clear();
						break;
					default: value += c; break;
				}
				break;
		}
		if ( end ){ //Ił
			break;
		}
	}
}

Tag::~Tag(){
	//^O͕KElement̍ޗɂȂĂ͂ŁA
	//mAttributes̒g͓nĂ̂delete͂Ȃ
}

const string* Tag::name() const {
	return &mName;
}

Tag::Type Tag::type() const {
	return mType;
}

//d̂Ń|C^Ԃ
const vector< Attribute* >* Tag::attributes() const {
	return &mAttributes;
}

} //namespace PseudoXml