#include "GameLib/Framework.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"
#include "Library/Vector3.h"
#include "Library/Matrix34.h"
#include "Library/Matrix44.h"
#include "Robo.h"
#include "Stage.h"
#include "Pad.h"
#include "GameLib/Math.h"
using namespace GameLib;
#include <sstream>
using namespace std;

namespace { //OԁBقcpp݂ė~Ȃ̂͂ɓB

bool gFirstFrame = true;
Robo* gRobo[ 2 ]; //{O[oɂČB}lȂłˁB
Stage* gStage; //Xe[WO[oɂČB}lȂłˁB
int gCount;
Vector3 gEyePosition( 0.0, 0.0, 1.0 );
Vector3 gEyeTarget( 0.0, 0.0, 0.0 );

} //namespace{}

namespace GameLib{
	void Framework::update(){
		if ( gFirstFrame ){
			setFrameRate( 60 );
			gFirstFrame = false;
			
			Pad::create(); //pbh
			gRobo[ 0 ] = new Robo( 0 );
			gRobo[ 1 ] = new Robo( 1 );
			gStage = new Stage();
			//ʒuݒ
			gRobo[ 0 ]->setPosition( Vector3( 0.0, 0.0, 50.0 ) );
			gRobo[ 1 ]->setPosition( Vector3( 0.0, 0.0, -50.0 ) );
			gRobo[ 0 ]->setAngleY( 180.0 );
			gRobo[ 1 ]->setAngleY( 0.0 );
		}

		//C[v
		//̂݌vZBRobo::update()ɎĝŁBł_f[^͑Õt[
		Vector3 eyeVector;
		eyeVector.setSub( gEyeTarget, gEyePosition );

		//ړ\擾
		Vector3 move[ 2 ];
		for ( int i = 0; i < 2; ++i ){
			gRobo[ i ]->getMove( &move[ i ], eyeVector );
		}
		//ՓˌopCuboidQbg
		const Cuboid& cbRobo0 = *gRobo[ 0 ]->cuboid();
		const Cuboid& cbRobo1 = *gRobo[ 1 ]->cuboid();
		const Cuboid& cbStage = *gStage->cuboid();
		//ړ𐧌
		//0ԃ{
		cbRobo0.restrictMove( &move[ 0 ], cbRobo1 );
		cbRobo0.restrictMove( &move[ 0 ], cbStage );
		//1ԃ{
		cbRobo1.restrictMove( &move[ 1 ], cbRobo0 );
		cbRobo1.restrictMove( &move[ 1 ], cbStage );

		//ړ\蔽fƂ̑
		for ( int i = 0; i < 2; ++i ){
			gRobo[ i ]->update( move[ i ], *gRobo[ 1-i ]->position() );
		}

		//----`----
		//r[ϊs񐶐
		Vector3 dir;
		gRobo[ 0 ]->getDirection( &dir );
		gEyePosition = *( gRobo[ 0 ]->position() ); //܂{̈ʒu
		//6[gɂdir
		Vector3 t;
		t.setMul( dir, 6.0 );
		gEyePosition -= t;
		gEyePosition.y += 4.0; //6[gォ猩Ă낤
		//_͋tɁA8[gɂ̂𑫂B
		gEyeTarget = *( gRobo[ 0 ]->position() );
		t.setMul( dir, 8.0 );
		gEyeTarget += t;
		Matrix34 vm;
		vm.setViewTransform( gEyePosition, gEyeTarget );

		//ϊs񐶐
		//ϊs
		Matrix44 pm; //60xł낤B
		pm.setPerspectiveTransform( 60.0, 640.0, 480.0, 1.0, 1000.0 );
		//Z
		pm *= vm;
		//`
		for ( int i = 0; i < 2; ++i ){
			gRobo[ i ]->draw( pm );
		}
		gStage->draw( pm );

		++gCount;
		//n
		if ( isEndRequested() ){
			SAFE_DELETE( gRobo[ 0 ] );
			SAFE_DELETE( gRobo[ 1 ] );
			SAFE_DELETE( gStage );
			Pad::destroy();
		}
	}
}
