#include "GameLib/Framework.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Manager.h"

#include "Robo.h"
#include "Bullet.h"
#include "Pad.h"
#include "Library/Matrix34.h"
#include "Library/GraphicsDatabase.h"
#include "Library/Model.h"
#include "GameLib/Math.h"
#include <sstream>
using namespace GameLib;
using namespace std;

//{̓t@Cɏo񂾂H
const int Robo::mJumpUpTime = 20; //㏸Ă
const int Robo::mJumpStayTime = 60; //㏸㉺~܂ł̎
const int Robo::mJumpFallTime = 40; //~ɂ鎞
const int Robo::mMoveAccelEndCount = 30; //n߂ĉI܂ł̎
const double Robo::mMaxMoveSpeed = 0.5; //őړx
const double Robo::mJumpHeight = 20.0; //ő卂x
const int Robo::mCameraDelayCount = 10; //WvJn㉽t[œG̕
const double Robo::mCameraDistanceZ = 10.0; //[g납ʂH
const double Robo::mCameraDistanceY = 4.0; //낵
const double Robo::mCameraTargetDistanceZ = 20.0; //_͉[gH
const double Robo::mTurnSpeed = 1.0; //񑬓x
const int Robo::mMaxHitPoint = 100; //őqbgb|Cg

Robo::Robo( int id ) : 
mPosition( 0.0, 0.0, 0.0 ),
mAngleY( 0.0 ),
mId( id ),
mDatabase( 0 ),
mModel( 0 ),
mBullets( 0 ),
mBulletNumber( 100 ), //߂
mCameraCount( 0 ),
mCount( 0 ),
mVelocity( 0.0, 0.0, 0.0 ),
mMode( MODE_ON_LAND ),
mHitPoint( mMaxHitPoint ){
	mDatabase = new GraphicsDatabase( "robo.txt" );
	mModel = mDatabase->createModel( "robo" );
	mBullets = new Bullet[ mBulletNumber ];
}

Robo::~Robo(){
	SAFE_DELETE_ARRAY( mBullets );
	SAFE_DELETE( mModel ); //gĂgĂ
	SAFE_DELETE( mDatabase );
}

void Robo::setPosition( const Vector3& a ){
	mPosition = a;
}

void Robo::setAngleY( double a ){
	mAngleY = a;
}

void Robo::update( Robo* enemy ){
	//ł
	if ( mHitPoint <= 0 ){
		return;
	}
	//px͈͕␳
	if ( mAngleY > 180.0 ){
		mAngleY -= 360.0;
	}else if ( mAngleY < -180.0 ){
		mAngleY += 360.0;
	}

	const Vector3& enemyPos = *enemy->position();
	++mCount;
	//WvĂH
	Pad* pad = Pad::instance();
	bool inputJump = pad->isOn( Pad::JUMP, mId );
	double t;
	//͂ɎĂ݂悤BR[h̏d邪ubNPʂŌ΃VvɂȂB
	//ʂ̏Ƃǂ炪ǂׂĂ݂悤B
	switch ( mMode ){
		case MODE_JUMP_UP:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			//㏸
			t = mJumpHeight / static_cast< double >( mJumpUpTime );
			mVelocity.y = t;
			if ( !inputJump ){ //Wv͂Ȃ̂ŉ~ɕω
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}else if ( mCount >= mJumpUpTime ){ //㏸I
				mMode = MODE_JUMP_STAY; 
				mCount = 0;
			}
			mVelocity.x = mVelocity.z = 0.0; //X,Zړ𖕎E
			break;
		case MODE_JUMP_STAY:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			mVelocity.y = 0.0;
			if ( !inputJump ){ //Wv͂Ȃ̂ŉ~ɕω
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}else if ( mCount >= mJumpStayTime ){ //~
				mMode = MODE_JUMP_FALL;
				mCount = 0;
			}
			break;
		case MODE_JUMP_FALL:
			//J肫ĂȂȂJ]p
			if ( mCameraCount < mCameraDelayCount ){
				mAngleY += mAngleVelocityY;
				++mCameraCount;
			}
			//~
			t = mJumpHeight / static_cast< double >( mJumpFallTime );
			mVelocity.y = -t;
			//ڒn͍ŏIIɂ͏Փˏł̂łł͂ȂB
			break;
		case MODE_ON_LAND:
			if ( inputJump ){
				mMode = MODE_JUMP_UP;
				mCount = 0;
				mCameraCount = 0;

				//G̕ɌB
				Vector3 dir;
				dir.setSub( enemyPos, mPosition ); //G
				//Ypxatan2( x, z )
				t = atan2( dir.x, dir.z );
				//180xȏ㍷+-360xċt
				if ( t - mAngleY > 180.0 ){
					t -= 360.0;
				}else if ( mAngleY - t > 180.0 ){
					t += 360.0;
				}
				mAngleVelocityY = ( t - mAngleY ) / static_cast< double >( mCameraDelayCount );
			}else if ( pad->isOn( Pad::TURN, mId ) ){
				turn(); //R[hȂ̂Ŋ֐ɔ΂
			}else{
				move(); //R[hȂ̂Ŋ֐ɔ΂
			}
			mVelocity.y = 0.0;
			break;
	}
	//牺͏ՓˏƂ̌ɂȂB
	mPosition += mVelocity;
	if ( mPosition.y < 0.0 ){
		mPosition.y = 0.0;
		mMode = MODE_ON_LAND;
	}
	//퐶
	if ( pad->isTriggered( Pad::FIRE, mId ) ){
		//󂫕T
		for ( int i = 0; i < mBulletNumber; ++i ){
			if ( mBullets[ i ].isEmpty() ){
				mBullets[ i ].create(
					mDatabase, 
					"bullet", 
					mPosition,
					15.0,
					mAngleY );
				break;
			}
		}
	}
	//XV
	for ( int i = 0; i < mBulletNumber; ++i ){
		if ( !mBullets[ i ].isEmpty() ){
			mBullets[ i ].update( enemyPos );
			//Փˏ
			Vector3 t;
			t.setSub( *mBullets[ i ].position(), enemyPos );
			if ( t.squareLength() < 4.0 ){
				enemy->setDamage( 1 ); //1_炵Ă݂B
				mBullets[ i ].die(); //e܂B
			}
		}
	}
}

void Robo::turn(){
	Pad* pad = Pad::instance();
	if ( pad->isOn( Pad::LEFT, mId ) ){
		mAngleY += mTurnSpeed;
		if ( mAngleY > 180.0 ){ //-PIPIɂ߂
			mAngleY -= 360.0;
		}
	}
	if ( pad->isOn( Pad::RIGHT, mId ) ){
		mAngleY -= mTurnSpeed;
		if ( mAngleY < -180.0 ){ //-PIPIɂ߂
			mAngleY += 360.0;
		}
	}
}

void Robo::move(){
	//ړB܂_lȂxo
	Vector3 move( 0.0, 0.0, 0.0 );
	Pad* pad = Pad::instance();
	if ( pad->isOn( Pad::UP, mId ) ){
		move.z = -1.0;
	}
	if ( pad->isOn( Pad::DOWN, mId ) ){
		move.z = 1.0;
	}
	if ( pad->isOn( Pad::LEFT, mId ) ){
		move.x = -1.0;
	}
	if ( pad->isOn( Pad::RIGHT, mId ) ){
		move.x = 1.0;
	}
	//ĉ]
	Matrix34 m;
	m.setRotationY( mAngleY + 180.0 );
	m.multiply( &move, move );

	//~܂ĂȂb͑BKɉĂ邾
	if ( mVelocity.x == 0.0 && mVelocity.z == 0.0 ){
		//ɂ鎞Ԃōő呬x1t[̉xoB
		double accel = mMaxMoveSpeed / static_cast< double >( mMoveAccelEndCount );
		mVelocity.setMul( move, accel );
	}else{ //łɓĂꍇ
		if ( move.x == 0.0 && move.z == 0.0 ){ //ړ[
			mVelocity.set( 0.0, 0.0, 0.0 ); //ړ͂Ƃ܂B
		}else{
			//łɓĂꍇȂʓ|łB
			//45x]Ƀ[ȂƂ̂̓XgXB
			//AȗxƕȂ[蒼vɂB

			//90xȏ̃^[ȂUx0ɂB
			//Q[邪AтѓȂ犵͎ז낤B
			//90xȏ̃^[Ȃ猻xƉ̓ς}CiX̂͂
			double dp = mVelocity.dot( move );
			if ( dp <= 0.0 ){
				mVelocity.set( 0.0, 0.0, 0.0 );
			}else{ //90x
				//݂̈ړxƐȐ̂ݎo
				//́AړPʃxN^Ƃ̓ςAړPʃxN^ɂ΂B
				//ړPʃxN^EAxxN^VƂāAVxxN^V'Ȃ킿s
				//V' = dot(V,E) * E
				//̎AE͈ړxN^MgE=M/|M|Ə邩A
				//V' = dot(V,M) * M / ( |M|^2 )
				//APʃxN^ۂ̕B|M||M|^2̕vZ͑̂B
				double moveSquareLength = move.x * move.x + move.z * move.z;
				double dp = mVelocity.dot( move );
				mVelocity.setMul( move, dp / moveSquareLength );
			}
			//B
			//ړx͍ő呬x/ԂłB
			double accel = mMaxMoveSpeed / static_cast< double >( mMoveAccelEndCount );
			mVelocity.madd( move, accel );
			//ő呬xŃXgbv
			double speed = mVelocity.length();
			if ( speed > mMaxMoveSpeed ){
				mVelocity *= mMaxMoveSpeed / speed;
			}
		}
	}
}

void Robo::draw( const Matrix44& pvm ) const {
	//fɈʒuZbg
	mModel->setAngle( Vector3( 0.0, mAngleY, 0.0 ) );
	mModel->setPosition( mPosition );
	//`
	mModel->draw( pvm );
	//
	for ( int i = 0; i < mBulletNumber; ++i ){
		if ( !mBullets[ i ].isEmpty() ){
			mBullets[ i ].draw( pvm );
		}
	}
}

const Vector3* Robo::position() const {
	return &mPosition;
}

void Robo::setDamage( int d ){
	mHitPoint -= d;
}

int Robo::hitPoint() const {
	return mHitPoint;
}

void Robo::getViewMatrix( Matrix34* vm ) const {
	//܂ʕxN^쐬
	Vector3 d( 0.0, 0.0, 1.0 );
	Matrix34 m;
	m.setRotationY( mAngleY );
	m.multiply( &d, d );
	//OmCameraTargetDistanceZL΂
	Vector3 t;
	t.setMul( d, mCameraTargetDistanceZ );
	//{ƂɂȂ炿ƉĂB̓p[^ɂȂ̏HvB
	t.y -= mPosition.y * 0.12; //̂ւ̒K
	//mCameraDistacneZL΂
	Vector3 p;
	p.setMul( d, -mCameraDistanceZ );
	//YmCameraDistanceYvX
	p.y += mCameraDistanceY;
	//{ƂɂȂ炿ƍڂɂĉĂB̓p[^ɂȂ̏HvB
	p.y += mPosition.y * 0.12; //̂ւ̒K
	//{݈ʒuvX
	t += mPosition;
	p += mPosition;
	//r[s쐬
	vm->setViewTransform( p, t );
}