#ifndef INCLUDED_ROBO_H
#define INCLUDED_ROBO_H

#include "Library/Vector3.h"

class Matrix34;
class Matrix44;
class GraphicsDatabase;
class Model;

class Robo{
public:
	Robo( int id ); //ԍ炤BԂm肽̂ŁB
	~Robo();
	void draw( const Matrix44& perspectiveViewMatrix ) const;
	void update( const Vector3& enemyPosition );
	void setPosition( const Vector3& );
	void setAngleY( double );
	const Vector3* position() const;
	void getViewMatrix( Matrix34* ) const;
private:
	void move();
	void turn();

	Vector3 mPosition;
	double mAngleY;
	int mId;
	GraphicsDatabase* mDatabase;
	Model* mModel;
	
	int mCameraCount;
	int mCount; //ړJn㉽t[oH
	Vector3 mVelocity; //݂̕ʑx
	double mAngleVelocityY; //Ux

	static const int mJumpUpTime; //㏸Ă
	static const int mJumpStayTime; //㏸㉺~܂ł̎
	static const int mJumpFallTime; //~ɂ鎞
	static const int mMoveAccelEndCount; //n߂ĉI܂ł̎
	static const double mMaxMoveSpeed; //őړx
	static const double mJumpHeight; //ő卂x
	static const int mCameraDelayCount; //WvJn㉽t[œG̕
	static const double mCameraDistanceZ; //[g납ʂH
	static const double mCameraDistanceY; //낵
	static const double mCameraTargetDistanceZ; //_͉[gH
	static const double mTurnSpeed; //񑬓x

	enum Mode{
		MODE_JUMP_UP, //Wv㏸
		MODE_JUMP_STAY, //WvŒ~
		MODE_JUMP_FALL, //Wv~
		MODE_ON_LAND, //nĂ
	};
	Mode mMode;

};

#endif
