#ifndef INCLUDED_ROBO_H
#define INCLUDED_ROBO_H

#include "Library/Vector3.h"

class Matrix34;
class Matrix44;
class GraphicsDatabase;
class Model;
class Bullet;

class Robo{
public:
	Robo( int id ); //ԍ炤BԂm肽̂ŁB
	~Robo();
	void draw( 
		const Matrix44& perspectiveViewMatrix,
		const Vector3& lightVector,
		const Vector3& lightColor,
		const Vector3& ambient ) const;
	void update( Robo* robo );
	void setPosition( const Vector3& );
	void setAngleY( double );
	const Vector3* position() const;
	void getViewMatrix( Matrix34* ) const;
	void setDamage( int damage );
	int hitPoint() const;
	int energy() const;
	bool isLockOn() const;

	static const int mJumpUpTime; //㏸Ă
	static const int mJumpStayTime; //㏸㉺~܂ł̎
	static const int mJumpFallTime; //~ɂ鎞
	static const int mMoveAccelEndCount; //n߂ĉI܂ł̎
	static const double mMaxMoveSpeed; //őړx
	static const double mJumpHeight; //ő卂x
	static const int mCameraDelayCount; //WvJn㉽t[œG̕
	static const double mCameraDistanceZ; //[g납ʂH
	static const double mCameraDistanceY; //낵
	static const double mCameraTargetDistanceZ; //_͉[gH
	static const double mTurnSpeed; //񑬓x
	static const int mMaxHitPoint; //őqbg|Cgz
	static const int mMaxEnergy; //|Cgől
	static const int mEnergyPerBullet; //ꔭ̏GlM[
	static const int mEnergyCharge; //t[܂GlM[
	static const double mLockOnAngleIn; //bNIpx
	static const double mLockOnAngleOut; //bNIpx
private:
	void move( bool left, bool right, bool up, bool down );
	void turn( bool left, bool right );
	//vl[`B{^͂ԂBvC[LȂ炽͂邾
	void think( bool* jump, bool* fire, bool* turn, bool* left, bool* right, bool* up, bool* down ) const;

	Vector3 mPosition;
	double mAngleY;
	int mId;
	GraphicsDatabase* mDatabase;
	Model* mModel;
	
	Bullet* mBullets;
	int mBulletNumber;

	int mCameraCount;
	int mCount; //ړJn㉽t[oH
	Vector3 mVelocity; //݂̕ʑx
	double mAngleVelocityY; //Ux


	enum Mode{
		MODE_JUMP_UP, //Wv㏸
		MODE_JUMP_STAY, //WvŒ~
		MODE_JUMP_FALL, //Wv~
		MODE_ON_LAND, //nĂ
	};
	Mode mMode;

	int mHitPoint; //̗
	int mEnergy; //̂ɕKvȃGlM[
	bool mLockOn; //bNIĂ܂H
};

#endif
