#ifndef INCLUDED_GAMELIB_LIST_H
#define INCLUDED_GAMELIB_LIST_H

class List{
public:
	explicit List( int capacity );
	~List();
	//ǉBǂɑԂB
	int addTail( int value );
	//wꏊ폜
	void remove( int position );
	///l擾
	int value( int position ) const;
	//[ǂisEnd()ŊmF
	int next( int position ) const;
	//擪擾
	int first() const;
	//position[B
	bool isEnd( int position ) const;
private:
	struct Node{
		int mNext;
		int mPrev;
		int mValue;
	};
	List( const List& ); //Rs[RXgN^֎~
	void operator=( const List& ); //֎~

	Node* mNodes;
	int* mEmptyStack; //łǂ󂢂Ă邩O(1)ł킩
	int mStackTop;
	const int mCapacity; //RXgNg炢Ȃ̂const
};

//cpp̂ʓ|Ȃ̂łɏĂ܂Bxオ邵낤B

//擪ƖʈȂ悤ɂƍHvĂB
//mNodes[ mCapacity ]̓_~[m[hB擪Ɩɂ̃_~[邨ł낢yȂ̂łB
inline List::List( int capacity ) : 
mNodes( 0 ),
mEmptyStack( 0 ),
mCapacity( capacity ){
	mNodes = new Node[ mCapacity + 1 ]; //ŌɃ_~[m[hB+1
	mEmptyStack = new int[ mCapacity ];
	for ( int i = 0; i < mCapacity; ++i ){
		mEmptyStack[ i ] = i; //󂢂Ăԍi[BŏSȁB
	}
	mStackTop = mCapacity - 1; //ŏɎô͖
	//_~[m[hݒB
	mNodes[ mCapacity ].mNext = mNodes[ mCapacity ].mPrev = mCapacity;
}

inline List::~List(){
	SAFE_DELETE_ARRAY( mNodes );
	SAFE_DELETE_ARRAY( mEmptyStack );
}

inline int List::addTail( int v ){
	//󂫏ꏊ擾
	int newPos = mEmptyStack[ mStackTop ];
	--mStackTop;

	mNodes[ newPos ].mValue = v; //lāA
	mNodes[ newPos ].mNext = mCapacity; //̓_~[m[h
	int oldTail = mNodes[ mCapacity ].mPrev; //O̖̓_~[̑Oɂ
	mNodes[ newPos ].mPrev = oldTail; //V̑OɌÂ

	mNodes[ oldTail ].mNext = newPos; //Â̎
	mNodes[ mCapacity ].mPrev = newPos; //_~[̑O
	return newPos; //ꏊԂ
}

inline void List::remove( int position ){
	Node* cur = &mNodes[ position ]; //
	Node* nxt = &mNodes[ cur->mNext ]; //
	Node* prev = &mNodes[ cur->mPrev ]; //O
	//O̓z̎AɂB
	prev->mNext = cur->mNext;
	//̓z̑OAOɂB
	nxt->mPrev = cur->mPrev;

	//󂫔ԍXgɒǉ
	++mStackTop;
	mEmptyStack[ mStackTop ] = position;
}

inline int List::value( int position ) const {
	return mNodes[ position ].mValue;
}

inline int List::next( int position ) const {
	return mNodes[ position ].mNext;
}

inline int List::first() const {
	//_~[̎擪Ȃ̂
	return mNodes[ mCapacity ].mNext;
}

inline bool List::isEnd( int position ) const {
	//Ō܂ōsmCapacityA܂_~[ɂȂB
	return ( position == mCapacity );
}

#endif

