#include "GameLib/Framework.h"
#include "GameLib/Math.h"
#include "Vector2.h"
#include <sstream>
#include <list>
#include <algorithm>
using namespace std;
using namespace GameLib;

struct Circle{
	Vector2 mPosition;
	Vector2 mVelocity;
};
Circle* gCircles = 0;
const int N = 40; //̓ł
const double R = 2.0; //a2
const double RSUM2 = ( R + R ) * ( R + R ); //aa̓
const Vector2 gMinimum( -160.0, -160.0 );
const Vector2 gMaximum( 160.0, 160.0 );
const int gDivision = 30;
const int gBoxListSize = 300; //ĂƂ
const int gHitListSize = 6000; //ĂƂ
bool testCircles( int index0, int index1 ); //1Â̔֐(:ŗ͂͗^Ȃ)
void addForce( int i0, int i1 ); //͂𑫂̂͂

//----------------------̏͂̃~\--------------Z--------------------------

//yA
struct HitPair{ 
	bool operator<( const HitPair& a ) const { //\[gɕKvȕs
		if ( mI0 < a.mI0 ){
			return true;
		}else if ( mI0 > a.mI0 ){
			return false;
		}else{
			return ( mI1 < a.mI1 );
		}
	}
	bool operator==( const HitPair& a ) const {//uniqueɕKvȓ
		return ( ( mI0 == a.mI0 ) && ( mI1 == a.mI1 ) );
	}
	int mI0;
	int mI1;
};

void processCollision( int* test, int* hit ){
	*test = 0;
	*hit = 0;
#if 1
	int n = N*N; //
	//̃TCYvZ
	Vector2 boxSize; //TCY
	boxSize.setSub( gMaximum, gMinimum );
	boxSize *= 1.0 / static_cast< float >( gDivision );
	//Xgp
	int* boxList = new int[ gDivision * gDivision * gBoxListSize ];
	int* boxListPos = new int[ gDivision * gDivision ];
	for ( int i = 0; i < gDivision * gDivision; ++i ){ //Xgʒu
		boxListPos[ i ] = 0;
	}
	for ( int i = 0; i < n; ++i ){
		Vector2 t;
		t.setSub( gCircles[ i ].mPosition, gMinimum );
		double minX = t.x - R;
		double maxX = t.x + R;
		double minY = t.y - R;
		double maxY = t.y + R;
		//ԍɕϊ(Z͍łˁH)
		int minXBox = static_cast< int >( minX / boxSize.x );
		int maxXBox = static_cast< int >( maxX / boxSize.x );
		int minYBox = static_cast< int >( minY / boxSize.y );
		int maxYBox = static_cast< int >( maxY / boxSize.y );
		ASSERT( minXBox >= 0 && maxXBox < gDivision && minYBox >=0 && maxYBox < gDivision );
		for ( int j = minXBox; j <= maxXBox; ++j ){
			for ( int k = minYBox; k <= maxYBox; ++k ){
				int boxIndex = k * gDivision + j; //ԍ́uY * () + Xv
				ASSERT( boxListPos[ boxIndex ] < gBoxListSize );
				boxList[ boxIndex * gBoxListSize + boxListPos[ boxIndex ] ] = i;
				++boxListPos[ boxIndex ];
			}
		}
	}
	//Ƃɑ
	HitPair* hitArray = new HitPair[ gHitListSize ];
	int hitArrayPos = 0;
	for ( int i = 0; i < gDivision * gDivision; ++i ){
		for ( int j = 0; j < boxListPos[ i ]; ++j ){
			for ( int k = j + 1; k < boxListPos[ i ]; ++k ){
				int i0 = boxList[ i * gBoxListSize + j ];
				int i1 = boxList[ i * gBoxListSize + k ];
++( *test );
				if ( testCircles( i0, i1 ) ){
++( *hit );
					HitPair hit;
					//yA͓łȂƍ̂ŁAOɂ
					if ( i0 < i1 ){
						hit.mI0 = i0;
						hit.mI1 = i1;
					}else{
						hit.mI0 = i0;
						hit.mI1 = i1;
					}
					hitArray[ hitArrayPos ] = hit;
					++hitArrayPos;
				}
			}
		}
	}
	//\[g
	sort( hitArray, hitArray + hitArrayPos );
	//d
	size_t hitN = unique( hitArray, hitArray + hitArrayPos ) - hitArray;
	//͂
	for ( size_t i = 0; i < hitN; ++i ){
		addForce( hitArray[ i ].mI0, hitArray[ i ].mI1 );
	}
	SAFE_DELETE_ARRAY( hitArray );
	SAFE_DELETE_ARRAY( boxListPos );
	SAFE_DELETE_ARRAY( boxList );
#else //foOp
	for ( int i = 0; i < N*N; ++i ){
		for ( int j = i + 1; j < N*N; ++j ){
			++( *test );
			if ( testCircles( i, j ) ){
				++( *hit );
			}
		}
	}
#endif
}

//----------------------牺̖͂̏͂{؂ł͂ȂR[h---------------------------

//2circle钆gBtrue
bool testCircles( int i0, int i1 ){
	Circle& c0 = gCircles[ i0 ];
	const Vector2& p0 = c0.mPosition;
	Circle& c1 = gCircles[ i1 ];
	const Vector2& p1 = c1.mPosition;
	//́H
	Vector2 t;
	t.setSub( p1, p0 );
	double sql = t.squareLength();
	if ( sql < RSUM2 ){ 
		return true;
	}else{
		return false;
	}
}

void addForce( int i0, int i1 ){
	Vector2 t;
	t.setSub( gCircles[ i0 ].mPosition, gCircles[ i1 ].mPosition );
	double l = t.length();
	t *= 0.25 / l; //Kɒ𒲐
	//͂ԂBtp0->p1̃xN^Ac1ɑAc0B
	gCircles[ i0 ].mVelocity += t;
	gCircles[ i1 ].mVelocity -= t;
}

namespace GameLib{
	void Framework::update(){
		if ( !gCircles ){
			gCircles = new Circle[ N*N ];
			//zu
			for ( int i = 0; i < N*N; ++i ){
				gCircles[ i ].mPosition.set( 
					static_cast< double >( ( ( i % N ) - N/2 ) * 4 ) + 0.001 * i, //Ƃ炷
					static_cast< double >( ( ( i / N ) - N/2 ) * 4 ) );
				gCircles[ i ].mVelocity.set( 0.0, 0.0 );
			}
		}
		//x
		for ( int i = 0;i < N*N; ++i ){
			//x_ŏ
			gCircles[ i ].mVelocity.setMul( gCircles[ i ].mPosition, -0.001 );
		}
		int test;
		int hit;
		processCollision( &test, &hit ); //Փˌo֐

		//XV
		for ( int i = 0;i < N*N; ++i ){
			gCircles[ i ].mPosition += gCircles[ i ].mVelocity;

			//`
			double p[ 4 ][ 2 ];
			p[ 0 ][ 0 ] = p[ 1 ][ 0 ] = gCircles[ i ].mPosition.x - 0.5 + 160.0;
			p[ 2 ][ 0 ] = p[ 3 ][ 0 ] = gCircles[ i ].mPosition.x + 0.5 + 160.0;
			p[ 0 ][ 1 ] = p[ 2 ][ 1 ] = gCircles[ i ].mPosition.y - 0.5 + 120.0;
			p[ 1 ][ 1 ] = p[ 3 ][ 1 ] = gCircles[ i ].mPosition.y + 0.5 + 120.0;
			drawTriangle2D( p[ 0 ], p[ 1 ], p[ 2 ] );
			drawTriangle2D( p[ 3 ], p[ 1 ], p[ 2 ] );
		}
		ostringstream oss;
		oss << frameRate() << " " << test << " " << hit;
		drawDebugString( 0, 0, oss.str().c_str() );
	}
}
