#include "GameLib/Framework.h"
#include "GameLib/Math.h"
#include "Vector2.h"
#include <sstream>
#include <list>
#include <algorithm>
using namespace std;
using namespace GameLib;

struct Circle{
	Vector2 mPosition;
	Vector2 mVelocity;
};
Circle* gCircles = 0;
const int N = 40; //̓ł
const double R = 2.0; //a4
const double RSUM2 = ( R + R ) * ( R + R ); //aa̓
const Vector2 gMinimum( -160.0, -160.0 );
const Vector2 gMaximum( 160.0, 160.0 );
const int gDivision = 30;
const int gBoxListBlockSize = 1000; //ĂƂ
const int gHitListBlockSize = 1000; //ĂƂ
bool testCircles( int index0, int index1 ); //1Â̔֐(:ŗ͂͗^Ȃ)
void addForce( int i0, int i1 ); //͂𑫂̂͂

//----------------------̏͂̃~\--------------Z--------------------------

//yA
struct HitPair{ 
	bool operator<( const HitPair& a ) const { //\[gɕKvȕs
		if ( mI0 < a.mI0 ){
			return true;
		}else if ( mI0 > a.mI0 ){
			return false;
		}else{
			return ( mI1 < a.mI1 );
		}
	}
	bool operator==( const HitPair& a ) const {//uniqueɕKvȓ
		return ( ( mI0 == a.mI0 ) && ( mI1 == a.mI1 ) );
	}
	int mI0;
	int mI1;
};

//ԍƉ~ԍ̃yA
struct ObjPair{
	void set( int box, int circle ){
		mBox = box;
		mCircle = circle;
	}
	int mBox;
	int mCircle;
};

void processCollision( int* test, int* hit ){
	*test = 0;
	*hit = 0;
#if 1
	int n = N*N; //
	//̃TCYvZ
	Vector2 boxSize; //TCY
	boxSize.setSub( gMaximum, gMinimum );
	boxSize *= 1.f / static_cast< float >( gDivision );
	//Xgp
	list< ObjPair* > boxList;
	int boxListBlockPos = gBoxListBlockSize;

	//iKBtbgArrayListɔԍƕ̔ԍi[
	for ( int i = 0; i < n; ++i ){
		Vector2 t;
		t.setSub( gCircles[ i ].mPosition, gMinimum );
		double minX = t.x - R;
		double maxX = t.x + R;
		double minY = t.y - R;
		double maxY = t.y + R;
		//ԍɕϊ(Z͍łˁH)
		int minXBox = static_cast< int >( minX / boxSize.x );
		int maxXBox = static_cast< int >( maxX / boxSize.x );
		int minYBox = static_cast< int >( minY / boxSize.y );
		int maxYBox = static_cast< int >( maxY / boxSize.y );
		ASSERT( minXBox >= 0 && maxXBox < gDivision && minYBox >=0 && maxYBox < gDivision );
		for ( int j = minXBox; j <= maxXBox; ++j ){
			for ( int k = minYBox; k <= maxYBox; ++k ){
				int boxIndex = k * gDivision + j; //ԍ́uY * () + Xv
				if ( boxListBlockPos == gBoxListBlockSize ){
					boxList.push_back( new ObjPair[ gBoxListBlockSize ] );
					boxListBlockPos = 0;
				}
				boxList.back()[ boxListBlockPos ].set( boxIndex, i ) ;
				++boxListBlockPos;
			}
		}
	}
	//iKB𐔂
	int* boxListSize = new int[ gDivision * gDivision ];
	//
	for ( int i = 0; i < gDivision * gDivision; ++i ){
		boxListSize[ i ] = 0;
	}
	//[vŐ
	typedef list< ObjPair* >::const_iterator It; //ʖ
	int blockPos = 0;
	int blockNumber = static_cast< int >( boxList.size() );
	for ( It i = boxList.begin(); i != boxList.end(); ++i ){
		//ubÑTCY߂BŌゾႤBĂr炾B
		int blockSize = ( blockPos == ( blockNumber - 1 ) ) ? boxListBlockPos : gBoxListBlockSize;
		for ( int j = 0; j < blockSize; ++j ){
			const ObjPair& o = ( *i )[ j ];
			++boxListSize[ o.mBox ];
		}
		++blockPos;
	}
	//boxListSize͐A擪ItZbgɕϊB
	int* boxListOffset = new int[ gDivision * gDivision ];
	int offset = 0;
	for ( int i = 0; i < gDivision * gDivision; ++i ){
		boxListOffset[ i ] = offset;
		offset += boxListSize[ i ];
		boxListSize[ i ] = 0; //TCYz0ɂĂ܂B
		//ɓĂɂɐȂ΂܂̂B
		//OiKłǂ܂œꂽoĂ߂̔zʂɍȂ߂̌ƑȍHvB
	}
	//OiKBۂɔƂ̃Xg𐶐B

	//̔zmہB傤ǏoffsetɍvĂB
	int* boxArray = new int[ offset ];
	//ĂB
	blockPos = 0;
	blockNumber = static_cast< int >( boxList.size() );
	for ( It i = boxList.begin(); i != boxList.end(); ++i ){
		//ubÑTCY߂BŌゾႤBĂr炾B
		int blockSize = ( blockPos == ( blockNumber - 1 ) ) ? boxListBlockPos : gBoxListBlockSize;
		for ( int j = 0; j < blockSize; ++j ){
			const ObjPair& o = ( *i )[ j ];
			boxArray[ boxListOffset[ o.mBox ] + boxListSize[ o.mBox ] ] = o.mCircle;
			++boxListSize[ o.mBox ]; //TCY+1B̃[v𔲂ɂ͍ŏɐƓԂɂȂĂB
		}
		++blockPos;
	}
	//ƂɑBzɂĂ܂֌WɒPĂB
	list< HitPair* > hitList;
	int hitListBlockPos = gHitListBlockSize;
	for ( int i = 0; i < gDivision * gDivision; ++i ){ //Ń[v
		//̒̐
		int boxSize = boxListSize[ i ];
		const int* box = &boxArray[ boxListOffset[ i ] ]; //ʖ
		for ( int j = 0; j < boxSize; ++j ){ //ڂ̃̕[v
			for ( int k = j + 1; k < boxSize; ++k ){ //ڂ̃̕[v
				int i0 = box[ j ];
				int i1 = box[ k ];
				++( *test );
				if ( testCircles( i0, i1 ) ){
					++( *hit );
					HitPair hit;
					//yA͓łȂƍ̂ŁAOɂ
					if ( i0 < i1 ){
						hit.mI0 = i0;
						hit.mI1 = i1;
					}else{
						hit.mI0 = i0;
						hit.mI1 = i1;
					}
					if ( hitListBlockPos == gHitListBlockSize ){
						hitList.push_back( new HitPair[ gHitListBlockSize ] );
						hitListBlockPos = 0;
					}
					hitList.back()[ hitListBlockPos ] = hit;
					++hitListBlockPos;
				}
			}
		}
	}
	//XgzɃRs[B\[g炾B
	blockNumber = static_cast< int >( hitList.size() );
	HitPair* hitArray = 0;
	if ( blockNumber > 0 ){
		int hitArraySize = ( blockNumber - 1 ) * gHitListBlockSize + hitListBlockPos;
		hitArray = new HitPair[ hitArraySize ];
		int blockCopied = 0;
		list< HitPair* >::iterator hitListIt = hitList.begin();
		while ( blockCopied < ( blockNumber - 1 ) ){
			for ( int i = 0; i < gHitListBlockSize; ++i ){
				hitArray[ blockCopied * gHitListBlockSize + i ] = ( *hitListIt )[ i ];
			}
			++blockCopied;
			++hitListIt;
		}
		//ŏIubN
		for ( int i = 0; i < hitListBlockPos; ++i ){
			hitArray[ blockCopied * gHitListBlockSize + i ] = hitList.back()[ i ];
		}
		//\[g
		sort( hitArray, hitArray + hitArraySize );
		//d
		size_t hitN = unique( hitArray, hitArray + hitArraySize ) - hitArray;
		//͂
		for ( size_t i = 0; i < hitN; ++i ){
			addForce( hitArray[ i ].mI0, hitArray[ i ].mI1 );
		}
		//n
		for ( list< HitPair* >::iterator i = hitList.begin(); i != hitList.end(); ++i ){
			SAFE_DELETE_ARRAY( *i );
		}
		SAFE_DELETE_ARRAY( hitArray );
	}
	//n
	SAFE_DELETE_ARRAY( boxArray );
	SAFE_DELETE_ARRAY( boxListSize );
	SAFE_DELETE_ARRAY( boxListOffset );
	for ( list< ObjPair* >::iterator i = boxList.begin(); i != boxList.end(); ++i ){
		SAFE_DELETE_ARRAY( *i );
	}


#else //foOp
	for ( int i = 0; i < N*N; ++i ){
		for ( int j = i + 1; j < N*N; ++j ){
			++( *test );
			if ( testCircles( i, j ) ){
				++( *hit );
			}
		}
	}
#endif
}

//----------------------牺̖͂̏͂{؂ł͂ȂR[h---------------------------

//2circle钆gBtrue
bool testCircles( int i0, int i1 ){
	Circle& c0 = gCircles[ i0 ];
	const Vector2& p0 = c0.mPosition;
	Circle& c1 = gCircles[ i1 ];
	const Vector2& p1 = c1.mPosition;
	//́H
	Vector2 t;
	t.setSub( p1, p0 );
	double sql = t.squareLength();
	if ( sql < RSUM2 ){ //a4ł
		return true;
	}else{
		return false;
	}
}

void addForce( int i0, int i1 ){
	Vector2 t;
	t.setSub( gCircles[ i0 ].mPosition, gCircles[ i1 ].mPosition );
	double l = t.length();
	t *= 0.25 / l; //Kɒ𒲐
	//͂ԂBtp0->p1̃xN^Ac1ɑAc0B
	gCircles[ i0 ].mVelocity += t;
	gCircles[ i1 ].mVelocity -= t;
}

namespace GameLib{
	void Framework::update(){
		if ( !gCircles ){
			gCircles = new Circle[ N*N ];
			//zu
			for ( int i = 0; i < N*N; ++i ){
				gCircles[ i ].mPosition.set( 
					static_cast< double >( ( ( i % N ) - N/2 ) * 4 ) + 0.001 * i, //Ƃ炷
					static_cast< double >( ( ( i / N ) - N/2 ) * 4 ) );
			}
		}
		//x
		for ( int i = 0;i < N*N; ++i ){
			//x_ŏ
			gCircles[ i ].mVelocity.setMul( gCircles[ i ].mPosition, -0.001 );
		}
		int test;
		int hit;
		processCollision( &test, &hit ); //Փˌo֐

		//XV
		for ( int i = 0;i < N*N; ++i ){
			gCircles[ i ].mPosition += gCircles[ i ].mVelocity;

			//`
			double p[ 4 ][ 2 ];
			p[ 0 ][ 0 ] = p[ 1 ][ 0 ] = gCircles[ i ].mPosition.x - 0.5 + 160.0;
			p[ 2 ][ 0 ] = p[ 3 ][ 0 ] = gCircles[ i ].mPosition.x + 0.5 + 160.0;
			p[ 0 ][ 1 ] = p[ 2 ][ 1 ] = gCircles[ i ].mPosition.y - 0.5 + 120.0;
			p[ 1 ][ 1 ] = p[ 3 ][ 1 ] = gCircles[ i ].mPosition.y + 0.5 + 120.0;
			drawTriangle2D( p[ 0 ], p[ 1 ], p[ 2 ] );
			drawTriangle2D( p[ 3 ], p[ 1 ], p[ 2 ] );
		}
		ostringstream oss;
		oss << frameRate() << " " << test << " " << hit;
		drawDebugString( 0, 0, oss.str().c_str() );
	}
}
