#include "GameLib/Framework.h"
#include "GameLib/DebugScreen.h"
#include "GameLib/Math/Vector2.h"
#include "GameLib/Math/Vector3.h"
#include "GameLib/Math/Matrix34.h"
#include "GameLib/Math/Matrix44.h"
#include "GameLib/Math/Functions.h"
#include "GameLib/Graphics/Manager.h"
#include "GameLib/Graphics/Texture.h"
#include "GameLib/Graphics/VertexBuffer.h"
#include "GameLib/Graphics/IndexBuffer.h"
#include "GameLib/Graphics/Vertex.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"
using namespace GameLib::Math;
using namespace GameLib::Graphics;

VertexBuffer gVertexBuffer;
IndexBuffer gIndexBuffer;
Texture gTexture;
int gCount;
GameLib::Graphics::LightingMode gLightingMode = GameLib::Graphics::LIGHTING_NONE;

namespace GameLib{
	//ConfigurationNXgďݒ肵Ă낤B
	void Framework::configure( Configuration* conf ){
		conf->setWidth( 640 );
		conf->setHeight( 480 );
		conf->forbidFullScreen( true );
		conf->enableFullScreen( false ); //tXN[[hN
		conf->enableVSync( false ); //n[hEFAɂt[[g艻
		conf->enableAntiAlias( false ); //WM[y鏈̗L
		conf->setTitle( "DrawCube Sample" ); //^Cgo[̕
	}
	void Framework::update(){
		using namespace Graphics;
		//xƂȂoĂ̂mꕶł邱Ƃė~
		Graphics::Manager m = Graphics::Manager::instance();
		if ( gCount == 0 ){ 
			m.setTextureFilter( TEXTURE_FILTER_POINT );
			//--------------_obt@-----------------------
			gVertexBuffer = VertexBuffer::create( 8 ); //8_̒_obt@
			Vertex* v = gVertexBuffer.lock(); //݃|C^𓾂
			//ʒu
			v[ 0 ].mPosition.set( -1.f, -1.f, -1.f );
			v[ 1 ].mPosition.set( -1.f, -1.f, 1.f );
			v[ 2 ].mPosition.set( -1.f, 1.f, -1.f );
			v[ 3 ].mPosition.set( -1.f, 1.f, 1.f );
			v[ 4 ].mPosition.set( 1.f, -1.f, -1.f );
			v[ 5 ].mPosition.set( 1.f, -1.f, 1.f );
			v[ 6 ].mPosition.set( 1.f, 1.f, -1.f );
			v[ 7 ].mPosition.set( 1.f, 1.f, 1.f );
			//@B΂߂ɏoĂ@ɂĂ݂B͂1
			v[ 0 ].mNormal.set( -0.57f, -0.57f, -0.57f );
			v[ 1 ].mNormal.set( -0.57f, -0.57f, 0.57f );
			v[ 2 ].mNormal.set( -0.57f, 0.57f, -0.57f );
			v[ 3 ].mNormal.set( -0.57f, 0.57f, 0.57f );
			v[ 4 ].mNormal.set( 0.57f, -0.57f, -0.57f );
			v[ 5 ].mNormal.set( 0.57f, -0.57f, 0.57f );
			v[ 6 ].mNormal.set( 0.57f, 0.57f, -0.57f );
			v[ 7 ].mNormal.set( 0.57f, 0.57f, 0.57f );
			//_J[(CeBǑʂ̂Ő^
			for ( int i = 0; i < 8; ++i ){
				v[ i ].mColor = 0xffffffff;
			}
			//eNX`W(K)
			v[ 0 ].mUv.set( 0.f, 0.f );
			v[ 1 ].mUv.set( 0.f, 1.f );
			v[ 2 ].mUv.set( 1.f, 0.f );
			v[ 3 ].mUv.set( 1.f, 1.f );
			v[ 4 ].mUv.set( 0.f, 0.f );
			v[ 5 ].mUv.set( 0.f, 1.f );
			v[ 6 ].mUv.set( 1.f, 0.f );
			v[ 7 ].mUv.set( 1.f, 1.f );
			//I
			gVertexBuffer.unlock( &v );

			//-------------CfNXobt@--------------------
			//3CfNXŎOp`Ȃ̂ŁACfNXobt@̃TCY͕3̔{ɂȂ
			gIndexBuffer = IndexBuffer::create( 36 ); //36_̃CfNXobt@
			unsigned short indices[ 36 ] = {
				0, 1, 3, 3, 2, 0,
				4, 6, 7, 7, 5, 4,
				0, 4, 5, 5, 1, 0,
				2, 3, 7, 7, 6, 2,
				7, 3, 1, 1, 5, 7,
				2, 6, 4, 4, 0, 2,
			};
			unsigned short* iBuffer = gIndexBuffer.lock();
			for ( int i = 0; i < 36; ++i ){
				iBuffer[ i ] = indices[ i ];
			}
			gIndexBuffer.unlock( &iBuffer );

			//-------------eNX`---------------------
			gTexture = Texture::create( "robo.tga" );
			while ( !gTexture.isReady() ){
				; //[h҂
			}
		}
		//gf[^w肷
		m.setVertexBuffer( gVertexBuffer );
		m.setIndexBuffer( gIndexBuffer );
		m.setTexture( gTexture );

		//At@uhȂǂȂǂݒ
		m.setBlendMode( BLEND_LINEAR );
		m.setCullMode( CULL_BACK ); //
		m.enableDepthTest( true );
		m.enableDepthWrite( true );
		m.setLightingMode( gLightingMode );

		//[hsݒ肷
		Matrix34 wm;
		wm.setRotationY( gCount * 0.09f );
		wm.rotateX( gCount * 0.08f );
		wm.rotateZ( gCount * 0.07f );
		//r[sݒ肷
		Matrix34 vm;
		Vector3 eyePosition( 
			4.f * sin( gCount * 0.01f ),
			0.f,
			4.f * cos( gCount * 0.01f ) );
		Vector3 eyeTarget( 0.f, 0.f, 0.f );
		Vector3 up( 0.f, 1.f, 0.f ); //uvw肷xN^BĉɌXB
		vm.setViewTransform( eyePosition, eyeTarget, up ); 

		//esݒ肷
		Matrix44 pm;
		pm.setPerspectiveTransform( 
			45.f, //45x
			static_cast< float >( width() ),
			static_cast< float >( height() ),
			1.f,
			1000.f );
		
		//sn[hEFAɓn
		pm *= vm; //ϊ~r[ϊ
		m.setProjectionViewMatrix( pm ); //ϊr[s
		m.setWorldMatrix( wm ); //[hs

		//CeBO̐ݒBKɔщ̋̃C[W
		Vector3 lightPositions[ 4 ];
		float lightIntensities[ 4 ];
		for ( int i = 0; i < 4; ++i ){
			//܂͈ʒu
			float phase = 90.f * static_cast< float >( i );
			float t = gCount * 0.025f + phase;
			lightPositions[ i ].x = 10.f * sin( t ) * sin( t );
			lightPositions[ i ].y = 10.f * sin( t ) * cos( t );
			lightPositions[ i ].z = 10.f * cos( t );
			lightIntensities[ i ] = 5.f;
		}
		//̐F͔AԁA΁AԁAɂĂ낤
		Vector3 lightColors[ 4 ];
		lightColors[ 0 ].set( 1.f, 1.f, 1.f );
		lightColors[ 1 ].set( 1.f, 0.f, 0.f );
		lightColors[ 2 ].set( 0.f, 1.f, 0.f );
		lightColors[ 3 ].set( 0.f, 0.f, 1.f );
		//ArGg͒n0.3炢
		Vector3 ambient( 0.3f, 0.3f, 0.3f );
		//͕̑̓B܂肶ĂdȂ̂ŌŒlŁB낢낢ČʂǂȂ邩Ă낤
		Vector3 diffuseColor( 1.f, 1.f, 1.f );
		Vector3 specularColor( 1.f, 1.f, 1.f );
		//ςƃnCCg̉sςBقǂ炴炵\ʂƂC[W
		float specularSharpness = 100.f;
		//Jʒu̐ݒ
		m.setEyePosition( eyePosition );
		//ł̓Cg̏ZbgĂ낤
		m.setAmbientColor( ambient );
		m.setDiffuseColor( diffuseColor );
		m.setSpecularColor( specularColor );
		m.setSpecularSharpness( specularSharpness );
		for ( int i = 0; i < 4; ++i ){
			m.setLightPosition( i, lightPositions[ i ] );
			m.setLightColor( i, lightColors[ i ] );
			m.setLightIntensity( i, lightIntensities[ i ] );
		}
		//͕`悷邾
		//͏ɃCfNXobt@̉ԖڂgA`A`B
		m.drawIndexed( 0, 12, PRIMITIVE_TRIANGLE );
		//̏ꍇAu0Ԗڂ12̎Op``vƂȂBgCfNX36B

		//ȉ̓Xy[XL[ŃCeBO؂ւR[hŁAǂłǂB
		if ( Input::Manager::instance().keyboard().isTriggered( ' ' ) ){
			if ( gLightingMode == LIGHTING_NONE ){
				gLightingMode = LIGHTING_PER_VERTEX;
			}else if ( gLightingMode == LIGHTING_PER_VERTEX ){
				gLightingMode = LIGHTING_PER_PIXEL;
			}else if ( gLightingMode == LIGHTING_PER_PIXEL ){
				gLightingMode = LIGHTING_NONE;
			}
		}
		DebugScreen ds = DebugScreen::instance();
		if ( gLightingMode == LIGHTING_NONE ){
			ds << "Lighting : NONE ( SPACE KEY TO CHANGE )";
		}else if ( gLightingMode == LIGHTING_PER_VERTEX ){
			ds << "Lighting : PER VERTEX ( SPACE KEY TO CHANGE )";
		}else if ( gLightingMode == LIGHTING_PER_PIXEL ){
			ds << "Lighting : PER PIXEL ( SPACE KEY TO CHANGE )";
		}
		++gCount;

		//Еt 
		if ( isEndRequested() ){
			//O[oɒuƏɂ͏Ȃ̂ŊJ
			gTexture.release();
			gIndexBuffer.release();
			gVertexBuffer.release();
		}
	}
}
