#ifndef INCLUDED_BULLET_H
#define INCLUDED_BULLET_H

namespace GameLib{
	namespace Math{
		class Matrix44;
		class Vector3;
	}
}
using namespace GameLib::Math;

class Model;
class GraphicsDatabase;

class Bullet{
public:
	Bullet();
	~Bullet();
	void create( 
		AutoPtr< GraphicsDatabase >&,
		const char* batchName,
		const Vector3& position,
		float angleX, 
		float angleY,
		bool homing );
	const Vector3* getPosition() const;
	void update( const Vector3& enemyPos ); 
	void draw() const;
	bool isEmpty() const; //gĂȂtrueBmCount<0Ŕ
	void die(); //e܂
private:
	AutoPtr< Model > mModel;
	int mCount; //-1Ȃ炻̒e͋󂾂ƂƂɂ悤B
	bool mHoming; //ǔH

	static const float mHomingX; //pxU\X
	static const float mHomingY; //pxU\Y
	static const int mLife; //e
	static const float mSpeed; //ȇx
};

#endif