#ifndef INCLUDED_ROBO_H
#define INCLUDED_ROBO_H

#include "GameLib/Math/Vector3.h"

namespace GameLib{
	namespace Math{
		class Matrix34;
		class Matrix44;
	}
}
using namespace GameLib::Math;

class GraphicsDatabase;
class Model;
class Bullet;

class Robo{
public:
	Robo( int id ); //ԍ炤BԂm肽̂ŁB
	~Robo();
	void draw() const;
	void update( Robo* robo );
	void setPosition( const Vector3& );
	void setAngleY( float );
	const Vector3* getPosition() const;
	void getView( Matrix34* matrix, Vector3* position ) const;
	void setDamage( int damage );
	int getHitPoint() const;
	int getEnergy() const;
	bool getLockOn() const;
	const Vector3* getBulletPosition( int i ) const;

	static const int mJumpUpTime; //㏸Ă
	static const int mJumpStayTime; //㏸㉺~܂ł̎
	static const int mJumpFallTime; //~ɂ鎞
	static const int mMoveAccelEndCount; //n߂ĉI܂ł̎
	static const float mMaxMoveSpeed; //őړx
	static const float mJumpHeight; //ő卂x
	static const int mCameraDelayCount; //WvJn㉽t[œG̕
	static const float mCameraDistanceZ; //[g납ʂH
	static const float mCameraDistanceY; //낵
	static const float mCameraTargetDistanceZ; //_͉[gH
	static const float mTurnSpeed; //񑬓x
	static const int mMaxHitPoint; //őqbg|Cgz
	static const int mMaxEnergy; //|Cgől
	static const int mEnergyPerBullet; //ꔭ̏GlM[
	static const int mEnergyCharge; //t[܂GlM[
	static const float mLockOnAngleIn; //bNIpx
	static const float mLockOnAngleOut; //bNIpx
private:
	void move( bool left, bool right, bool up, bool down );
	void turn( bool left, bool right );
	//vl[`B{^͂ԂBvC[LȂ炽͂邾
	void think( bool* jump, bool* fire, bool* turn, bool* left, bool* right, bool* up, bool* down ) const;

	Vector3 mPosition;
	float mAngleY;
	int mId;
	AutoPtr< GraphicsDatabase > mDatabase;
	AutoPtr< Model > mModel;
	
	Array< Bullet > mBullets;
	int mBulletNumber;

	int mCameraCount;
	int mCount; //ړJn㉽t[oH
	Vector3 mVelocity; //݂̕ʑx
	float mAngleVelocityY; //Ux


	enum Mode{
		MODE_JUMP_UP, //Wv㏸
		MODE_JUMP_STAY, //WvŒ~
		MODE_JUMP_FALL, //Wv~
		MODE_ON_LAND, //nĂ
	};
	Mode mMode;

	int mHitPoint; //̗
	int mEnergy; //̂ɕKvȃGlM[
	bool mLockOn; //bNIĂ܂H
};

#endif
