#ifndef INCLUDED_GAMELIB_FRAMEWORK_H
#define INCLUDED_GAMELIB_FRAMEWORK_H

#include <string>
using namespace std;

namespace GameLib{

namespace Graphics{
	class Texture;
}

namespace Math{
	class Vector3;
	class Vector2;
	class Matrix44;
}

class Framework{
public:
	enum LoadMode{
		LOAD_ARCHIVE_FIRST,
		LOAD_DIRECT_FIRST,
		LOAD_ARCHIVE_ONLY,
	};
	class Configuration{
	public:
		///ݒ
		void setWidth( int );
		///ݒ
		void setHeight( int );
		///EBhE^Cgݒ
		void setTitle( const char* title );
		///Lݒ
		void enableVSync( bool = true );
		///tXN[A`GCAXݒ
		void enableAntiAlias( bool = true );
		///ÑtXN[tOݒ
		void enableFullScreen( bool = true );
		///tXN[֎~
		void forbidFullScreen( bool = true );
		///hbOAhhbvL
		void enableDragAndDrop( bool = true );
		///A[JCu
		void setArchiveNumber( int );
		///A[JCuݒ
		void setArchiveName( int index, const char* );
		///[h[hݒ
		void setLoadMode( LoadMode );
		///t@C[h
		void loadFile( string* out, const char* filename ) const;
		///R}hCIvV擾
		const char* commandLineString() const;
		///HALT,ASSERTőɗO𓊂@\̗LB蕨ɑR[h͓ȂAƂl̂߂̂́B
		void enableThrowWhenHalt( bool = true );
		///ǉXbhݒ
		void setExtraThreadNumber( int );
	};
	Framework();
	///CX^X擾
	static Framework instance();

	///[U`֐BȂƃNG[
	void configure( Configuration* );
	///[U`֐B̒łȂɂ
	void update(); 

	///tXN[tOݒB
	void enableFullScreen( bool );
	///ʕ擾
	int width() const;
	///ʍ擾
	int height() const;
	///Av擾
	const char* title() const;
	///tXN[łH
	bool isFullScreen() const;
	///tXN[͋֎~Ă܂H
	bool isFullScreenForbidden() const;
	///hbOAhhbv͗LłH
	bool isDragAndDropEnabled() const;
	///FrameworkɏI߂o
	void requestEnd();
	///FrameworkɏI߂oĂ邩ׂ
	bool isEndRequested() const;
	///擾(~bP)
	unsigned time() const;
	///t[[g擾
	int frameRate() const;
	///t[[gݒ(ő҂[v񂵂Ă)
	void setFrameRate( int );
	///Ot[Ԏ擾(~bP)
	int previousFrameInterval() const;

	//ȉCugp҂͒mȂĂ
	void start( void* windowHandle );
	void preUpdate();
	void postUpdate();
	static void create();
	static void destroy();
};

} //namespace GameLib

//x[XT[rXL
#include "GameLib/GameLib.h"

#endif
