#ifndef INCLUDED_GAMELIB_FRAMEWORK_H
#define INCLUDED_GAMELIB_FRAMEWORK_H

namespace GameLib{

class Texture;

class Framework{
public:
	Framework();
	///[U`֐BB
	void update();
	///CX^X擾
	static Framework instance();
	///ʕ擾
	int width() const;
	///ʍ擾
	int height() const;
	///FrameworkɏI߂o
	void requestEnd();
	///FrameworkɏI߂oĂ邩ׂ
	bool isEndRequested() const;
	///擾(~bP)
	unsigned time() const;
	///t[[g擾
	int frameRate() const;
	///t[[gݒ(ő҂[v񂵂Ă)
	void setFrameRate( int );
	///Ot[Ԏ擾(~bP)
	int previousFrameInterval() const;
	///_Qbg
	int getRandom( int max = 0 );
	//
	void drawDebugString( 
		int column, //(x)
		int row, //s(y)
		const char* string, 
		unsigned color = 0xffffffff );
	///Op``BWŗ^̂ŁAp4vfBt2vfB
	void drawTriangle3DH(
		const double* p0,
		const double* p1,
		const double* p2,
		const double* t0 = 0,
		const double* t1 = 0,
		const double* t2 = 0,
		unsigned c0 = 0xffffffff,
		unsigned c1 = 0xffffffff,
		unsigned c2 = 0xffffffff );
	//eNX`
	void createTexture(
		Texture** textureOut,
		const char* filename );
	//eNX`j
	void destroyTexture( Texture** );
	//eNX`Zbg
	void setTexture( const Texture* );
	//eNX`̃TCY𒲂ׂ
	void getTextureSizes( const Texture*, int* width, int* height, int* originalWidth, int* originalHeight );
	//uh[h
	enum BlendMode{ 
		BLEND_LINEAR,
		BLEND_ADDITIVE,
		BLEND_OPAQUE,
	};
	void setBlendMode( BlendMode );
	void enableDepthTest( bool );
	void enableDepthWrite( bool );

	//ȉCugp҂͒mȂĂ
	void start( void* windowHandle );
	void preUpdate();
	void postUpdate();
	static void create();
	static void destroy();
};

} //namespace GameLib

#include "GameLib/GameLib.h"

#endif
