#include "StdAfx.h"
#include "GameLib/GameLib.h"
#include "GameLib/Base/Compressor.h"

#define OPTIMIZATION //ꂪONƍŁBOFFƔnŁB

namespace GameLib{

namespace {

//rbg蓖Ē萔
const int DIC_BITS = 11; //ʒubit
//ȉvZ萔
const int LENGTH_BITS = 16 - 1 - DIC_BITS; //
const int DIC_MASK = ( 1 << DIC_BITS ) - 1;
const int DIC_MASK_HIGH = DIC_MASK & 0xffffff00; //8bitԂ
const int DIC_MASK_SHIFTED = ( DIC_MASK >> 8 ) << LENGTH_BITS; 
const int LENGTH_MASK = ( 1 << LENGTH_BITS ) - 1;
const int DIC_SIZE = DIC_MASK + 1; //TCY(1Ċi[֌W1g)
const int MAX_LENGTH = LENGTH_MASK + 3; //őv(3Ċi[֌W3g)

//悭gŏlƍől
inline int min( int a, int b ){
	return ( a < b ) ? a : b;
}

inline int max( int a, int b ){
	return ( a > b ) ? a : b;
}

#ifdef OPTIMIZATION
/*
@́AɈ肻Ȃ炢PȂ݂ɗ}Ał\B
ɂāAua͂vub͂vƂ悤ȕ\B
0-255܂ł256ނ̕ɂāAꂼoXgĂB
TabcȂan܂̂ŁAaꏊXgTāA
猟n߂BałȂꏊ͖邽߁AU΂ĂΑȂB

Node,IndexNX͂̂߂̕\\NXŁA
Xg̊eGgNodeANodeǗ\ŜIndexNXƂȂB
NodeĂmPosA̕ꏊ\Bꏊ̓t@CŜ̒ł̈ʒuŁA
ł̈ʒuł͂ȂB
*/

class Node{
public:
	int mNext;
	int mPrev;
	int mPos; //t@C̈ʒu
};

class Index{ //DIC_SIZEԂ܂łgpm[hB̌256̓_~[wbhBDIC_SIZE+cƂ̂́AcƂ̃Xg̃wbhÄӖB
public:
	Index(){
		//_~[wbh̏Bnext,prev͎w悤ɏ
		for ( int i = DIC_SIZE; i < ( DIC_SIZE + 256 ); ++i ){
			mNodes[ i ].mNext = mNodes[ i ].mPrev = i;
		}
		//󂢂ĂꏊL^X^bN̏BDIC_SIZE܂ŁB
		for ( int i = 0; i < DIC_SIZE; ++i ){
			mStack[ i ] = i;
		}
		mStackPos = DIC_SIZE;
	}
	int getFirst( unsigned char c ) const {
		return mNodes[ DIC_SIZE + c ].mNext;
	}
	const Node* getNode( int i ) const {
		return &mNodes[ i ];
	}
	//擪ɑBV̂قǑΏۂɂȂB
	void add( unsigned char c, int pos ){
		--mStackPos;
		int newIdx = mStack[ mStackPos ];
		Node* newNode = mNodes + newIdx;
		Node* head = &mNodes[ DIC_SIZE + c ];
		newNode->mNext = head->mNext;
		newNode->mPrev = DIC_SIZE + c;
		newNode->mPos = pos;
		mNodes[ head->mNext ].mPrev = newIdx;
		head->mNext = newIdx;
	}
	//TďB͈̂ԍŏadd̂Ȃ̂ŁA΂ɖɂB
	//܂AXg񂷕Kv͂ȂB
	void remove( unsigned char c, int pos ){
		int idx = mNodes[ DIC_SIZE + c ].mPrev;
		Node* n = &mNodes[ idx ];
		ASSERT( n->mPos == pos ); //΂ɂɂ͂ŁȀȂ΃oOB
		mStack[ mStackPos ] = mNodes[ n->mPrev ].mNext; //폜
		++mStackPos;
		mNodes[ n->mPrev ].mNext = n->mNext;
		mNodes[ n->mNext ].mPrev = n->mPrev;
	}
	bool isEnd( int idx ) const { //_~[wbhǂԂBDIC_SIZEȏȂ_~[B
		return ( idx >= DIC_SIZE );
	}
private:
	Node mNodes[ DIC_SIZE + 256 ];
	int mStack[ DIC_SIZE ];
	int mStackPos;
};

#endif //OPTIMIZATION

} //namespace{}

/*
kBLZ77B

k̈2oCgŁAʒuƒɕzĂB
1oCg : 0x80+TCY+ʒȕʃrbgA
2oCg : ʒủ8bitB
񈳏k̈́A񈳏k̈TCYA񈳏k(1128)

k̈́AʒuA-3i[ĂB
WJ͎oĂ3𑫂B
񈳏k̈͒-1ĂAoɂ+1B
*/

void Compressor::compress(
Array< char >* oDataSigned,
int* inPlaceDecompressionBufferSize,
const char* iDataSigned,
int iSize ){
	int worstSize = iSize + ( iSize / 128 ) + 1; //ňTCYvZBꂾmہB+1͏_ȉ؂グB
	oDataSigned->setSize( worstSize );

	unsigned char* oData = reinterpret_cast< unsigned char* >( &( *oDataSigned )[ 0 ] );
	const unsigned char* iData = reinterpret_cast< const unsigned char* >( iDataSigned );

	int oPos = 0; //ݑ̏ވʒu
	int i = 0;
	int unmatchBegin = 0; //v̈̊Jnʒu
#ifdef OPTIMIZATION
	Index index;
#endif
	while ( i < iSize ){
		//猟
		int matchLength = 0;
		int matchPos = 0;
		//̐擪TĂBjizȂB
		//ő匟
		int maxL = min( MAX_LENGTH, iSize - i ); //t@C͌łȂ̂ŁAmaxL𐧌B
#ifdef OPTIMIZATION
		//Jn ꕶڂT
		int idx = index.getFirst( iData[ i ] );
		while ( !index.isEnd( idx ) ){
			const Node* n = index.getNode( idx );
			int p = n->mPos;
			//v𒲂ׂ
			int l = 1; //1vԂn߂B
			while ( l < maxL ){
				//̕}b`ȂΏI
				if ( iData[ p + l ] != iData[ i + l ] ){
					break;
				}
				++l; //1
			}
			//O蒷vȂL^Bȃ}b`̎d͂Aő̂̂L^B
			if ( matchLength < l ){
				matchPos = p;
				matchLength = l;
				if ( matchLength == maxL ){ //vőɂȂ炻ŏIB
					break;
				}
			}
			idx = n->mNext;
		}
		//āAv3ȏ゠Έk[hŋL^B
		if ( matchLength >= 3 ){
			//XVBāABi񂾕폜āAi񂾕B
			for ( int j = 0; j < matchLength; ++j ){
				int delPos = i + j - DIC_SIZE;
				if ( delPos >= 0 ){
					index.remove( iData[ delPos ], delPos );
				}
				index.add( iData[ i + j ], i + j );
			}
			//񈳏kwb_
			if ( unmatchBegin < i ){
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
			}
			//kL^
			int wl = matchLength - 3; //3Ċi[
			int wp = i - matchPos - 1; //1Ċi[
			int tmp = 0x80 | wl; //ɈktOǉ
			tmp |= ( wp & DIC_MASK_HIGH ) >> ( 8 - LENGTH_BITS ); //mask&ATCYɎgĂrbg̕炷B
			oData[ oPos + 0 ] = static_cast< unsigned char >( tmp );
			oData[ oPos + 1 ] = static_cast< unsigned char >( wp & 0xff );
			oPos += 2;
			i += matchLength;
			unmatchBegin = i; //vʒu͎
		}else{ //}b`ȂB݂͂܂Ƃ߂Ă̂ŁA͐i߂B
			//XVBāAB
			int delPos = i - DIC_SIZE;
			if ( delPos >= 0 ){
				index.remove( iData[ delPos ], delPos );
			}
			index.add( iData[ i ], i );
			++i;
			if ( i - unmatchBegin == 128 ){ //E܂Ă܂B
				//񈳏kwb_
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
				unmatchBegin = i;
			}
		}
#else //n
		//̐擪B
		int dicBegin = max( i - DIC_SIZE, 0 ); //0Oɂ͂ȂȂƂɒӁBmax()g
		for ( int j = dicBegin; j < i; ++j ){ //ȂÃ[v̒gvZ̑唼߂ĂB邱ƂKvɂȂ邪A\ςƎvB
			//v𒲂ׂ
			int l = 0;
			while ( l < maxL ){ //j<iŁAi+l<sizeInBāAj+l<sizeInŁA͈͓ɓBj+l>=i͂肤B܂A͂ݏoČ邱Ƃ͂肤BAł̂B}`Ēׂ悤B
				//̕}b`ȂΏI
				if ( iData[ j + l ] != iData[ i + l ] ){
					break;
				}
				++l; //1
			}
			//O蒷vȂL^Bȃ}b`̎d͂Aő̂̂L^B
			if ( matchLength < l ){
				matchPos = j;
				matchLength = l;
				if ( matchLength == maxL ){ //vőɂȂ炻ŏIB
					break;
				}
			}
		}
		//āAv3ȏ゠Έk[hŋL^B
		if ( matchLength >= 3 ){
			if ( unmatchBegin < i ){
				//񈳏kwb_
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
			}
			//kL^
			int wl = matchLength - 3; //3Ċi[
			int wp = i - matchPos - 1; //1Ċi[
			int tmp = 0x80 | wl; //ɈktOǉ
			tmp |= ( wp & DIC_MASK_HIGH ) >> ( 8 - LENGTH_BITS ); //mask&ATCYɎgĂrbg̕炷B
			oData[ oPos + 0 ] = static_cast< unsigned char >( tmp );
			oData[ oPos + 1 ] = static_cast< unsigned char >( wp & 0xff );
			oPos += 2;
			i += matchLength;
			unmatchBegin = i; //vʒu͎
		}else{ //}b`ȂB݂͂܂Ƃ߂Ă̂ŁA͐i߂B
			++i;
			if ( i - unmatchBegin == 128 ){ //E܂Ă܂B
				//񈳏kwb_
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
				unmatchBegin = i;
			}
		}
#endif //OPTIMIZATION
	}

	//vʒucĂ΍Ō̏
	if ( unmatchBegin < i ){
		//񈳏kwb_
		oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
		++oPos;
		for ( int j = unmatchBegin; j < i; ++j ){
			oData[ oPos ] = iData[ j ];
			++oPos;
		}
	}
	//̏WJpǂʌvZ
	if ( inPlaceDecompressionBufferSize ){
		//zIɓWJĒׂBƂ肪񂾂ւ
		int wp = 0; //݃|C^
		int diff = 0; //݃|C^-ǂݍ݃|C^
		int i = 0;
		int bufferSize = max( iSize, oPos ); //LтĂ܂oPosgB
		while ( i < oPos ){
			int length;
			if ( oData[ i ] & 0x80 ){ //k[h
				length = oData[ i ] & LENGTH_MASK;
				length += 3; //3ȂL^ĂB
				i += 2;
			}else{ //񈳏k[h
				length = oData[ i ] + 1; //1ȂL^Ă
				i += length + 1;
			}
			wp += length;
			diff = max( diff, wp - ( i + bufferSize - oPos ) );
		}
		*inPlaceDecompressionBufferSize = bufferSize + diff;
	}
	oDataSigned->setSize( oPos ); //܂Ă͂Ȃ̂ŏkB
}

//WJ͂ƂĂȒPłB
void Compressor::decompress( 
char* oDataSigned,
int* oSize,
const char* iDataSigned,
int iSize ){
	unsigned char* oData = reinterpret_cast< unsigned char* >( oDataSigned );
	const unsigned char* iData = reinterpret_cast< const unsigned char* >( iDataSigned );

	int oPos = 0;
	for ( int i = 0; i < iSize; ++i ){
		int length;
		if ( iData[ i ] & 0x80 ){ //k[h
			length = iData[ i ] & LENGTH_MASK;
			length += 3; //3ȂL^ĂB
			int position = ( ( iData[ i ] & DIC_MASK_SHIFTED ) << ( 8 - LENGTH_BITS ) ) | iData[ i + 1 ]; //GȂ̂ł悭čl悤
			position += 1; //1ȂL^ĂB
			for ( int j = 0; j < length; ++j ){
				oData[ oPos + j ] = oData[ oPos - position + j ]; //outڂ̂CȂAłɏout͎Ȃ̂łB
			}
			i += 1; //1oCg]ɐi߂ĂB
		}else{ //񈳏k[h
			length = iData[ i ] + 1; //1ȂL^Ă
			for ( int j = 0; j < length; ++j ){
				oData[ oPos + j ] = iData[ i + 1 + j ];
			}
			i += length; //قĂĂ1͑Bf[^lengthi߁ȂO1oCg͎Rɂ܂悤
		}
		oPos += length;
	}
	*oSize = oPos;
}

} //namespace GameLib