#include "StdAfx.h"
#ifdef _WIN32
#include <windows.h>
#undef min
#undef max
#endif

#include <cstring> //sprintfȂǂȂǁBgȂdȂB
#include "GameLib/Base/MemoryManager.h"

//#define STRONG_DEBUG //ĂlpfoO

#ifndef NDEBUG //foOfoO
#define USE_DEBUG_INFO
#endif

//̃t@C̒C++̃CugȂŏĂB
//̂ƌ΁AnewĂ΂ꏊȂ̂ɁAnew悤ȂƂ疳ċAɊׂ邩炾B
//C++̃Cu͒ŏneŵłǂgĂƂ͔f̂łB
//C̊֐͊{IɎgȂƏAǂĂgׂƂ̂͂̂B

namespace GameLib{

namespace{ //x蓮삷܂ł͂ĂBfoOɂĎdȂB

using namespace std;

//^ʖBR[hZB
typedef unsigned U4; //oCgʖ
typedef unsigned short U2; //2oCgʖ

//ݒ萔Q
const U4 MAX_NORMAL_BLOCK_SIZE = 128 * 1024; //ȏVirtualAllocŒڊm
const U4 HEAP_REGION_SIZE_BIT = 24; //OSCɂ߂̈TCY(Ⴆ201MB, 2416MB)
const U4 ALIGN = 8; //ACTCY4,8,16肩IڂB4IԎdoubleȂƂۏႷ邱ƁB
//o萔Q
const U4 HEAP_REGION_SIZE = ( 1 << HEAP_REGION_SIZE_BIT );
const U4 TABLE_NUMBER = ( HEAP_REGION_SIZE_BIT - 3 ) * 4; //󂫃Xg̐(4Ƃɔ{ɂȂ̂ŃTCYrbg4{A4,8,12,16Ǝn܂邽߁A낢날-3)

//ubNtO
/*
łubNm肽̂́ABƂAgpɌ܂ĂB
A󂩂ǂm肽̂HeapƂ킩Ă炾Arbgg܂킷B
*/
const U4 FLAG_LARGE_BLOCK = ( 1 << 0 ); //łubNłB
const U4 FLAG_EMPTY = ( 1 << 0 ); //󂢂Ă܂B
const U4 FLAG_PREV_EMPTY = ( 1 << 1 ); //ÕubN͋󂫂ł
const U4 SIZE_MASK = ~( FLAG_PREV_EMPTY | FLAG_EMPTY );

#ifdef USE_DEBUG_INFO
//t@CnbV
/*
foOp̃t@ĆAO[oϐɂ܂Ƃ߂ĒuĂB4oCgɂ񂾂߂B
*/
const U2 FILE_INDEX_MAX = 65521; //65536ȉő̑f
const U2 FILE_INDEX_UNKNOWN = FILE_INDEX_MAX - 1;
const char* gFileNames[ FILE_INDEX_MAX ];

U2 getFileNameIndex( const char* p ){
	if ( !p ){
		return FILE_INDEX_UNKNOWN;
	}
	//nbVlvZ
	ptrdiff_t address = p - static_cast< const char* >( 0 );
	U2 h = static_cast< U2 >( address % FILE_INDEX_MAX );
	//nbVlY̏lƂăCfNXQbg
	for ( U2 i = h; i < FILE_INDEX_UNKNOWN; ++i ){
		if ( !gFileNames[ i ] || ( gFileNames[ i ] == p ) ){
			gFileNames[ i ] = p;
			return i;
		}
	}
	//ɗ悤ƑIĂBԂ񖞑ȑxł͓ȂB
	for ( U2 i = 0; i < h; ++i ){
		if ( !gFileNames[ i ] || ( gFileNames[ i ] == p ) ){
			gFileNames[ i ] = p;
			return i;
		}
	}
	STRONG_ASSERT( false && "MemoryManager : FileName Table Full!" );
	return FILE_INDEX_UNKNOWN;
}
#endif //DEBUG_INFO

//char*Qbg
template< class T > inline char* ptr( T* p ){
	return reinterpret_cast< char* >( p );
}

//Cӂ̌^ɃLXgĕԂBoCgPʃItZbg@\t
template< class T > inline T* cast( void* p, int offsetInByte ){
	return reinterpret_cast< T* >( ptr( p ) + offsetInByte );
}

//AhXQbg
template< class A, class B > inline U4 diff( A* p0, B* p1 ){
	ptrdiff_t t = ptr( p0 ) - ptr( p1 );
	return static_cast< U4 >( t );
}

//|C^AC
template< class T > inline T* align( T* p, U4 n ){
	ptrdiff_t address = ptr( p ) - static_cast< char* >( 0 );
	address += n - 1;
	address &= ~( n - 1 );
	return reinterpret_cast< T* >( address );
}

//AC
inline U4 align( U4 size, U4 n ){
	size += n - 1;
	size &= ~( n - 1 );
	return size;
}

#ifdef _WIN32
//OSACꂽ炤
void* allocateAlignedMemory( void** originalPointer, U4 size, U4 alignSize ){
	//2{AhX\
	void* reserved = VirtualAlloc( NULL, size*2, MEM_RESERVE, PAGE_NOACCESS );
	STRONG_ASSERT( reserved && "MemoryManager : Address Space Full!" );
	//K؂ȃACAhX擾āÄm
	void* aligned = align( reserved, alignSize );
	void* commited = VirtualAlloc( aligned, size, MEM_COMMIT, PAGE_READWRITE );
	STRONG_ASSERT( commited && "MemoryManager : No Memory!" );
	STRONG_ASSERT( ( commited == aligned ) && "MemoryManager : Unexpected Error! VirtualAlloc() returned invalid value." );

	*originalPointer = reserved; //freepAhXԂ
	return commited;
}

//OS烁炤BACsv
void* allocateMemory( U4 size ){
	U4 alignedSize = align( size, 64 * 1024 );
	void* p = VirtualAlloc( NULL, alignedSize , MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );
	STRONG_ASSERT( p && "MemoryManager : No Memory!" );
#ifndef NDEBUG //
	memset( p, 0xfb, size ); //gp̈}[LO
	if ( size < alignedSize ){ //֎~̈}[LO
		memset( ptr( p ) + size, 0xf9, alignedSize - size );
	}
#endif
	return p;
}

//OSɃԂ
void deallocateMemory( void* p ){
	BOOL succeeded = VirtualFree( p, 0, MEM_RELEASE );
	STRONG_ASSERT( ( succeeded != 0 ) && "MemoryManager : Deallocation failed! The pointer must be invalid." );
}
#endif

struct Lock{
	Lock(){} //ftHgRXgN^͉ȂBO[oɒu鎖Ԃz肷B
	Lock( bool f ){
		mLock = ( f ) ? 1 : 0;
	}
	void lock(){
		//񂩎ă_ȂUXbh؂ւB
		int count = 0;
		while ( InterlockedCompareExchange( &mLock, 1, 0 ) != 0 ){
			++count;
			if ( count == 10 ){ //10񂭂炢H
				count = 0;
				Sleep( 0 );
			}
		}
	}
	bool tryLock(){
		return ( InterlockedCompareExchange( &mLock, 1, 0 ) == 0 );
	}
	void unlock(){
		InterlockedCompareExchange( &mLock, 0, mLock );
	}
	LONG mLock;
};

U4 getBitNumber( U4 a ){
	//񕪌Ńrbgm
	U4 first = 0;
	U4 last = HEAP_REGION_SIZE_BIT;
	while ( last >= first + 2 ){ //2ȏ゠ΌJԂ
		U4 middle = ( first + last ) / 2;
		U4 middleV = ( 1 << middle ) - 1;
		if ( middleV < a ){
			first = middle;
		}else if ( middleV > a ){
			last = middle;
		}else{
			first = last = middle;
		}
	}
	//01ɂȂĂ̂ŁAlastԂB
	return last;
}

inline U4 getHeadIndex( U4 size ){
	U4 r;
	//e[u
	//ŏ84iB(0,4,8...)B؎̂āB
	//32,40,48,56̂悤4Ƃɔ{B
	if ( size <= 32 ){	//32oCg܂ł͐`B4,8,12...ƕ
		r = size >> 2;
	}else{
		//܂sizerbg̐Ȃ̂m肳B
		U4 bits = getBitNumber( size );
		//4bit̐ȂA[2bit*5, 2bit*8)͈̔͂ɂB
		//8-9,10-11,12-13,14-15̂ǂ͈̔͂́A12rbgځA܂24̈ʂ΂B
		//4bit̐Ȃ1bitEVtg0-7ɂẢ2bit
		U4 idx = ( size >> ( bits - 3 ) ) & 0x3;
		r = ( bits - 4 ) * 4 + idx;
	}
	return r;
}

//[Lb]LargeBlock̗
class Heap{
public:
	Heap( void* reserved ) :
	mReserved( reserved ),
	mNext( 0 ),
	mLock( false ){
		//ŏ̂łubNB-4prevSizeP`ĂBŏ̃ubNOȂĂȂ炾B
		U4 body = align( sizeof( Heap ) + VACANT_HEADER_SIZE - 4, ALIGN ) - VACANT_HEADER_SIZE;
		U4 bodySize = HEAP_REGION_SIZE - body - 8; //8oCg炷̂́ÃubNɖ菑4oCgƁAtOZbg鎟4{oCg̕B

		//N
		for ( int i = 0; i < TABLE_NUMBER; ++i ){
			U4 headAddr = diff( mHeads[ i ], this );
			U4* head = mHeads[ i ];
			head[ PREV_SIZE ] = head[ SIZE ] = 0xffffffff; //NȂƂȂ̂ŎɂȐĂB
			head[ NEXT ] = head[ PREV ] = headAddr; //[v
		}
		//ŏ̃obt@Xgɑ}
		insertToList( body, bodySize );
		setEmptySize( body, bodySize );
		U4 next = body + bodySize;
		setPrevEmptyFlag( next, bodySize );
#ifdef STRONG_DEBUG
check();
#endif
	}
	static Heap* create(){
		void* reserved;
		Heap* r = reinterpret_cast< Heap* >( allocateAlignedMemory( &reserved, HEAP_REGION_SIZE, HEAP_REGION_SIZE ) );

		//̃o𖄂߂
		new( r ) Heap( reserved );
		return r;
	}
	void removeFromList( U4 addr ){
		if ( getSize( addr ) >= VACANT_HEADER_SIZE ){ //TCYĂȂ̂͒xJB
			U4 next = getNext( addr );
			U4 prev = getPrev( addr );
			setPrev( next, prev );
			setNext( prev, next );
		}
	}
	void insertToList( U4 addr, U4 size ){
		STRONG_ASSERT( addr < 0xfffff8 );
		U4 index = getHeadIndex( size - OCCUPYED_HEADER_SIZE + 4 );//wb_āA4oCg̃ubNɐHނ̂ŁÃTCYB
		//VXgɍށB擪ɑ}
		U4 first = mHeads[ index ][ NEXT ];
		U4 last = getPrev( first );

		setNext( last, addr );
		setPrev( addr, last );
		setNext( addr, first );
		setPrev( first, addr );
	}

#ifdef USE_DEBUG_INFO
	void* allocate( U4 size, U4 debugInfo ){
#else
	void* allocate( U4 size ){
#endif
#ifdef STRONG_DEBUG
check();
#endif
		void* r = 0;
		U4 headIndex = getHeadIndex( size ) + 1; //̃TCY\ɓ锠~̂ŁA+1Kv
		for ( U4 i = headIndex; i < TABLE_NUMBER; ++i ){
			U4 head = diff( mHeads[ i ], this );
			U4 current = mHeads[ i ][ NEXT ];
			if ( current != head ){
				U4 currentSizeWithFlag = getSize( current );
				U4 currentSize = currentSizeWithFlag & SIZE_MASK;
				U4 next = current + currentSize;
				//8oCgAC߂AhXvZ(+4͎̃wb_̍ŏ4oCgj󂷂C)
				U4 user = ( next + 4 - size ) & ~( ALIGN - 1 );
				//gpwb_TCŶubN擪AhX
				U4 newBlock = user - OCCUPYED_HEADER_SIZE;
				//̃ubÑwb_ȏ̂̂ł΁A
				if ( newBlock >= current + VACANT_HEADER_SIZE ){
					//܂XgO
					removeFromList( current );
					//̃TCYĐݒ
					currentSize = newBlock - current;
					setEmptySize( current, currentSize );
					//Đݒ肵TCYŃXgɍēo^
					insertToList( current, currentSize );
					//VubNݒ
					setSize( newBlock, next - newBlock );
#ifdef USE_DEBUG_INFO
					setDebugInfo( newBlock, debugInfo );
#endif
					//tOݒ
					setPrevEmptyFlag( newBlock, currentSize ); //O͐΋󂢂Ă
					resetPrevEmptyFlag( next ); //͎̎gĂ
#ifdef STRONG_DEBUG
check();
#endif
				}else{ //cȂB̃ubN̂܂ܗpB
					removeFromList( current ); //Xg؂藣
#ifdef USE_DEBUG_INFO
					setDebugInfo( current, debugInfo );
#endif
					//tOݒ
					resetEmptyFlag( current ); //󂢂ĂȂ
					resetPrevEmptyFlag( next ); //󂢂ĂȂƂ`
					//ԋpAhX
					user = current + OCCUPYED_HEADER_SIZE;
#ifdef STRONG_DEBUG
check();
#endif
				}
				r = ptr( this ) + user;
#ifndef NDEBUG //foOphԂ
				memset( r, 0xfb, size ); //gpfb
				char* paddingBegin = ptr( r ) + size;
				U4 paddingSize = next + 4 - user - size; //+4݂͂͂
				memset( paddingBegin, 0xf9, paddingSize ); //gp֎~̈f9
#endif
				break; //mۏI
			}
		}
		return r;
	}
	void deallocate( void* p ){
#ifdef STRONG_DEBUG
check();
#endif
		U4 addr = diff( p, this ) - OCCUPYED_HEADER_SIZE;
		U4 sizeWithFlag = getSize( addr );
		//폜́A܂OƂ̗Z\ǂ𒲂ׂB
		bool prevIsEmpty = ( ( sizeWithFlag & FLAG_PREV_EMPTY ) != 0 );
		U4 size = ( sizeWithFlag & SIZE_MASK );
		U4 next = addr + size;
#ifndef NDEBUG 
		//t߂̐`FbN
		if ( prevIsEmpty ){
			U4 prevSize = getPrevSize( addr );
			U4 prev = addr - prevSize;
			U4 prevSizeWithFlag = getSize( prev );
			STRONG_ASSERT( prevSizeWithFlag & FLAG_EMPTY );
			STRONG_ASSERT( prevSize == ( prevSizeWithFlag & SIZE_MASK ) );
		}
		U4 nextSizeWithFlagDebug = getSize( next );
		STRONG_ASSERT( !( nextSizeWithFlagDebug & FLAG_PREV_EMPTY ) ); //gĂ񂾂󂢂Ă킯ȂłB

		//ς݃}[NœhԂ
		ptrdiff_t fillSize = ptr( this ) + next - ptr( p );
		if ( fillSize > 0 ){
			memset( p, 0xfd, fillSize ); //gpς݂fb
		}
#endif
		U4 nextSizeWithFlag = getSize( next );
		bool nextIsEmpty = ( ( nextSizeWithFlag & FLAG_EMPTY ) != 0 );
		U4 nextSize = ( nextSizeWithFlag & SIZE_MASK );

		if ( prevIsEmpty ){ //O󂢂ĂB
			U4 prevSize = getPrevSize( addr );
			U4 prev = addr - prevSize;
			if ( nextIsEmpty ){ //󂢂Ă
				//OƂOāA
				removeFromList( prev );
				removeFromList( next );
				//TCYĐݒ
				prevSize += size + nextSize;
				setEmptySize( prev, prevSize );
				insertToList( prev, prevSize );
				//̃ubNɋ󂢂Ă邱Ƃ`
				U4 nextNext = prev + prevSize;
				setPrevEmptyFlag( nextNext, prevSize );
#ifdef STRONG_DEBUG
check();
#endif
			}else{ //O󂢂Ă
				removeFromList( prev );
				//TCYĐݒ
				prevSize += size;
				setEmptySize( prev, prevSize );
				insertToList( prev, prevSize );
				//̃ubNɋ󂢂Ă邱Ƃ`
				setPrevEmptyFlag( next, prevSize );
#ifdef STRONG_DEBUG
check();
#endif
			}
		}else{
			if ( nextIsEmpty ){ //󂢂Ă
				removeFromList( next );
				//TCYĐݒ
				size += nextSize;
				setEmptySize( addr, size );
				insertToList( addr, size );
				//̃ubNɋ󂢂ĂTCY`
				U4 nextNext = addr + size;
				setPrevSize( nextNext, size );
#ifdef STRONG_DEBUG
check();
#endif
			}else{ //ĂȂB
				if ( size >= VACANT_HEADER_SIZE ){ //XgɂȂ󋵂łȂBȂƂׂ͗̂҂B
					insertToList( addr, size );
				}
				setEmptyFlag( addr );
				//̃ubNɋ󂢂Ă邱Ƃ`
				setPrevEmptyFlag( next, size );
#ifdef STRONG_DEBUG
check();
#endif
			}
		}
	}
	void check(){
		/*
		ōs`FbŃA
		PDAhX̃`FbNBOTCYATCYAubNEX̐
		QDÑ`FbNB󂢂Ă邩BTCY͓KB
		RDN~̃`FbNB󂢂Ă邩BTCY͓KB
		*/
		U4 begin = align( sizeof( Heap ) + VACANT_HEADER_SIZE - 4, ALIGN ) - VACANT_HEADER_SIZE;
		U4 current = begin;
		U4 prevSizeCheck = 0;
		bool prevIsEmpty = false;
		U4 end = HEAP_REGION_SIZE - OCCUPYED_HEADER_SIZE; //OBłȂƃwb_͂
		while ( current < end ){
			U4 sizeWithFlag = getSize( current );
			if ( sizeWithFlag & FLAG_PREV_EMPTY ){
				STRONG_ASSERT( prevIsEmpty );
				U4 prevSize = getPrevSize( current );
				STRONG_ASSERT( prevSize == prevSizeCheck );
			}
			prevIsEmpty = ( sizeWithFlag & FLAG_EMPTY ) ? true : false;
			U4 size = sizeWithFlag & SIZE_MASK;
			current += size;
			prevSizeCheck = size;
		}
		for ( U4 i = 0; i < TABLE_NUMBER; ++i ){
			U4 head = diff( mHeads[ i ], this );
			U4 current;
			//N`FbN
			current = mHeads[ i ][ NEXT ];
			while ( current != head ){
				U4 sizeWithFlag = getSize( current );
				STRONG_ASSERT( sizeWithFlag & FLAG_EMPTY ); //󂢂Ă͂B
				U4 size = sizeWithFlag & SIZE_MASK;
				U4 idx = getHeadIndex( size - OCCUPYED_HEADER_SIZE + 4 );//wb_āA4oCg̃ubNɐHނ̂ŁÃTCYB
				STRONG_ASSERT( idx == i );
				current = getNext( current );
			}
			//N~`FbN
			current = mHeads[ i ][ PREV ];
			while ( current != head ){
				U4 sizeWithFlag = getSize( current );
				STRONG_ASSERT( sizeWithFlag & FLAG_EMPTY ); //󂢂Ă͂B
				U4 size = sizeWithFlag & SIZE_MASK;
				U4 idx = getHeadIndex( size - OCCUPYED_HEADER_SIZE + 4 );//wb_āA4oCg̃ubNɐHނ̂ŁÃTCYB
				STRONG_ASSERT( idx == i );
				current = getPrev( current );
			}
		}
	}
	void write( FILE* fp ){
		char str[ 8192 ];
		U4 begin = align( sizeof( Heap ) + VACANT_HEADER_SIZE - 4, ALIGN ) - VACANT_HEADER_SIZE;
		U4 current = begin;
		U4 end = HEAP_REGION_SIZE - OCCUPYED_HEADER_SIZE; //OBłȂƃwb_͂
		while ( current < end ){
			U4 sizeWithFlag = getSize( current );
			U4 size = sizeWithFlag & SIZE_MASK;
			if ( !( sizeWithFlag & FLAG_EMPTY ) ){
#ifdef USE_DEBUG_INFO
				U4 debugInfo = getDebugInfo( current );
				const char* filename = gFileNames[ debugInfo & 0xffff ];
				U4 line = debugInfo >> 16;
#else
				const char* filename = 0;
				U4 line = 0;
#endif
				if ( !filename ){
					filename = "unknown";
				}
				int l = sprintf_s( 
					str, 
					8192,
					"%p\t\t%d\t\t%s\t\t%d\n",
					ptr( this ) + current,
					size,
					filename,
					line );
				if ( fp ){
					fwrite( str, 1, l, fp );
				}else{
					::OutputDebugStringA( str );
				}
			}
			current += size;
		}
	}
	void lock(){
		mLock.lock();
	}
	bool tryLock(){
		return mLock.tryLock();
	}
	void unlock(){
		mLock.unlock();
	}
	enum Header{
		PREV_SIZE = 0, //͑ÕubN󂢂Ă鎞BȊO͉̎󂳂ĂB
		SIZE = 1,
#ifdef USE_DEBUG_INFO
		DEBUG_INFO = 2, //ƋpB͎gpgȂB
#endif
		NEXT = 2,
		PREV = 3,

		HEADER_MAX = 4,
	};
#ifdef USE_DEBUG_INFO
	static const U4 OCCUPYED_HEADER_SIZE = 12;
#else
	static const U4 OCCUPYED_HEADER_SIZE = 8;
#endif
	static const U4 VACANT_HEADER_SIZE = 16;
	//܂܂Ƃwb_֐Q
	void setNext( U4 addr, U4 target ){
		( cast< U4 >( this, addr ) )[ NEXT ] = target;
	}
	void setPrev( U4 addr, U4 target ){
		( cast< U4 >( this, addr ) )[ PREV ] = target;
	}
	void setSize( U4 addr, U4 size ){
		( cast< U4 >( this, addr ) )[ SIZE ] = size;
	}
	void setEmptySize( U4 addr, U4 size ){
		( cast< U4 >( this, addr ) )[ SIZE ] = size | FLAG_EMPTY;
	}
	void setPrevSize( U4 addr, U4 size ){
		( cast< U4 >( this, addr ) )[ PREV_SIZE ] = size;
	}
	void setPrevEmptyFlag( U4 addr, U4 prevSize ){
		U4* p4 = cast< U4 >( this, addr );
		p4[ SIZE ] |= FLAG_PREV_EMPTY;
		p4[ PREV_SIZE ] = prevSize;
	}
	void setEmptyFlag( U4 addr ){
		( cast< U4 >( this, addr ) )[ SIZE ] |= FLAG_EMPTY;
	}
	void resetEmptyFlag( U4 addr ){
		( cast< U4 >( this, addr ) )[ SIZE ] &= ~FLAG_EMPTY;
	}
	void resetPrevEmptyFlag( U4 addr ){
		( cast< U4 >( this, addr ) )[ SIZE ] &= ~FLAG_PREV_EMPTY;
	}
	U4 getSize( U4 addr ){
		return ( cast< U4 >( this, addr ) )[ SIZE ];
	}
	U4 getPrevSize( U4 addr ){
		return ( cast< U4 >( this, addr ) )[ PREV_SIZE ];
	}
	U4 getNext( U4 addr ){
		return ( cast< U4 >( this, addr ) )[ NEXT ];
	}
	U4 getPrev( U4 addr ){
		return ( cast< U4 >( this, addr ) )[ PREV ];
	}
#ifdef USE_DEBUG_INFO
	void setDebugInfo( U4 addr, U4 debugInfo ){
		( cast< U4 >( this, addr ) )[ DEBUG_INFO ] = debugInfo;
	}
	U4 getDebugInfo( U4 addr ){
		return ( cast< U4 >( this, addr ) )[ DEBUG_INFO ];
	}
#endif
	void* mReserved; //\̈|C^
	Heap* mNext; //̃q[v
	U4 mHeads[ TABLE_NUMBER ][ HEADER_MAX ]; //TCYƂ̋󂫃Xg
	Lock mLock;
};

class Impl{
public:
#ifdef USE_DEBUG_INFO
	void* allocate( size_t sizeOrig, U4 debugInfo = FILE_INDEX_UNKNOWN ){
#else
	void* allocate( size_t sizeOrig ){
#endif
#ifdef _WIN64
		STRONG_ASSERT( sizeoOrig <= 0xffffffff && "allocation over 4GB is forbidden" );
#endif
		U4 size = static_cast< U4 >( sizeOrig ); //4GBȏ
		//߂l
		void* r = 0;
		//sizeE𒴂ĂBpubNp
		if ( size > MAX_NORMAL_BLOCK_SIZE ){
#ifdef USE_DEBUG_INFO
			r = allocateLb( size, debugInfo );
#else
			r = allocateLb( size );
#endif
		}else{
			//q[vallocate()B_Ȃ玟ցB
			Heap* current = mHead; //bNsvB0Ȃ0Ō\B0ȊOȂǂł܂B
			while ( current ){
				if ( current->tryLock() ){
#ifdef USE_DEBUG_INFO
					r = current->allocate( size, debugInfo );
#else
					r = current->allocate( size );
#endif
					current->unlock();
				}
				if ( r ){
					break;
				}
				current = current->mNext;
			}

			if ( !r ){
				//󂫂ȂBq[v𑫂ȂƂ܂B
				Heap* newHeap = Heap::create();
#ifdef USE_DEBUG_INFO
				r = newHeap->allocate( size, debugInfo );
#else
				r = newHeap->allocate( size );
#endif
				//擪ɑ܂
				mHeapLock.lock();
				Heap* first = mHead;
				mHead = newHeap;
				newHeap->mNext = first;
				mTotalSize += HEAP_REGION_SIZE;
				mHeapLock.unlock();
			}
		}
STRONG_ASSERT( r && "BUG!" ); //͂肦ȂBoO
		return r;
	}
	void deallocate( void* p ){
		if ( !p ){ //0
			return;
		}
		//mNext0ȂAłubNłB
		if ( isLb( p ) ){
			deallocateLb( p );
		}else{ //łȂꍇA܂Area̐擪oāAAreaɍ폜
			Heap* heap = getHeap( p );
			heap->lock();
			heap->deallocate( p );
			heap->unlock();
		}
	}
	void write( const char* filename ){
		//̒newg킯ɂ͍sȂB
		//͑ofstream߂ƂƂӖBnew邩炾B
		//āÃt@C̒łCWCuŎsB
		FILE* fp = 0;
		if ( filename ){
			setlocale( LC_ALL, "" );
			errno_t e = fopen_s( &fp, filename, "w" );
			STRONG_ASSERT( ( e == 0 ) && "MemoryManager::write() : can't open output file." );
		}else{
			::OutputDebugStringA( "\n" );
		}
		char str[ 8192 ]; //ߏɎBŃP`Ă̓ȂȁB{sprintf̓_ȂƎvB
		int l = 0;
		l += sprintf_s( str + l, 8192 - l, "[ MemoryManager::write() ]\n" );
		l += sprintf_s( str + l, 8192 - l, "totalSize = %d ( %x ) : %.2fMB\n", mTotalSize, mTotalSize, static_cast< float >( mTotalSize ) / 1024.f / 1024.f );
		l += sprintf_s( str + l, 8192 - l, "address\t\tsize\t\tfile\t\tline\n" );
		if ( fp ){
			fwrite( str, 1, l, fp );
		}else{
			::OutputDebugStringA( str );
		}

		mLbLock.lock();
		//܂ubN
		if ( mLbHead ){
			void* begin = mLbHead;
			void* block = begin;
			do{
#ifdef USE_DEBUG_INFO
				U4 debugInfo = getLbDebugInfo( block );
				const char* filename = gFileNames[ debugInfo & 0xffff ];
				U4 line = debugInfo >> 16;
#else
				const char* filename = 0;
				U4 line = 0;
#endif
				if ( !filename ){
					filename = "unknown";
				}
				U4 size = getLbSize( block );
				l = sprintf_s( 
					str, 
					8192,
					"%p\t\t%d\t\t%s\t\t%d\n",
					block,
					size,
					filename,
					line );
				if ( fp ){
					fwrite( str, 1, l, fp );
				}else{
					::OutputDebugStringA( str );
				}
				block = getLbNext( block );
			} while ( begin != block );
		}
		mLbLock.unlock();
		//q[v
		mHeapLock.lock();
		Heap* current = mHead;
		while ( current ){
			current->write( fp );
			current = current->mNext;
		}
		mHeapLock.unlock();
	}
	void check(){
		checkLb();
		checkHeap();
	}
	~Impl(){
#ifndef NDEBUG
		write( 0 );
#endif
	}
	int totalSize() const {
		return mTotalSize;
	}
private:
	void checkLb(){
		mLbLock.lock();
		//܂ubN
		if ( mLbHead ){
			void* begin = mLbHead;
			void* block = begin;
			do{
				void* next = getLbNext( block );
				void* prev = getLbPrev( block );
				void* nextPrev = getLbPrev( next );
				void* prevNext = getLbNext( prev );
				STRONG_ASSERT( nextPrev == block );
				STRONG_ASSERT( prevNext == block );
				block = next;
			} while ( begin != block );
		}
		mLbLock.unlock();
	}
	void checkHeap(){
		Heap* h = mHead;
		while ( h ){
			h->lock();
			h->check();
			h->unlock();
		}
	}
	Heap* getHeap( void* p ){
		ptrdiff_t address = ptr( p ) - static_cast< char* >( 0 );
		address &= ~( HEAP_REGION_SIZE - 1 );
		return reinterpret_cast< Heap* >( address );
	}
#ifdef USE_DEBUG_INFO
	void* allocateLb( U4 size, U4 debugInfo ){
#else
	void* allocateLb( U4 size ){
#endif
#ifdef STRONG_DEBUG
checkLb();
#endif
		//TCỶ2rbg0ɂ邽߂ɃAC
		size = align( size, 8 );
		//wb_TCYvZB|C^OU4
		U4 alignedHeaderSize = align( LB_HEADER_SIZE, ALIGN );
		void* p = allocateMemory( size + alignedHeaderSize );

		//[UɕԂ|C^
		void* r = ptr( p ) + alignedHeaderSize; 
		setLbSize( r, size );
#ifdef USE_DEBUG_INFO
		setLbDebugInfo( r, debugInfo );
#endif

		//Nւ
		mLbLock.lock();
		void* prev;
		void* next;
		if ( mLbHead ){
			prev = mLbHead;
			next = getLbNext( mLbHead );
			setLbPrev( next, r );
			setLbNext( mLbHead, r );
		}else{
			prev = next = r;
		}
		setLbNext( r, next );
		setLbPrev( r, prev );
		mLbHead = r;
		mTotalSize += size;
		mLbLock.unlock();
#ifdef STRONG_DEBUG
checkLb();
#endif
		return r;
	}
	void deallocateLb( void* p ){
#ifdef STRONG_DEBUG
checkLb();
#endif

		//N
		mLbLock.lock();
		void* prev = getLbPrev( p );
		void* next = getLbNext( p );
#ifndef NDEBUG
		void* nextPrev = getLbPrev( next );
		void* prevNext = getLbNext( prev );
		STRONG_ASSERT( nextPrev == p );
		STRONG_ASSERT( prevNext == p );
#endif
		setLbNext( prev, next );
		setLbPrev( next, prev );
		if ( mLbHead == p ){ //擪̍폜B
			mLbHead = next; //̃|C^ɕύX
			if ( mLbHead == p ){ //ɂĂȂƂƂ͍Ō̈B
				mLbHead = 0; //E
			}
		}
		mTotalSize -= getLbSize( p ) & SIZE_MASK;
		mLbLock.unlock();
#ifdef STRONG_DEBUG
checkLb();
#endif
		//
		char* origP = ptr( p ) - LB_HEADER_SIZE;
		U4 alignedHeaderSize = align( LB_HEADER_SIZE, ALIGN );
		origP -= alignedHeaderSize - LB_HEADER_SIZE; //ACł炵ȂAԋpAhX炷
		deallocateMemory( origP );
	}
/* //ubÑCAEg
	void* next;
	void* prev;
	U4 size;
	U4 debugInfo; //̒[UɕԂ
*/
#ifdef USE_DEBUG_INFO
	static const int DEBUG_INFO = sizeof( U4 );
	static const int SIZE = DEBUG_INFO + sizeof( U4 );
#else
	static const int SIZE = sizeof( U4 );
#endif
	static const int PREV = SIZE + sizeof( void* );
	static const int NEXT = PREV + sizeof( void* );
	static const int LB_HEADER_SIZE = NEXT;

	static bool isLb( void* p ){//TCY͕K4oCgOɂB
		U4* up = cast< U4 >( p, -SIZE );
		return ( *up & FLAG_LARGE_BLOCK );
	}
#ifdef USE_DEBUG_INFO
	static U4 getLbDebugInfo( void* p ){
		return *cast< U4 >( p, -DEBUG_INFO );
	}
	static void setLbDebugInfo( void* p, U4 di ){
		*cast< U4 >( p, -DEBUG_INFO ) = di;
	}
#endif
	static U4 getLbSize( void* p ){
		return *cast< U4 >( p, -SIZE );
	}
	static void* getLbPrev( void* p ){
		return *cast< void* >( p, -PREV );
	}
	static void* getLbNext( void* p ){
		return *cast< void* >( p, -NEXT );
	}
	static void setLbSize( void* p, U4 size ){
		*cast< U4 >( p, -SIZE ) = size | FLAG_LARGE_BLOCK;
	}
	static void setLbPrev( void* p, void* prev ){
		*cast< void* >( p, -PREV ) = prev;
	}
	static void setLbNext( void* p, void* next ){
		*cast< void* >( p, -NEXT ) = next;
	}

	//q[v擪
	Heap* mHead;
	//ubN擪
	void* mLbHead;
	//bN
	Lock mLbLock;
	Lock mHeapLock;
	//STCY
	int mTotalSize;
};
Impl gImpl;

} //namespace {}

MemoryManager MemoryManager::instance(){
	return MemoryManager();
}

void MemoryManager::write( const char* filename ){
	gImpl.write( filename );
}

int MemoryManager::totalSize() const {
	return gImpl.totalSize();
}

} //naemsapce GameLib

using namespace GameLib;

#ifdef USE_DEBUG_INFO
void* operator new( size_t size, const char* filename, int line ){
	unsigned debugInfo = ( line << 16 ) | getFileNameIndex( filename );
	return gImpl.allocate( size, debugInfo );
#else
void* operator new( size_t size, const char*, int ){
	return gImpl.allocate( size );
#endif
}

#ifdef USE_DEBUG_INFO
void* operator new[]( size_t size, const char* filename, int line ){
	unsigned debugInfo = ( line << 16 ) | getFileNameIndex( filename );
	return gImpl.allocate( size, debugInfo );
#else
void* operator new[]( size_t size, const char*, int ){
	return gImpl.allocate( size );
#endif
}

void operator delete( void* p, const char*, int ){
	gImpl.deallocate( p );
}

void operator delete[]( void* p, const char*, int ){
	gImpl.deallocate( p );
}

void* operator new( size_t size ){
	return gImpl.allocate( size );
}

void* operator new[]( size_t size ){
	return gImpl.allocate( size );
}

void operator delete( void* p ){
	gImpl.deallocate( p );
}

void operator delete[]( void* p ){
	gImpl.deallocate( p );
}
