#include "StdAfx.h"
#include "src/ElementImpl.h"
#include "src/AttributeImpl.h"

#include "GameLib/PseudoXml/Document.h"

namespace GameLib{
namespace PseudoXml{

Document::Impl::Impl() : 
mStringPool( 1024 ), //Ƃ肠1KBÂ
mElementPool( 16 ), //16Â
mAttributePool( 16 ), //16Â
mRoot( 0 ){
	mRoot = allocateElement( 1 );
	mRoot->setDocument( this );
}

Document::Impl::~Impl(){
}

bool Document::Impl::isReady(){
	bool r = false;
	if ( mRoot->name() ){ //ONULLłȂȂbuildς݁B
		r = true;
	}else if ( mFile ){ //[h
		if ( mFile.isFinished() ){ //[hI
			build( mFile.data(), mFile.size() );
			mFile.release();
			r = true;
		}
	}else{
		HALT( "IT MUST BE BUG!" ); //[gvfȂ
	}
	return r;
}

void Document::Impl::build( const char* data, int size ){
	if ( RefString( data, 4 ) == "PXML" ){ //oCiI
		IBinaryStream is( data, size );
		is.setPosition( 4 );
		//v[ɕԂ
		int stringBufferOffset = is.readInt();
		int stringBufferSize = size - stringBufferOffset;
		is.setPosition( stringBufferOffset );
		char* stringBuffer = mStringPool.allocate( stringBufferSize );
		is.read( stringBuffer, stringBufferSize );
		is.setPosition( 8 );
		mRoot->setName( "" );
		mRoot->setChildNumber( is.readInt() );
		for ( int i = 0; i < mRoot->childNumber(); ++i ){
			mRoot->child( i )->build( &is, stringBuffer );
		}
	}else{ //eLXg
		const char* begin = data;
		const char* end = begin + size;
		Tag tag( "<ROOT>" );
		mRoot->build( &tag, &begin, end );
	}
}

//PɈÂĂōsB
void Document::Impl::convertToString( string* out ) const {
	OStringStream oss;
	int childN = mRoot->childNumber();
	for ( int i = 0; i < childN; ++i ){
		const Element::Impl* e = mRoot->child( i );
		if ( e->name() ){ //ÔoȂ
			e->convertToString( &oss, 0 );
		}
	}
	Array< char > t;
	oss.get( &t );
	*out = &t[ 0 ];
}

//PɈÂĂōsB
void Document::Impl::convertToBinary( Array< char >* out ) const {
	int childN = mRoot->childNumber();
	OStringStream binaryOut;
	OStringStream stringBuffer;
	map< RefString, int > stringMap;
	binaryOut.write( "PXML", 4  ); //}WbN
	binaryOut.write( 0 ); //XgOobt@ItZbg̃_~[
	binaryOut.write( childN ); //Gg
	for ( int i = 0; i < childN; ++i ){
		const Element::Impl* e = mRoot->child( i );
		if ( e->name() ){ //ÔoȂ
			e->convertToBinary( &binaryOut, &stringBuffer, &stringMap );
		}
	}
	int stringBufferOffset = binaryOut.size();
	//XgOobt@}[W
	stringBuffer.get( out );
	binaryOut.write( &( *out )[ 0 ], out->size() );
	out->clear();

	binaryOut.get( out );
	//XgOobt@ItZbg̖{
	const char* p = reinterpret_cast< const char* >( &stringBufferOffset );
	for ( int i = 0; i < 4; ++i ){
		( *out )[ 4 + i ] = p[ i ];
	}
}

Element::Impl* Document::Impl::root(){
	return mRoot;
}

Element::Impl* Document::Impl::allocateElement( int n ){
	return mElementPool.allocate( n );
}

Attribute::Impl* Document::Impl::allocateAttribute( int n ){
	return mAttributePool.allocate( n );
}

} //namespace PseudoXml
} //namespace GameLib

