#include "StdAfx.h"
#include "GameLib/GameLib.h"
#include "GameLib/Base/RefString.h"
#include "src/AnimationNode.h"
#include "src/ContainerImpl.h"
#include "src/Curve.h"

#include "GameLib/PseudoXml/Element.h"
#include "GameLib/PseudoXml/Attribute.h"

namespace GameLib{
namespace Scene{
	
AnimationNode::AnimationNode( PseudoXml::ConstElement& e, Container::Impl& c ){
	ASSERT( RefString( "Node" ) == e.name() ); //NodeˁH
	ASSERT( e.childNumber() > 0 ); //J[u͂ˁH
	//O擾
	int an = e.attributeNumber();
	for ( int i = 0; i < an; ++i ){
		ConstAttribute a = e.attribute( i );
		if ( RefString( "name" ) == a.name() ){
			mName = c.allocateString( RefString( a.value() ) );
		}
	}
	mCurveNumber = e.childNumber();
	mCurves = static_cast< Curve* >( OPERATOR_NEW( sizeof( Curve ) * mCurveNumber ) );
	for ( int i = 0; i < mCurveNumber; ++i ){
		ConstElement child = e.child( i );
		new ( &mCurves[ i ] ) Curve( child );
	}
}

} //namespace Scene
} //namespace GameLib
