#ifndef INCLUDED_GAMELIB_SCENE_FONTIMPLOS_H
#define INCLUDED_GAMELIB_SCENE_FONTIMPLOS_H

#include "src/FontImpl.h"
#include "GameLib/Graphics/Texture.h"
#include "GameLib/Graphics/Manager.h"
#include "GameLib/Math/Vector2.h"
#include "GameLib/WindowCreator/WindowCreator.h"
#include <map> //ꎩɊ...

#include <windows.h>
#undef min
#undef max

namespace GameLib{
namespace Scene{
using namespace std;

using namespace GameLib::Graphics;
using namespace GameLib::Math;

namespace { //

//WindowstHgf[^擾
class FontImplOS : public Font::Impl{
	struct Char;
public:
	FontImplOS(
	const char* fontName,
	int charHeightHint, //ɂȂƂ͌Ȃ
	bool bold,
	bool italic,
	bool proportional,
	bool antialias,
	int textureWidth,
	int textureHeight ) :
	mCharHeight( 0 ),
	mCharAscent( 0 ),
	mAntiAliased( antialias ),
	mFontHandle( 0 ),
	mDeviceContextHandle( 0 ),
	mCurrentX( 0 ),
	mCurrentY( 0 ),
	mCurrentLineHeight( 0 ),
	mCurrentPage( 0 ),
	mTextureWidth( textureWidth ),
	mTextureHeight( textureHeight ){
		//eNX`BƂ肠ꖇ
		Texture t = Texture::create( mTextureWidth, mTextureHeight, false );
		//}bvɊi[
		mTextures.insert( make_pair( 0, t ) );

		//tHgUNICODEϊ
		DWORD pitch = ( proportional ) ? VARIABLE_PITCH : FIXED_PITCH;

		//tHg
		mFontHandle = CreateFontA(
			charHeightHint,
			0,
			0,
			0,
			( bold ) ? FW_BOLD : FW_DONTCARE,
			( italic ) ? TRUE : FALSE,
			FALSE,
			FALSE,
			SHIFTJIS_CHARSET,
			OUT_DEFAULT_PRECIS,
			CLIP_DEFAULT_PRECIS,
			ANTIALIASED_QUALITY,
			pitch | FF_DONTCARE,
			fontName );
		ASSERT( mFontHandle );
		//HDC
		mDeviceContextHandle = CreateCompatibleDC( NULL );
		//eLXggNX擾
		//fontZbg
		SelectObject( mDeviceContextHandle, mFontHandle );
		//̃gNX
		TEXTMETRIC tm;
		GetTextMetrics( mDeviceContextHandle, &tm );
		mCharHeight = tm.tmHeight; //ۂ̒lŏ㏑B
		mCharAscent = tm.tmAscent; //x[XC̏̐@Kv
	}
	~FontImplOS(){
		DeleteDC( mDeviceContextHandle );
		mDeviceContextHandle = 0;
	
		DeleteObject( mFontHandle );
		mFontHandle = 0;
	}
	bool getChar(
	Texture* texture,
	Vector2* uvTopLeft,
	Vector2* uvBottomRight,
	int code ){
		//R[he[uɂΎgB
		CharIt cit = mChars.find( static_cast< unsigned short >( code ) );
		const Char* c = 0;
		if ( cit != mChars.end() ){
			c = &cit->second;
		}else{
			c = createGlyph( code );
		}
		TextureIt tit = mTextures.find( c->mTexturePage );
		ASSERT( tit != mTextures.end() );
		*texture = tit->second;
		float tw = static_cast< float >( texture->width() );
		float th = static_cast< float >( texture->height() );
		float w = static_cast< float >( c->mWidth );
		float h = static_cast< float >( c->mHeight );
		float x = static_cast< float >( c->mX );
		float y = static_cast< float >( c->mY );
		uvTopLeft->set( x / tw, y / th );
		uvBottomRight->set( 
			( x + w ) / tw, 
			( y + h ) / th );
		return true;
	}
	const Char* createGlyph( int code ){
		//fontZbg
		SelectObject( mDeviceContextHandle, mFontHandle );

		GLYPHMETRICS gm; // 
		MAT2 mat = {
			{ 0, 1 }, 
			{ 0, 0 }, 
			{ 0, 0 }, 
			{ 0, 1 }
		};
		DWORD size;
		const UINT format = ( mAntiAliased ) ? GGO_GRAY8_BITMAP : GGO_BITMAP;
		// ܂͕Kvȃobt@TCY擾
		size = GetGlyphOutlineA(
			mDeviceContextHandle,
			static_cast< UINT >( code ),
			format,
			&gm, 0, NULL, &mat );
		//@擾
		int cellW = static_cast< int >( gm.gmCellIncX );
		int cellH = static_cast< int >( mCharHeight ); //IncY͖𗧂B
		int glyphW = static_cast< int >( gm.gmBlackBoxX );
		int glyphH = static_cast< int >( gm.gmBlackBoxY );
		int glyphX = static_cast< int >( gm.gmptGlyphOrigin.x );
		int glyphY = static_cast< int >( mCharAscent - gm.gmptGlyphOrigin.y );
		if ( glyphW + glyphX > cellW ){ //肦񂪑Ώق܂
			cellW = glyphW + glyphX;
		}
		if ( glyphH + glyphY > cellH ){ //肦񂪑Ώق܂
			cellH = glyphH + glyphY;
		}
		//݃eNX`擾
		TextureIt tit = mTextures.find( mCurrentPage );
		ASSERT( tit != mTextures.end() );
		Texture* tex = &( tit->second );
		int tw = tex->width();
		int th = tex->height();
		//ӂ܂I
		if ( mCurrentX + cellW >= tw ){
			mCurrentX = 0;
			mCurrentY += mCurrentLineHeight;
			mCurrentLineHeight = 0;
			//cӂ܂I
			if ( mCurrentY + cellH >= th ){
				mCurrentY = 0;
				++mCurrentPage;
				Texture t = Texture::create( mTextureWidth, mTextureHeight, false );
				//}bvɊi[
				mTextures.insert( make_pair( mCurrentPage, t ) );
				//eNX`蒼
				TextureIt tit = mTextures.find( mCurrentPage );
				ASSERT( tit != mTextures.end() );
				tex = &( tit->second );
			}
		}
		//eNX`bN(bN)
		unsigned* dst;
		int dstPitch;
		tex->lock( 
			&dst, 
			&dstPitch,
			mCurrentX,
			mCurrentY,
			cellW,
			cellH );

		if ( size == 0 ){ //TCY0
			for ( int y = 0; y < cellH; ++y ){
				for ( int x = 0; x < cellW; ++x ){
					dst[ x ] = 0x00ffffff;
				}
				dst += dstPitch / 4;
			}
		}else{
			// obt@m
			BYTE* data = NEW BYTE[ size ];
			int srcPitch = ( glyphW + 3 ) & ~( 3 ); //4oCgAC

			// xڂ̌Ăяo{Bf[^擾B
			size = GetGlyphOutlineA(
				mDeviceContextHandle,
				static_cast< UINT >( code ),
				format,
				&gm, size, data, &mat );
			ASSERT( size != GDI_ERROR );

			//1bit̎sւ̂ŁAoCgzɃRs[
			if ( mAntiAliased ){ //A`ĂȂ64->255Kϊ
				for ( DWORD i = 0; i < size; ++i ){
					data[ i ] = data[ i ] * 255 / 64;
				}
			}else{
				BYTE* newData = NEW BYTE[ size * 8 ]; //8{Α邾
				const BYTE* src = data;
				BYTE* dst = newData;
				int srcPitch = ( ( ( glyphW + 7 ) / 8 ) + 3 ) & ( ~3 );
				int dstPitch = ( glyphW + 3 ) & ( ~3 );
				for ( int y = 0; y < glyphH; ++y ){
					for ( int x = 0; x < glyphW; ++x ){
						int shift = 7 - ( x % 8 );
						int mask = 0x1 << shift;
						int bit = ( src[ x / 8 ] & mask ) >> shift;
						dst[ x ] = static_cast< BYTE >( bit * 255 );
					}
					dst += dstPitch;
					src += srcPitch;
				}
				//zdelete l|
				SAFE_DELETE_ARRAY( data );
				//Vzɍւ
				data = newData;
			}
			BYTE* src = data;
			//㕔󔒂̓hԂ
			int y = 0;
			for ( ; y < glyphY; ++y ){
				for ( int x = 0; x < cellW; ++x ){
					dst[ x ] = 0x00ffffff;
				}
				dst += dstPitch / 4;
			}
			//Ot{Z
			for ( ; y < glyphY + glyphH; ++y ){
				LONG x = 0;
				//
				for ( ; x < glyphX; ++x ){
					dst[ x ] = 0x00ffffff;
				}
				//Ot{
				for ( ; x < glyphX + glyphW; ++x ){
					int a = src[ x - glyphX ];
					dst[ x ] = ( a << 24 ) | 0xffffff;
				}
				//E
				for ( ; x < cellW; ++x ){
					dst[ x ] = 0x00ffffff;
				}
				dst += dstPitch / 4;
				src += srcPitch;
			}
			//󔒂̓hԂ
			for ( ; y < cellH; ++y ){
				for ( int x = 0; x < cellW; ++x ){
					dst[ x ] = 0x00ffffff;
				}
				dst += dstPitch / 4;
			}
			SAFE_DELETE_ARRAY( data );
		}
		tex->unlock( &dst, 0 );
		//Xgɒǉ
		Char c;
		c.mTexturePage = static_cast< unsigned char >( mCurrentPage );
		c.mWidth = static_cast< unsigned char >( cellW );
		c.mHeight = static_cast< unsigned char >( cellH );
		c.mX = static_cast< unsigned short >( mCurrentX );
		c.mY = static_cast< unsigned short >( mCurrentY );
		mCurrentX += cellW; //݈ʒui߂
		if ( mCurrentLineHeight < cellH ){
			mCurrentLineHeight = cellH;
		}

		CharIt it = mChars.insert( make_pair( code, c ) ).first;
		return &( it->second );
	}
	int charHeight() const {
		return mCharHeight;
	}
private:
	void operator=( const FontImplOS& ); //֎~

	struct Char{
		unsigned char mTexturePage; //eNX`y[W
		unsigned char mHeight; //(sNZ)
		unsigned char mWidth; //(sNZ)
		unsigned short mX; //[
		unsigned short mY; //[
	};
	typedef map< unsigned short, Char > CharMap;
	typedef CharMap::iterator CharIt;
	typedef map< int, Texture > TextureMap;
	typedef TextureMap::iterator TextureIt;

	int mCharHeight;
	int mCharAscent; //TEXTMETRIX擾
	bool mAntiAliased;
	HFONT mFontHandle;
	HDC mDeviceContextHandle;
	CharMap mChars;
	TextureMap mTextures;
	int mCurrentX; //̍̕X
	int mCurrentY; //̍̕Y
	int mCurrentLineHeight; //݂̍s̍ő卂
	int mCurrentPage; //ݏݒ̃eNX`ԍ
	const int mTextureWidth;
	const int mTextureHeight;
};

} //namespace {}

} //Scene:
} //GameLib
#endif
