#ifndef INCLUDED_GAMELIB_SCENE_TREETEMPLATE_H
#define INCLUDED_GAMELIB_SCENE_TREETEMPLATE_H

#include "GameLib/PseudoXml/Element.h"
#include "GameLib/PseudoXml/Attribute.h"

#include "src/BatchImpl.h"
#include "src/NodeTemplate.h"
#include "src/Node.h"

namespace GameLib{

namespace Math{
	class Vector3;
}
namespace PseudoXml{
	class Element;
}

namespace Scene{
using namespace Math;

//c[̌^BCůO͌Ȃ̂łImpl͂ȂB
class TreeTemplate{
public:
	TreeTemplate( PseudoXml::ConstElement&, Container::Impl& ); //cppB
	~TreeTemplate(){
		SAFE_DELETE_ARRAY( mNodes );
		mName = 0; //ReiĂ镶Ȃ̂łł͎QƂ͂
		mContainer = 0;
	}
	int nodeNumber() const { 
		return mNodeNumber; 
	}
	const NodeTemplate* node( int i ) const { 
		return &mNodes[ i ]; 
	}
	const char* name() const { 
		return mName; 
	}
	Container::Impl* container(){
		return mContainer;
	}
private:
	int countNode( GameLib::PseudoXml::ConstElement&, int n );
	int build( PseudoXml::ConstElement&, Container::Impl&, int nodePos );

	NodeTemplate* mNodes; //0Ԃƌ܂Ă̂ōw|C^͕sv
	int mNodeNumber;
	const char* mName;
	Container::Impl* mContainer;
};

} //namespace Scene
} //namespace GameLib

#endif
