#include "StdAfx.h"
#include "GameLib/GameLib.h"
#include "GameLib/Threading/Thread.h"
#include "GameLib/Threading/Event.h"
#include "src/ManagerImpl.h"

namespace GameLib{
namespace Threading{

class Thread::Impl{
public:
	Impl(){
		mFinished = Event::create();
	}
	~Impl(){
	}
	Event mFinished;
};

Thread::Thread() : mImpl( 0 ){
}

void Thread::start(){
	wait(); //ÔΑ҂
	mImpl = new Impl;
	gManagerImpl->add( this, &mImpl->mFinished ); //sJn
}

void Thread::wait(){
	if ( mImpl ){
		mImpl->mFinished.wait();
		SAFE_DELETE( mImpl );
	}
}

bool Thread::isFinished(){
	bool r = false;
	if ( mImpl ){
		if ( mImpl->mFinished.isSet() ){ //IĂ
			SAFE_DELETE( mImpl );
			r = true;
		}
	}else{
		r = true;
	}
	return r;
}

Thread::~Thread(){
	STRONG_ASSERT( !mImpl && "You must call wait() or isFinished() before destruction." );
}

} //namespace Threading
} //namespace GameLib
