#ifndef INCLUDED_GAMELIB_HASTMAPIMPL_H
#define INCLUDED_GAMELIB_HASHMAPIMPL_H

#include "GameLib/GameLib.h"
#include "GameLib/Base/HashMap.h"
#include "GameLib/Base/PrimeNumber.h"

/*
<>
YmCapacity + i (0<=i<mTableSize)gĂA̓_~[m[hłB
mNodes[ mCapacity + i ].mNextmNodes[ mCapacity + i + 1 ]ĂB
*/

namespace GameLib{

//擪ƖʈȂ悤ɂƍHvĂB
template< class K, class V, class H > inline HashMap< K, V, H >::HashMap() : 
mNexts( 0 ),
mKeys( 0 ),
mValues( 0 ),
mCapacity( 0 ),
mSize( 0 ),
mTableSize( 0 ){
	ASSERT( sizeof( K ) != 0 ); //肦ȂˁH
}

//擪ƖʈȂ悤ɂƍHvĂB
template< class K, class V, class H > inline HashMap< K, V, H >::HashMap( int capacity, int tableSize ) : 
mNexts( 0 ),
mKeys( 0 ),
mValues( 0 ),
mCapacity( 0 ),
mSize( 0 ),
mTableSize( 0 ){
	ASSERT( sizeof( K ) != 0 ); //肦ȂˁH
	setCapacity( capacity, tableSize );
}

template< class K, class V, class H > inline HashMap< K, V, H >::~HashMap(){
	if ( mNexts ){
		int pos = mNexts[ mCapacity ];
		while ( pos < mCapacity + mTableSize ){ //m[h
			if ( pos < mCapacity ){
				mKeys[ pos ].~K();
				mValues[ pos ].~V();
			}
			pos = mNexts[ pos ];
		}
		OPERATOR_DELETE( mKeys ); //delete
		OPERATOR_DELETE( mValues ); //delete
		SAFE_DELETE_ARRAY( mNexts );
	}
}

template< class K, class V, class H > inline void HashMap< K, V, H >::setCapacity( int capacity, int tableSize ){
	ASSERT( mSize == 0 && "NOT EMPTY! call clear()." );
	//܂NA
	if ( mCapacity > 0 ){
		mEmptyStack.clear();
		clear();
		OPERATOR_DELETE( mValues ); //delete
		OPERATOR_DELETE( mKeys ); //delete
		SAFE_DELETE_ARRAY( mNexts );
	}
	//Ċm
	mCapacity = capacity;
	if ( capacity <= 0 ){ //0TCY
		return;
	}	
	if ( tableSize == 0 ){ //capacityȏ̑fݒ
		tableSize = capacity;
	}
	tableSize = PrimeNumber::next( tableSize );
	if ( tableSize < 3 ){
		tableSize = 3; //Œ3
	}
	mTableSize = tableSize;
	//z e[uTCY_~[𑫂Ƃɒ
	mNexts = NEW int[ mCapacity + mTableSize ];
	//lzmہBRXgN^svȂ̂Őnew
	mKeys = static_cast< K* >( OPERATOR_NEW( sizeof( K ) * mCapacity ) );
	mValues = static_cast< V* >( OPERATOR_NEW( sizeof( V ) * mCapacity ) );
	//󂫔ԍX^bN
	mEmptyStack.setCapacity( mCapacity );
	for ( int i = 0; i < mCapacity; ++i ){
		mEmptyStack.push( i ); //󂫔ԍXgɋl߂Ă
	}
	//mCapacity+0mCapacity+mTableSize-1Ԃ̓_~[vfBe̐擪̑OɈʒuB
	for ( int i = 0; i < mTableSize; ++i ){
		mNexts[ mCapacity + i ] = mCapacity + i + 1;
	}
}

template< class K, class V, class H > inline int HashMap< K, V, H >::capacity() const {
	return mCapacity;
}

template< class K, class V, class H > inline int HashMap< K, V, H >::add( const K& k, const V& v ){
	ASSERT( mSize < mCapacity );
	//nbV֐Zo
	int h = H().value( k, mTableSize );
	//
	int p = mNexts[ mCapacity + h ];
	while ( p < mCapacity ){
		if ( H().isEqual( mKeys[ p ], k ) ){
			break;
		}
		p = mNexts[ p ];
	}
	if ( p >= mCapacity ){ //Ȃ瑫
		//󂫏ꏊ擾
		int newPos;
		mEmptyStack.pop( &newPos );
		//e[u擪ɑ}
		int head = mCapacity + h;
		mNexts[ newPos ] = mNexts[ head ]; //_~[̎Zbg
		new ( &mKeys[ newPos ] ) K( k ); //Rs[RXgN^Ăяo
		new ( &mValues[ newPos ] ) V( v ); //Rs[RXgN^Ăяo
		mNexts[ head ] = newPos; //ÕNVm[hɂȂ
		++mSize;
		return newPos;
	}else{
		return mCapacity + mTableSize;
	}
}

template< class K, class V, class H > inline int HashMap< K, V, H >::add( const K& k ){
	ASSERT( mSize < mCapacity );
	//nbV֐Zo
	int h = H().value( k, mTableSize );
	//
	int p = mNexts[ mCapacity + h ];
	bool found = false;
	while ( p < mCapacity ){
		if ( H().isEqual( mKeys[ p ], k ) ){
			found = true;
		}
		p = mNexts[ p ];
	}
	if ( !found ){ //Ȃ瑫
		//󂫏ꏊ擾
		int newPos;
		mEmptyStack.pop( &newPos );
		//e[u擪ɑ}
		int head = mCapacity + h;
		mNexts[ newPos ] = mNexts[ head ]; //_~[̎Zbg
		new ( &mKeys[ newPos ] ) K( k ); //Rs[RXgN^Ăяo
		new ( &mValues[ newPos ] ) V;
		mNexts[ head ] = newPos; //ÕNVm[hɂȂ
		++mSize;
		return newPos;
	}else{
		return mCapacity + mTableSize;
	}
}

template< class K, class V, class H > inline int HashMap< K, V, H >::find( const K& k ) const {
	int h = H().value( k, mTableSize );

	int p = mNexts[ mCapacity + h ];
	while ( p < mCapacity ){
		if ( H().isEqual( mKeys[ p ], k ) ){
			return p;
		}
		p = mNexts[ p ];
	}
	return mCapacity + mTableSize;
}

template< class K, class V, class H > inline bool HashMap< K, V, H >::remove( int position ){
	//p̏ꏊɂvf̃nbVlnbVlvZȂŒm肽B
	//ŁAUwbhe[uɏo܂ŃCe[^i߂ČB
	int h = position;
	while ( h < mCapacity ){
		h = mNexts[ h ];
	}
	//U͈͊OɏoBmCapacityƎ̃nbVl킩B
	h -= mCapacity;
	//-1΂̃nbVl
	h -= 1;
	//nbVl킩̂ŁAe[u̐擪HĂpB
	int prev = mCapacity + h; //wbh
	int p = mNexts[ prev ];
	while ( p < mCapacity ){
		if ( p == position ){ //BB
			mNexts[ prev ] = mNexts[ p ]; //Ȃς
			mKeys[ p ].~K(); //fXgNg
			mValues[ p ].~V(); //fXgNg
			mEmptyStack.push( p ); //󂫃X^bNɃvbV
			--mSize;
			return true;
		}
		prev = p;
		p = mNexts[ p ];
	}
	return false;
}

template< class K, class V, class H > inline const V* HashMap< K, V, H >::value( int p ) const {
	return &mValues[ p ];
}

template< class K, class V, class H > inline V* HashMap< K, V, H >::value( int p ){
	return &mValues[ p ];
}

template< class K, class V, class H > inline V* HashMap< K, V, H >::operator[]( const K& k ){
	int p = find( k );
	return ( p < mCapacity ) ? &mValues[ p ] : 0;
}

template< class K, class V, class H > inline const V* HashMap< K, V, H >::operator[]( const K& k ) const {
	int p = find( k );
	return ( p < mCapacity ) ? &mValues[ p ] : 0;
}

template< class K, class V, class H > inline const K* HashMap< K, V, H >::key( int p ) const {
	return &mKeys[ p ];
}

template< class K, class V, class H > inline void HashMap< K, V, H >::clear(){
	//fXgNgĉ
	int prev = mCapacity; //wbh
	int p = mNexts[ mCapacity ]; //_~[wbh
	while ( p < mCapacity + mTableSize ){  //mCapacity + mTableSize݂͑ȂB܂ł̓_~[Ƃđ݂B
		if ( p < mCapacity ){
			mNexts[ prev ] = mNexts[ p ]; //Ȃς
			mKeys[ p ].~K();
			mValues[ p ].~V();
			mEmptyStack.push( p ); //󂫃X^bNɃvbV
		}
		prev = p;
		p = mNexts[ p ];
	}
	mSize = 0;
}

template< class K, class V, class H > inline int HashMap< K, V, H >::next( int p ) const {
	ASSERT( p >= 0 );
	while ( p < mCapacity + mTableSize ){
		p = mNexts[ p ];
		if ( p < mCapacity ){ //_~[m[hȊOԂ
			return p;
		}
	}
	return p;
}

template< class K, class V, class H > inline int HashMap< K, V, H >::first() const {
	int p = mCapacity; //ŏ̃_~[
	while ( p < mCapacity + mTableSize ){
		p = mNexts[ p ];
		if ( p < mCapacity ){ //_~[m[hȊOԂ
			return p;
		}
	}
	return mCapacity + mTableSize;
}

template< class K, class V, class H > inline bool HashMap< K, V, H >::isEnd( int position ) const {
	return ( position == mCapacity + mTableSize );
}

template< class K, class V, class H > inline void HashMap< K, V, H >::copyTo( V* a ) const {
	int p = mNexts[ mCapacity ];
	int idx = 0;
	while ( p != mCapacity + mTableSize ){
		if ( p < mCapacity ){
			a[ idx ] = mValues[ p ];
			++idx;
		}
		p = mNexts[ p ];
	}
}

template< class K, class V, class H > inline void HashMap< K, V, H >::copyTo( Array< V >* a ) const {
	a->setSize( mSize );
	if ( mSize > 0 ){
		copyTo( &( ( *a )[ 0 ] ) );
	}
}
		

template< class K, class V, class H > inline int HashMap< K, V, H >::size() const {
	return mSize;
}

} //namespace GameLib

#endif
