#ifndef INCLUDED_GAMELIB_SCENE_CONTAINER_H
#define INCLUDED_GAMELIB_SCENE_CONTAINER_H

namespace GameLib{

namespace PseudoXml{
	class ConstElement;
};

namespace Scene{

class Batch;
class Model;
class Tree;
class Animation;

///`f[^ReiB
/*!
createModel()āAModel::draw()΂B2sŊGoB
*/
class Container{
public:
	///jZxml琶Bǉf[^pX͏ȗexȅꏊɂȂ
	static Container create( PseudoXml::ConstElement, const char* extraDataPath = 0 );
	///t@C璼ڐBǉf[^pXȂ΃t@CƓꏊgB
	static Container create( const char* filename, const char* extraDataPath = 0 );
	///ob`w肵ăf
	Model createModel( const char* batchName ) const;
	///ob`ԍw肵ăf
	Model createModel( int batchId ) const;
	///c[w肵ăc[
	Tree createTree( const char* treeName ) const;
	///c[̔ԍw肵ăc[
	Tree createTree( int treeId ) const;

	///[hImBKĂtrueԂ邱ƂmFĂgƁB
	bool isReady();

	Batch batch( const char* batchName ) const;
	Batch batch( int batchIndex ) const;
	Animation animation( const char* animationName ) const;
	Animation animation( int animationIndex ) const;
	//Batch킩BĂŜ̂oɂ͂getBatch(int)𕹗pΗǂB
	int batchNumber() const;
	//Tree킩BĂŜ̂oɂ͂createTree(int)𕹗pΗǂB
	int treeNumber() const;
	//Aj[V킩B
	int animationNumber() const;

	//ȉ[U͈ӎȂĂ
	Container();
	~Container();
	Container( const Container& );
	operator void*() const;
	Container& operator=( const Container& );
	void release();
	bool operator==( const Container& ) const;
	bool operator!=( const Container& ) const;

	class Impl;
private:
	explicit Container( Impl* );
	Impl* mImpl;
};

} //namespace Scene
} //namespace GameLib

#endif
