#ifndef INCLUDED_GAMELIB_SCENE_FONT_H
#define INCLUDED_GAMELIB_SCENE_FONT_H

namespace GameLib{

namespace Graphics{
	class Texture;
}
namespace Math{
	class Vector2;
}
using namespace Math;

namespace Scene{

///tHgNX
class Font{
public:
	///rbg}bvtHg̕ÂɕtKvȃf[^
	struct BitmapChar{
		unsigned short mCode; //R[h(SHIFT_JIS)
		unsigned short mX; //[
		unsigned short mY; //[
		unsigned char mTexturePage; //eNX`y[W
		unsigned char mWidth; //(sNZ)
		unsigned char mHeight; //(sNZ)
	};
	///eNX`grbg}bvtHg𐶐B͍̍ől̗pB
	static Font create( 
		const char** textureFileNames, //eNX`t@Cz
		int textureNumber,
		BitmapChar* BitmapChars,
		int bitmapCharNumber );
	///eNX`grbg}bvtHg𐶐B͍̍ől̗pB
	static Font create(
		const char** textureFileData, //eNX`DDSC[Wz
		const int* textureFileSizes, //eNX`f[^TCYz
		int textureNumber,
		BitmapChar* bitmapChars,
		int CharNumber );
	///OS瓮IɃtHgf[^擾B̍AeNX`Ȃǂ͎wB
	static Font create(
		const char* osFontName,
		int charHeightHint, //͖ڈBۂɂgetCharHeightQƂ
		bool bold = false,
		bool italic = false,
		bool proportional = false,
		bool antialias = false,
		int internalTextureWidth = 512,
		int internalTextureHeight = 512 );
	///擾BȂfalseԂB
	bool getChar( 
		Graphics::Texture* textureOut,
		Vector2* uvTopLeftOut,
		Vector2* uvBottomRightOut,
		int code );
	///̍ő卂
	int charHeight() const;
	///[hIĂH
	bool isReady();

	//ȉ[U͈ӎȂĂ
	Font();
	~Font();
	Font( const Font& );
	operator void*() const;
	Font& operator=( const Font& );
	void release();
	bool operator==( const Font& ) const;
	bool operator!=( const Font& ) const;

	class Impl;
private:
	explicit Font( Impl* );
	Impl* mImpl;
};

} //namespace Scene
} //namespace GameLib

#endif
