#ifndef INCLUDED_GAMELIB_SCENE_PRIMITIVERENDERER_H
#define INCLUDED_GAMELIB_SCENE_PRIMITIVERENDERER_H

#include "GameLib/Graphics/Enum.h"

namespace GameLib{

namespace Graphics{
	class Texture;
}

namespace Math{
	class Matrix44;
	class Vector4;
	class Vector3;
	class Vector2;
}
using namespace Math;

namespace Scene{

///ڎOp`AA_A2D``悷邽߂֗̕NXBxIɂ͂Ȃ薳ʂB
class PrimitiveRenderer{
public:
	///_ƁȂ߂̐w肵č\z
	static PrimitiveRenderer create( 
		int vertexCapacity, 
		int commandCapacity );

	void setTexture( Graphics::Texture );
	void enableDepthTest( bool );
	void enableDepthWrite( bool );
	void setBlendMode( Graphics::BlendMode );
	void setCullMode( Graphics::CullMode );
	void setTransform( const Matrix44& );

	///Op`ϊςݒ_ŏB܂p4vfxN^B
	void addTransformedTriangle(
		const Vector4& pos0,
		const Vector4& pos1,
		const Vector4& pos2,
		const Vector2& uv0,
		const Vector2& uv1,
		const Vector2& uv2,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff,
		unsigned color2 = 0xffffffff);
	///Op`ϊςݒ_ŏBeNX`ȂB
	void addTransformedTriangle(
		const Vector4& pos0,
		const Vector4& pos1,
		const Vector4& pos2,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff,
		unsigned color2 = 0xffffffff);
	///Op``
	void addTriangle(
		const Vector3& pos0,
		const Vector3& pos1,
		const Vector3& pos2,
		const Vector2& uv0,
		const Vector2& uv1,
		const Vector2& uv2,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff,
		unsigned color2 = 0xffffffff );
	///Op``BeNX`Ȃ
	void addTriangle(
		const Vector3& pos0,
		const Vector3& pos1,
		const Vector3& pos2,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff,
		unsigned color2 = 0xffffffff );
	///`B
	void addLine(
		const Vector3& pos0,
		const Vector3& pos1,
		const Vector2& uv0,
		const Vector2& uv1,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff );
	///`BeNX`ȂB
	void addLine(
		const Vector3& pos0,
		const Vector3& pos1,
		unsigned color0 = 0xffffffff,
		unsigned color1 = 0xffffffff );
	///_`B
	void addPoint(
		const Vector3& pos,
		const Vector2& uv,
		unsigned color = 0xffffffff );
	///_`BeNX`Ȃ
	void addPoint(
		const Vector3& pos,
		unsigned color = 0xffffffff );
	///Z=0ʂɒ``BWn̓XN[WB
	void addRectangle(
		const Vector2& pos0,
		const Vector2& pos1,
		const Vector2& uv0,
		const Vector2& uv1,
		unsigned color = 0xffffffff,
		float depth = 0.f );
	///Z=0ʂɒ``BWn̓XN[WBeNX`ȂB
	void addRectangle(
		const Vector2& pos0,
		const Vector2& pos1,
		unsigned color = 0xffffffff,
		float depth = 0.f );
	///`
	void draw();

	//ȉ[U͈ӎȂ
	PrimitiveRenderer();
	PrimitiveRenderer( const PrimitiveRenderer& );
	~PrimitiveRenderer();
	operator void*() const;
	PrimitiveRenderer& operator=( const PrimitiveRenderer& );
	void release();
	bool operator==( const PrimitiveRenderer& ) const;
	bool operator!=( const PrimitiveRenderer& ) const;
private:
	class Impl;
	Impl* mImpl;
};

} //namespace Scene

} //namespace GameLib


#endif
