#ifndef INCLUDED_GAMELIB_WINDOWCREATOR_H
#define INCLUDED_GAMELIB_WINDOWCREATOR_H

namespace GameLib{

class WindowCreator{
public:
	class Configuration{
	public:
		void setWidth( int width );
		void setHeight( int height );
		void setTitle( const char* title );
		void forbidFullScreen( bool = true ); //Ăłalt-enter
		void enableFullScreen( bool = true );
		void enableDragAndDrop( bool = true );
	};
	WindowCreator();
	//[U֐
	void configure( Configuration* );
	void start( void* windowHandle );
	void update();

	const char* title() const;
	int titleLength() const;
	int width() const;
	int height() const;
	bool isFullScreen() const;
	bool isMinimized() const;
	bool isActive() const;
	void enableFullScreen( bool );
	///R}hC擾
	const char* commandLineString() const;
	///hbOAhhbv͗LłH
	bool isDragAndDropEnabled() const;
	///hbOAhhbv擾
	int droppedItemNumber() const;
	///hbOAhhbv擾
	const char* droppedItem( int index ) const;
	///hbOAhhbvNA
	void clearDroppedItem();
	///~bPʎԂ
	unsigned time() const;

	static bool isMainThread();
	static WindowCreator instance();
	void requestEnd(); //Iv
	void end(); //IʒmB
	bool isEndRequested() const; //I͗vĂ܂
	int getAndResetMouseWheel();
};

} //namespace GameLib

#endif