#include "GameLib/Framework.h"
#include "GameLib/Sound/Player.h"
#include "GameLib/FileIO/InFile.h"

using namespace GameLib;
using namespace GameLib::Sound;
using namespace GameLib::FileIO;

InFile gFile;
Player gPlayer;
const int BUFFER_SIZE = 16 * 1024; //ȉ͂߂ȂB1/16bȏȂPlayerRXgN^ł͂˂B
const int BUFFER_HALFSIZE = BUFFER_SIZE / 2;

int gReadPos = 0;
int gWritePos = 0;
int gWaveSize;
int gWaveStart;

namespace GameLib{
	void Framework::configure( Configuration* ){}
	void Framework::update(){
		if ( !gFile ){
			gFile = InFile::create( "charara.wav" );
			while ( !gFile.isFinished() ){ ; } //[h҂

			//--------Wavt@C͂Ă݂悤B

			int channels = gFile.getShort( 22 ); //22oCgڂ2oCg`l
			int frequency = gFile.getInt( 24 ); //24oCgڂ4oCgg
			int bitsPerSample = gFile.getShort( 34 ); //34oCgڂ2oCgrbg
			const char* data = gFile.data();
			int pos = 36; //36oCgڂǂł
			//Ȃ̂ǂݔ΂
			while ( data[ pos+0 ] != 'd' || data[ pos+1 ] != 'a' || data[ pos+2 ] != 't' || data[ pos+3 ] != 'a' ){ //"data"ƕł̂܂Ői߂B
				pos += gFile.getInt( pos+4 ); //Ȃ̂̃TCYɓĂ
			}
			//ƃf[^
			gWaveSize = gFile.getInt( pos + 4 ); //f[^̗ʂ"data"̎4oCg
			gWaveStart = pos + 8; //Ɏ炪g
			if ( gWaveSize + gWaveStart > gFile.size() ){ //܂ɃTCYɃE\Ăt@CB
				gWaveSize = gFile.size() - gWaveStart; //dȂ̂Ŗ܂ŁB
			}


			//vC[
			gPlayer = Player::create( bitsPerSample, BUFFER_SIZE, frequency, channels );

			//ŏ̕[U
			int restSize = gWaveSize - gReadPos; //ct@CTCY
			int writeSize = ( restSize >= BUFFER_HALFSIZE ) ? BUFFER_HALFSIZE : restSize; //obt@̔傫΂ꂾBΎcSB
			bool succeeded = gPlayer.write( gWritePos, gFile.data() + 44 + gReadPos, writeSize ); //݁B
			if ( !succeeded ){
				cout << "WRITING FAILED!" << endl;
			}
			gReadPos += writeSize;
			gWritePos += writeSize;
			//Ȃf[^0𖄂߂
			if ( writeSize < BUFFER_HALFSIZE ){
				gPlayer.fillSilence( gWritePos, BUFFER_HALFSIZE - writeSize );
				gWritePos += BUFFER_HALFSIZE - writeSize;
			}
			gPlayer.play(); //Xg[~OĐ͉nȂĂɃ[vĐɂȂBȂ̂̂[v鏈͎Oł邱ƁB
		}
		///-----ȉt[-----


		//Đ̏ꏊāA
		int playPos = gPlayer.position();
		//݃|C^Ƌ߂ÂĂ( ݈ʒuĐʒuŁAobt@TCYȉȂ )
		if ( ( gWritePos > playPos ) && ( gWritePos - playPos < BUFFER_HALFSIZE ) ){
			cout << "write=" << gWritePos << "\tplay=" << playPos << "\tread=" << gReadPos << endl;
			//݁B
			int restSize = gWaveSize - gReadPos;
			int writeSize = ( restSize >= BUFFER_HALFSIZE ) ? BUFFER_HALFSIZE : restSize;
			if ( gWritePos >= BUFFER_SIZE ){ //Ō܂ōŝŊ߂
				gWritePos = 0;
			}
			bool succeeded = gPlayer.write( gWritePos, gFile.data() + 44 + gReadPos, writeSize );
			if ( !succeeded ){
				cout << "WRITING FAILED!" << endl;
			}
			gReadPos += writeSize;
			gWritePos += writeSize;
			//Ȃf[^0𖄂߂
			if ( writeSize < BUFFER_HALFSIZE ){
				gPlayer.fillSilence( gWritePos, BUFFER_HALFSIZE - writeSize );
				gWritePos += BUFFER_HALFSIZE - writeSize;
			}
		}
		if ( isEndRequested() ){
			gFile.release();
			gPlayer.release();
		}
	}
}
