#include <fstream>
#include <iostream>
#include <cassert>
#include "GameLib/Base/Compressor.h"
using namespace std;

class DictionaryCompressor{
public:
	static bool compress( 
		int* outSize, 
		int* necessaryBufferSize,
		bool* compressed,
		ofstream* oStream, 
		ifstream* iStream,
		double threshold );
private:
	static bool compress( 
		unsigned char* outData, 
		int* outSize, 
		int* necessaryBufferSize,
		int outBufferSize,
		const unsigned char* inData, 
		int inSize );
	static bool decompress( 
		unsigned char* outData, 
		int* outSize,
		int outBufferSize,
		const unsigned char* inData, 
		int inSize );
};

bool DictionaryCompressor::compress(
int* writtenSize, 
int* necessaryBufferSize,
bool* compressed,
ofstream* oStream, 
ifstream* iStream,
double threshold ){
	//{͕ǂ݂ȂƂ܂ʓ|Ȃ̂ňꊇ
	iStream->seekg( 0, ifstream::end );
	int inSize = static_cast< int >( iStream->tellg() );
	iStream->seekg( 0, ifstream::beg );
	char* inData = new char[ inSize ];
	iStream->read( inData, inSize );

	//ݐp
	int outBufferSize = inSize + ( inSize / 127 ) + 1; //܂̕+1YꂸɁB
	char* outData = new char[ outBufferSize ];
	if ( !outData ){
		cerr << "memory allocation failed : " << outBufferSize << endl;
		return false;
	}
	//Ⴀk[
	int outSize;
	bool succeeded = compress( 
		reinterpret_cast< unsigned char* >( outData ), 
		&outSize, 
		necessaryBufferSize,
		outBufferSize,
		reinterpret_cast< unsigned char* >( inData ), 
		inSize );
	assert( succeeded );
#ifndef NDEBUG
	{
		//k̂WJĂƌɖ߂邩m߂悤B
		char* outData2 = new char[ inSize ]; //ł͂ˁH
		int outSize2;
		succeeded = decompress( 
			reinterpret_cast< unsigned char* >( outData2 ), 
			&outSize2, 
			inSize,
			reinterpret_cast< unsigned char* >( outData ), 
			outSize );
		assert( succeeded );
		for ( int i = 0; i < inSize; ++i ){
			assert( inData[ i ] == outData2[ i ] );
		}
		assert( inSize == outSize2 );
		delete[] outData2;
		outData2 = 0;
	}
#endif
	//
	double t = inSize;
	t *= threshold;
	t /= 100.0;
	if ( outSize < t ){ //ko[W
		oStream->write( outData, outSize );
		*writtenSize = outSize;
		*compressed = true;
	}else{
		oStream->write( inData, inSize );
		*writtenSize = inSize;
		*necessaryBufferSize = inSize;
		*compressed = false;
	}
	delete[] inData;
	delete[] outData;
	inData = 0;
	outData = 0;
	return true;
}

//rbg蓖
const int DIC_BITS = 10; //ʒubit
//ȉvZ萔
const int LENGTH_BITS = 16 - 1 - DIC_BITS; //
const int DIC_MASK = ( 1 << DIC_BITS ) - 1;
const int DIC_MASK_HIGH = DIC_MASK & 0xffffff00; //8bitԂ
const int DIC_MASK_SHIFTED = ( DIC_MASK >> 8 ) << LENGTH_BITS; 
const int LENGTH_MASK = ( 1 << LENGTH_BITS ) - 1;
const int DIC_SIZE = DIC_MASK + 3; //TCY
const int MAX_LENGTH = LENGTH_MASK + 3; //őv

//悭gŏlƍől
inline int min( int a, int b ){
	return ( a < b ) ? a : b;
}

inline int max( int a, int b ){
	return ( a > b ) ? a : b;
}

//k[
/*
kBLZ77̉B
k̈2oCgŁAʒuƒɕzĂB
1oCg : 0x80+TCY(5bit)+ʒȕʃrbg(2bit)A
2oCg : ʒủ8bitB
񈳏k̈́A񈳏k̈TCYA񈳏k(1128)

k̈́AʒuA-3i[ĂB
WJ͎oĂ3𑫂B
񈳏k̈͒-1ĂAoɂ+1B

23͂̃TvɔׂāAG[Ak̍HvŃR[hȂĂB
*/
bool DictionaryCompressor::compress( 
unsigned char* oData, 
int* oSize, 
int* oNecessaryBufferSize,
int oBufferSize, 
const unsigned char* iData, 
int iSize ){
	int oPos = 0; //ݑ̏ވʒu
	int maxPosDiff = 0; //WJɁA݃|C^ǂݍ݃|C^ǂʂ̍őlB̏WJ邽߂ɂ́A̕傫ȓWJobt@KvB
	int i = 0;
	int unmatchBegin = 0; //v̈̊Jnʒu
	while ( i < iSize ){
		//猟
		int matchLength = 0;
		int matchPos = 0;
		//̐擪B
		int dicBegin = max( i - DIC_SIZE, 0 ); //0Oɂ͂ȂȂƂɒӁBmax()g
		//ő匟
		int maxL = min( MAX_LENGTH, iSize - dicBegin ); //͂̍ŌzČ͂łȂB
		//̐擪TĂBŉȍHvƓɈ̂łĂȂB
		int jEnd = i - 3; //擪3ȏOn߂B3ȏ}b`Ȃ舳kȂ炾B
		//ł͌̃Tvƈă[vdɂĂBsvjl-1߂肾B̕킩ɂAŌ܂Ń}b`ɂĂ̂œ̎ނ̃t@C(^ȉ摜Ƃ)őȂB
		int j = dicBegin;
		int l = 0;
		while ( ( j < jEnd ) && ( l < maxL ) ){
			if ( iData[ j ] == iData[ i + l ] ){
				++j;
				++l;
			}else{
				//O蒷vȂL^Bȃ}b`̎d͂Aő̂̂L^B
				if ( matchLength < l ){
					matchPos = j - l;
					matchLength = l;
				}
				j -= l - 1; //l0ł1͐iށBlƂ߂B
				l = 0;
			}
		}
		if ( matchLength < l ){ //Ō܂ŗĂ܂ꍇɑΏ
			matchPos = j - l;
			matchLength = l;
		}
		//āAv3ȏ゠Έk[hŋL^B
		if ( matchLength >= 3 ){
			if ( unmatchBegin < i ){
				if ( ( oPos + i - unmatchBegin + 1 ) > oBufferSize ){ //݃obt@sG[o Ō+1̓wb_
					return false; //s
				}
				//񈳏kwb_
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
			}
			if ( ( oPos + 2 ) > oBufferSize ){ //݃obt@sG[o
				return false; //s
			}
			//kL^
			int wl = matchLength - 3; //3Ċi[
			int wp = i - matchPos - 3; //3Ċi[
			int tmp = 0x80 | wl; //ɈktOǉ
			tmp |= ( wp & DIC_MASK_HIGH ) >> ( 8 - LENGTH_BITS ); //mask&ATCYɎgĂrbg̕炷B
			oData[ oPos + 0 ] = static_cast< unsigned char >( tmp );
			oData[ oPos + 1 ] = static_cast< unsigned char >( wp & 0xff );
			oPos += 2;
			i += matchLength;
			unmatchBegin = i; //vʒu͎
		}else{ //}b`ȂB݂͂܂Ƃ߂Ă̂ŁA͐i߂B
			++i;
			if ( i - unmatchBegin == 128 ){ //E܂Ă܂B
				if ( ( oPos + i - unmatchBegin + 1 ) > oBufferSize ){ //݃obt@sG[o Ō+1̓wb_
					return false; //s
				}
				//񈳏kwb_
				oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
				++oPos;
				for ( int j = unmatchBegin; j < i; ++j ){
					oData[ oPos ] = iData[ j ];
					++oPos;
				}
				unmatchBegin = i;
			}
		}
		//݈ʒuǂʂXV
		maxPosDiff = max( maxPosDiff, i - oPos );
	}

	//vʒucĂ΍Ō̏
	if ( unmatchBegin < i ){
		if ( ( oPos + i - unmatchBegin + 1 ) > oBufferSize ){ //݃obt@sG[o Ō+1̓wb_
			return false; //s
		}
		//񈳏kwb_
		oData[ oPos ] = static_cast< unsigned char >( i - unmatchBegin - 1 ); //Œ1Ȃ̂1ĕۑ
		++oPos;
		for ( int j = unmatchBegin; j < i; ++j ){
			oData[ oPos ] = iData[ j ];
			++oPos;
		}
	}

	*oNecessaryBufferSize = max( maxPosDiff + oPos, iSize );
	*oSize = oPos;
	return true;
}

//WJ͂ƂĂȒPłBłG[`FbNłƒȂĂB
bool DictionaryCompressor::decompress( 
unsigned char* oData, 
int* oSize,
int oBufferSize,
const unsigned char* iData, 
int iSize ){
	int oPos = 0;
	for ( int i = 0; i < iSize; ++i ){
		int length;
		if ( iData[ i ] & 0x80 ){ //k[h
			length = iData[ i ] & LENGTH_MASK;
			length += 3; //3ȂL^ĂB
			int position = ( ( iData[ i ] & DIC_MASK_SHIFTED ) << ( 8 - LENGTH_BITS ) ) | iData[ i + 1 ]; //GȂ̂ł悭čl悤
			position += 3; //3ȂL^ĂB
			if ( oPos + length > oBufferSize ){ //݃obt@TCY`FbN
				return false;
			}
			for ( int j = 0; j < length; ++j ){
				oData[ oPos + j ] = oData[ oPos - position + j ]; //outڂ̂CȂAłɏout͎Ȃ̂łB
			}
			i += 1; //1oCg]ɐi߂ĂB
		}else{ //񈳏k[h
			length = iData[ i ] + 1; //1ȂL^Ă
			if ( oPos + length > oBufferSize ){ //݃obt@TCY`FbN
				return false;
			}
			for ( int j = 0; j < length; ++j ){
				oData[ oPos + j ] = iData[ i + 1 + j ];
			}
			i += length; //قĂĂ1͑Bf[^lengthi߁ȂO1oCg͎Rɂ܂悤
		}
		oPos += length;
	}
	*oSize = oPos;
	return true;
}
