#include <windows.h>
#include <string>
#include <list>
#include <sstream>
#include <fstream>
#include <iostream>
#include <cassert>
using namespace std;
/*
̃Tvłwindows̊֐ASCII(ʂchar*o[W)
𒼐ڌĂяoĎgB{TCHARȂǂ̃}N𑽗pUnicodeASCII
ӎɎĝ@Ȃ̂AȂR[h͓ǂ݂ɂA
ʂwindowsvO~OwԂƂ͖ړIł͂ȂB
perlbashAC#Ȃǂo΂̎̃c[C++ŏƂȂȂ邾낤B
łwindows@𖳎ASCIIł𒼐ڌĂ

<g֐>
GetFirstFileA
GetNextFileA
<g\>
WIN32_FIND_DATAA
*/

//t@Cꗗ擾
void enumerateFiles( 
	list< string >& fileNameListOut, 
	const string& directoryName,
	bool verbose );

//A[JCu
bool createArchive( 
	const string* fileNames, 
	int fileNumber, 
	const char* archiveName,
	int blockSize,
	bool verbose,
	double compressionThreshold );

//k{
bool compress( 
	int* outSize, 
	int* inPlaceDecompressionBufferSize,
	bool* compressed,
	ofstream* oStream, 
	ifstream* iStream,
	double threshold );

//int݂֗̕֐
void write( ofstream* o, unsigned a ){
   char str[ 4 ];
   str[ 0 ] = static_cast< char >( ( a & 0x000000ff ) >>  0 );
   str[ 1 ] = static_cast< char >( ( a & 0x0000ff00 ) >>  8 );
   str[ 2 ] = static_cast< char >( ( a & 0x00ff0000 ) >> 16 );
   str[ 3 ] = static_cast< char >( ( a & 0xff000000 ) >> 24 );
   o->write( str, 4 );
}

#include "GameLib/GameLib.h"

//o̓t@C
int main( int argc, char** argv ){
	int blockSize = 4;
	string archiveDir;
	string archiveName;
	bool verbose = false;
	bool help = false;
	double threshold = 100.0;
	//R}hC
	for ( int i = 1; i < argc; ++i ){
		if ( argv[ i ][ 0 ] == '-' ){ //-͂܂΂Ȃɂ̃IvV
			char c = argv[ i ][ 1 ];
			if ( c == 'b' ){ //TCYw
				if ( ( i + 1 ) < argc ){
					istringstream iss( argv[ i + 1 ] );
					iss >> blockSize;
				}
				++i;
			}else if ( c == 'o' ){ //o̓t@Cw
				if ( ( i + 1 ) < argc ){
					archiveName = argv[ i + 1 ];
				}
				++i;
			}else if ( c == 'r' ){ //臒l
				if ( ( i + 1 ) < argc ){
					istringstream iss( argv[ i + 1 ] );
					iss >> threshold;
					if ( threshold > 100.0 ){
						threshold = 100.0; //100ȏ͋Ȃ
					}
				}
				++i;
			}else if ( c == 'v' ){ //`ヂ[h
				verbose = true;
			}else if ( c == 'h' ){ //wv
				help = true;
			}
		}else{
			archiveDir = argv[ i ];
		}
	}
	//A[JCufBNgw肪ȂƑʖځB
	if ( archiveDir.size() == 0 ){
		help = true;
	}
	//wv\ďI
	if ( help ){
		cout << "Usage: Archiver.exe rootDir [ -o outfilename ][ -s blockSize ][ -r thresholdRatio ][ -v ][ -h ]" << endl;
		cout << "<Options>" << endl;
		cout << "\t-o outfilename : specify output archive name. default is \"rootDir\".bin" << endl;
		cout << "\t-s blocksize   : specify block size. \"4GB * blockSize\" is maximum archivesize. default is 4." << endl;
		cout << "\t-r percent     : specify threshold. if compressed size is less than this, non-compressed data is written." << endl;
		cout << "\t-v             : verbose mode." << endl;
		cout << "\t-h             : display this help." << endl;
#ifndef NDEBUG //ĂƃfoO̎Ȃ
	while( true ){;} //visual studios鎞ɃR\[ǂ݂̂ŁB
#endif
		return 1;
	}
	//A[JCuȂ΃A[JCufBNgĂ
	if ( archiveName.size() == 0 ){
		archiveName = archiveDir;
		archiveName += ".bin";
	}

	//悭ĝɕʖ
	typedef list< string > List;
	typedef List::iterator It;
	List fileNameList;
	//t@CXg
	enumerateFiles( fileNameList, archiveDir.c_str(), verbose );
	//gɂ̂Ŕzɕϊ
	int fileNumber = static_cast< int >( fileNameList.size() );
	string* fileNames = new string[ fileNumber ];
	int j = 0;
	for ( It i = fileNameList.begin(); i != fileNameList.end(); ++i ){
		fileNames[ j ] = *i;
		++j;
	}

	//A[JCu
	bool succeeded = createArchive( 
		fileNames, 
		fileNumber, 
		archiveName.c_str(), 
		blockSize, 
		verbose, 
		threshold );
	if ( !succeeded ){ //s͂ȂB񂾂낤B
		cerr << "creating failed. delete output file manually." << endl;
#ifndef NDEBUG //ĂƃfoO̎Ȃ
	while( true ){;} //visual studios鎞ɃR\[ǂ݂̂ŁB
#endif
		return 1;
	}

#ifndef NDEBUG //ĂƃfoO̎Ȃ
	while( true ){;} //visual studios鎞ɃR\[ǂ݂̂ŁB
#endif
	return 0;
}

//------------------------֐----------------------------

void enumerateFiles( 
list< string >& fileNameList, 
const string& directoryName,
bool verbose ){
	HANDLE iterator; //Ce[^݂Ȃ̂Ȃ̂iteratorƖtĂ݂B
	WIN32_FIND_DATAA fileData; //Ƀt@CB
	//ŏ̃t@C擾
	string searchPath = directoryName;
	searchPath += "\\*.*"; //\͓ȕȂ̂œd˂BƂ傤ǈB

	//t@C
	iterator = FindFirstFileA( searchPath.c_str(), &fileData );
	if ( iterator == INVALID_HANDLE_VALUE ){
		//sB
		return;
	}
	while ( true ){ //Ƃ肠ȂB[v̌Ŕ
		if ( !( fileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ){
			//t@Cɂ̓fBNg݂ɂĂKv
			string filename = directoryName;
			filename += '\\';
			filename += fileData.cFileName; 
			if ( verbose ){
				cout << "\tFile : " << filename << endl; //\Ă낤BfoOɂȂ邵B
			}
			fileNameList.push_back( filename ); //Xgɒǉ
		}
		if ( !FindNextFileA( iterator, &fileData ) ){ //ցBȂΔBiteratorύXꂻɂȂAHANDLE^̓|C^Ȃ̂ŁAővB
			break;
		}
	}
	//fBNg
	iterator = FindFirstFileA( searchPath.c_str(), &fileData );
	if ( iterator == INVALID_HANDLE_VALUE ){
		//sB
		return;
	}
	while ( true ){ //Ƃ肠ȂB[v̌Ŕ
		string name = fileData.cFileName;
		//Ƃ.Ƃ..ƂԂ̂ŁA͏OBłȂƖ[vĂ܂B
		if ( name == "." || name == ".." ){
			; //Ȃ
		}else if ( fileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ){ //fBNgłB
			//fBNgpĂB
			string newDirectoryName = directoryName;
			newDirectoryName += '\\';
			newDirectoryName += name;
			if ( verbose ){
				cout << "Directory : " << newDirectoryName << endl;
			}
			enumerateFiles( fileNameList, newDirectoryName.c_str(), verbose ); //ċAĂяo
		}
		if ( !FindNextFileA( iterator, &fileData ) ){ //ցBȂΔBiteratorύXꂻɂȂAHANDLE^̓|C^Ȃ̂ŁAővB
			break;
		}
	}
}

bool createArchive( 
const string* fileNames, 
int fileNumber, 
const char* archiveName, 
int blockSize, 
bool verbose,
double threshold ){
	//ݐJ
	ofstream out( archiveName, ofstream::binary );
	if ( !out ){
		cerr << "can't create output file." << endl;
		return false;
	}
	//t@CTCYzm
	int* originalSizes = new int[ fileNumber ];
	int* outputSizes = new int[ fileNumber ];
	int* inPlaceDecompressionBufferSizes = new int[ fileNumber ];

	//XgfileNamesĊJĂ͓ǂݏoăRs[
	for ( int i = 0; i < fileNumber; ++i ){
		setlocale( LC_ALL, "" ); //ꂪȂƓ{t@C󂯕tȂ
		ifstream in( fileNames[ i ].c_str(), ifstream::binary );
		if ( !in ){
			cerr << "can't open file : " << fileNames[ i ] << endl;
			return false;
		}
		in.seekg( 0, ifstream::end );
		streamsize sizeBig = in.tellg();
		if ( sizeBig >= 0x7fffffff ){
			cerr << "can't handle files larger than 2GB!" << endl;
			delete[] outputSizes;
			outputSizes = 0;
			delete[] originalSizes;
			originalSizes = 0;
			out.close();
			out.open( archiveName ); //JȂŒg
			return false;
		}
		in.seekg( 0, ifstream::beg );
		originalSizes[ i ] = static_cast< int >( sizeBig );
		bool compressed;
		compress( &outputSizes[ i ], &inPlaceDecompressionBufferSizes[ i ], &compressed, &out, &in, threshold );
		if ( verbose ){
			double ratio = ( sizeBig == 0 ) ? 100.0 : outputSizes[ i ] * 100.0 / sizeBig;
			cout << fileNames[ i ] << " ) : " << sizeBig << " -> " << outputSizes[ i ] << " ( " << ratio << "% )" << endl;
		}
		//ubNTCY܂Ƀ_~[
		int mod = outputSizes[ i ] % blockSize;
		int padding = ( mod > 0 ) ? ( blockSize - mod ) : 0;
		for ( int j = 0; j < padding; ++j ){
			out.put( '\0' );
		}
	}
	if ( verbose ){
		cout << "<Table>" << endl;
		cout << "FileNumber : " << fileNumber << endl;
		cout << "BlockSize : " << blockSize << endl;
	}
	//t@C̖̈ʒuL^
	streamsize dataEnd = out.tellp(); //tellggeẗʒuŁAtellppuẗʒu
	//܂t@C̐ł낤
	out.write( reinterpret_cast< char* >( &fileNumber ), 4 );
	//\邽߂ɃTCYItZbgɒȂA
	//ꏊATCYAO̕AOi[ĂB
	unsigned pos = 0; //ubNPʂ̈ʒu
	for ( int i = 0; i < fileNumber; ++i ){
		write( &out, pos );
		write( &out, outputSizes[ i ] );
		write( &out, originalSizes[ i ] );
		write( &out, inPlaceDecompressionBufferSizes[ i ] );
		string name = fileNames[ i ].c_str();
		int nameLength = static_cast< int >( name.size() );
		write( &out, nameLength );
		out.write( name.c_str(), nameLength );
		if ( verbose ){
			cout << pos << '\t' << outputSizes[ i ] << '\t' << originalSizes[ i ] << '\t' << inPlaceDecompressionBufferSizes[ i ] << '\t' << nameLength << '\t' << name << endl; //foOpɕ\Ă낤
		}
		pos += ( outputSizes[ i ] + blockSize - 1 ) / blockSize;
	}
	//Ōɏނ̂ubNTCY
	write( &out, blockSize );
	//\̊JnʒułB
	assert( dataEnd % blockSize == 0 );
	unsigned dataEndInBlock = static_cast< unsigned >( dataEnd / blockSize );
	write( &out, dataEndInBlock );
	//n
	delete[] outputSizes;
	outputSizes = 0;
	delete[] originalSizes;
	originalSizes = 0;
	delete[] inPlaceDecompressionBufferSizes;
	inPlaceDecompressionBufferSizes = 0;

	return true;
}
