#include "XFile/Document.h"
#include <fstream>
#include <iostream>
#include <string>
#include <vector>
#include "conversion.h"
#include "GameLib/GameLib.h"
using namespace std;
using namespace GameLib;
using namespace GameLib::PseudoXml;

bool convert( string* dst, const char* src, int size );

int main( int argc, char** argv ){
	bool verbose = false;
	bool help = false;
	vector< string > inFileNames;

	//R}hC
	for ( int i = 1; i < argc; ++i ){
		if ( argv[ i ][ 0 ] == '-' ){ //-͂܂΂Ȃɂ̃IvV
			char c = argv[ i ][ 1 ];
			if ( c == 'v' ){ //`ヂ[h
				verbose = true;
			}else if ( c == 'h' ){ //wv
				help = true;
			}
		}else{
			inFileNames.push_back( argv[ i ] );
		}
	}
	//t@C˂
	if ( inFileNames.size() == 0 ){
		help = true;
	}
	//wv\ďI
	if ( help ){
		std::cout << "Usage: XFileConverter.exe [ -v ][ -h ] inputFiles..." << endl;
		std::cout << "<Options>" << endl;
		std::cout << "\t-v             : verbose mode." << endl;
		std::cout << "\t-h             : display this help." << endl;
#ifndef NDEBUG //ĂƃfoO̎Ȃ
	while( true ){;} //visual studios鎞ɃR\[ǂ݂̂ŁB
#endif
		return 1;
	}
	//n߂[B
	for ( unsigned i = 0; i < inFileNames.size(); ++i ){
		setlocale( LC_ALL, "" ); //ꂪȂƓ{t@C󂯕tȂ
		ifstream in( inFileNames[ i ].c_str(), ifstream::binary );
		in.seekg( 0, ifstream::end );
		int size = static_cast< int >( in.tellg() );
		in.seekg( 0, ifstream::beg );
		char* src = NEW char[ size + 1 ];
		in.read( src, size );
		src[ size ] = '\0'; //NULLI[
		string dst;
		if ( !convert( &dst, src, size ) ){
			std::cout << "Conversion Failed : " << inFileNames[ i ] << endl;
		}else{
			string outName = inFileNames[ i ] + ".txt";
			setlocale( LC_ALL, "" ); //ꂪȂƓ{t@C󂯕tȂ
			ofstream out( outName.c_str(), ofstream::binary );
			out.write( dst.c_str(), static_cast< streamsize >( dst.size() ) );
			if ( out ){
				std::cout << "Conversion Succeeded : " << inFileNames[ i ] << endl;
			}else{
				std::cout << "Output Failed : " << inFileNames[ i ] << endl;
			}
		}
	}
#ifndef NDEBUG //ĂƃfoO̎Ȃ
	while( true ){;} //visual studios鎞ɃR\[ǂ݂̂ŁB
#endif
	return 0;
}

#include <ctime>
bool convert( string* dst, const char* src, int size ){
	//Xt@Cf[^\z
	XFile::Document xFile( src, size );
	if ( !xFile.isValid() ){
		return false;
	}
	string xml;
	xFile.convertToString( &xml );
	//jZxmlƂēǂݍ
	Document srcDoc = Document::create( xml.c_str(), static_cast< int >( xml.size() ) );
	Document dstDoc = convert( srcDoc );
	
	dstDoc.convertToString( dst );
	return true;
}

#include "GameLib/Framework.h"
namespace GameLib{
	void Framework::configure( Configuration* ){}
	void Framework::update(){}
}


